/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2015.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

(function(){
dojo.provide("com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget");

dojo.require("dojo.i18n");
dojo.require("dijit.MenuItem");
dojo.require("dijit.form.Button");

dojo.require("jazz.ui.Toolbar");
dojo.require("jazz.ui.toolbar.Button");
dojo.require("jazz.ui.toolbar.Separator");
dojo.require("jazz.ui.Menu");
dojo.require("jazz.util.html");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.toolbar.TwoStateButton");
dojo.require("jazz.ui.menu.NodeMenuItem");

dojo.require("com.ibm.rdm.web.artifact.ArtifactWidgetInterface");
dojo.require("com.ibm.rdm.web.attributes.OverviewSection");
dojo.require("com.ibm.rdm.web.commenting.CommentingWidget");
dojo.require("com.ibm.rdm.web.common.ArtifactIcons");
dojo.require("com.ibm.rdm.web.common.DateTimeHelper");
dojo.require("com.ibm.rdm.web.common.Menu");
dojo.require("com.ibm.rdm.web.common.MessageForm");
dojo.require("com.ibm.rdm.web.common.MessageHandler");
dojo.require("com.ibm.rdm.web.common.PermalinkDialog");
dojo.require("com.ibm.rdm.web.common.ProjectCache");
dojo.require("com.ibm.rdm.web.common.PublicTagsParser");
dojo.require("com.ibm.rdm.web.common.ResourceLinksHandler");
dojo.require("com.ibm.rdm.web.common.StatusDisplay");
dojo.require("com.ibm.rdm.web.history.HistoryViewer");
dojo.require("com.ibm.rdm.web.history.RestoreVersionAction");
dojo.require("com.ibm.rdm.web.history.RevisionsCache");
dojo.require("com.ibm.rdm.web.links.LinksListWidget");
dojo.require("com.ibm.rdm.web.locks.LockManager");
dojo.require("com.ibm.rdm.web.model.resources.ResourceManager");
dojo.require("com.ibm.rdm.web.model.types.RRMTypes");
dojo.require("com.ibm.rdm.web.model.types.TypesManager");
dojo.require("com.ibm.rdm.web.notifications.ChangeNotifier");
dojo.require("com.ibm.rdm.web.notifications.EventTopics");
dojo.require("com.ibm.rdm.web.picker.ArtifactPickerForm");
dojo.require("com.ibm.rdm.web.picker.CopyFolderPicker");
dojo.require("com.ibm.rdm.web.picker.MoveFolderPicker");
dojo.require("com.ibm.rdm.web.preferences.UserPreferenceNames");
dojo.require("com.ibm.rdm.web.preferences.UserPreferencesClient");
dojo.require("com.ibm.rdm.web.query.ViewServiceClient");
dojo.require("com.ibm.rdm.web.review.ArtifactInReviewViewer");
dojo.require("com.ibm.rdm.web.review.ReviewCache");
dojo.require("com.ibm.rdm.web.review.reviewTypes");
dojo.require("com.ibm.rdm.web.review.reviewutils");
dojo.require("com.ibm.rdm.web.server.XhrUtils");
dojo.require("com.ibm.rdm.web.server.cache.ProcessOperationsCache");
dojo.require("com.ibm.rdm.web.server.client.RDMClient");
dojo.require("com.ibm.rdm.web.server.client.utils.DashboardUtil");
dojo.require("com.ibm.rdm.web.server.client.utils.ResourceUtil");
dojo.require("com.ibm.rdm.web.server.client.utils.UserCache");
dojo.require("com.ibm.rdm.web.sidebar.SidebarExtensionsLoader");
dojo.require("com.ibm.rdm.web.snapshots.ModuleSnapshotServer");
dojo.require("com.ibm.rdm.web.suspicion.SuspectLinksUtil");
dojo.require("com.ibm.rdm.web.suspicion.SuspicionProfilePicker");
dojo.require("com.ibm.rdm.web.suspicion.model.ArtifactSuspicionModel");
dojo.require("com.ibm.rdm.web.tags.TagUtil");
dojo.require("com.ibm.rdm.web.util.bidiutils"); //bidi
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.util.queryutils");
dojo.require("com.ibm.rdm.web.viewer.CollectionsMenu");
dojo.require("com.ibm.rdm.web.viewer.ExportForm");
dojo.require("com.ibm.rdm.web.viewer.ModulesMenu");
dojo.require("com.ibm.rdm.web.viewer.NewArtifactTemplateForm");
dojo.require("com.ibm.rdm.web.viewer.RecentlyViewedSection");
dojo.require("com.ibm.rdm.web.viewer.viewerutils");
dojo.require("com.ibm.rdm.web.extensions.APIEventTopics");


dojo.requireLocalization("com.ibm.rdm.web.common", "common");
dojo.requireLocalization("com.ibm.rdm.web.artifact", "AbstractResourceArtifactWidget");
dojo.requireLocalization("com.ibm.rdm.web.suspicion", "SuspicionProfilePicker");


var TypesManager = com.ibm.rdm.web.model.types.TypesManager;
var ProcessOperationsCache = com.ibm.rdm.web.server.cache.ProcessOperationsCache;
var BidiUtils = com.ibm.rdm.web.util.bidiutils;  //bidi
var DashboardUtil = com.ibm.rdm.web.server.client.utils.DashboardUtil;
var DomUtils = com.ibm.rdm.web.util.domutils;
var LockManager = com.ibm.rdm.web.locks.LockManager;
var RecentlyViewedSection = com.ibm.rdm.web.viewer.RecentlyViewedSection;
var StatusDisplay = com.ibm.rdm.web.common.StatusDisplay;
var XhrUtils = com.ibm.rdm.web.server.XhrUtils;
var DateTimeHelper = com.ibm.rdm.web.common.DateTimeHelper;
var ReviewTypes = com.ibm.rdm.web.review.reviewTypes;
var UserPreferencesClient = com.ibm.rdm.web.preferences.UserPreferencesClient;
var UserPreferenceNames = com.ibm.rdm.web.preferences.UserPreferenceNames;
var APIEventTopics = com.ibm.rdm.web.extensions.APIEventTopics;

var HIDE_ON_SMALL_CLASS = 'hide-on-small';
var HIDE_ON_LARGE_CLASS = 'sbl-hide-on-large';


dojo.declare(
	"com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget",
		[com.ibm.rdm.web.artifact.ArtifactWidgetInterface],
{
	///////////////////////////////////////////////////////////////////////////////////
	// PUBLIC FIELDS
	///////////////////////////////////////////////////////////////////////////////////

	resource: null,
	containerNode: null,
	viewType: null,
	editMode: null,
	showMoreActions: true,

	///////////////////////////////////////////////////////////////////////////////////
	// PRIVATE FIELDS
	///////////////////////////////////////////////////////////////////////////////////

	_isDirty: false,
	_actionsToolbar: null,
	_refreshInProgress: false,
	_saveInProgress: false,
	_editorDirtiedWhileSaving: false,
	_underEdit: false,
	_listeners: [],
	_projectOperations: null,
	_editor: null,
	_artifactSuspicionModel: null,
	_abstractMessages: null,
	_dashboardToolbarWidgetMessages: null,
	_suspicionProfilePickerMessages: null,
	_commonMessages: null,

	//Sidebar hooks
	_overviewSidebar: null,
	_commentsSidebar: null,
	_linksSidebar: null,
	_moduleSidebar: null,

	//Lifecycle button hooks
	_saveDoneCancelStrip: null,
	editButton: null,
	saveButton: null,
	doneButton: null,
	cancelButton: null,

	//Button hooks
	_restoreVersionButton: null,
	_revisionDateLabel: null,
	_basePropertiesButton: null,
	_exportButton: null,

	//TitleNode bits
	_cshNode: null,
	_dirtyMarker: null,
	_artifactTitleElement: null,
	_nameEditor: null,
	_isEditingFrame: false,
	//Expected to be an optional function.
	updateLayoutTitle: null,
	updateLayoutClass: null,

	// Display size we have to fit in
	_latestWidth: 0,
	_latestHeight: 0,

	// Reference to the merge widget.  Non-null here indicates that there is an active merge widget
	// and so we are merging.
	_mergeWidget: null,

	//Navigate away handles
	_handleNavigateEvent: null,
	_handleBodyClickEvent: null,

	//Comment/Link
	selectCommentURI: null,
	selectLinkURI: null,
	selectArtifactInModule: null,

	_prettyLinkIcon: null,
	_breadcrumbsSpan: null,
	_lastBreadcrumbLinkButton: null,

	_showBaseProperties: null,

	// Review viewer refresh
	_reviewModelDeferred: null,

	_historyViewerLatestETag: null,

	///////////////////////////////////////////////////////////////////////////////////
	// dijit._widget API
	///////////////////////////////////////////////////////////////////////////////////

	constructor: function(){
		this.resource = null;
		this._isDirty = false;
		this._actionsToolbar = null;
		this._refreshInProgress = false;
		this._underEdit = false;
		this._listeners = [];
		this._overviewSidebar = null;
		this._commentsSidebar = null;
		this._linksSidebar = null;
		this._moduleSidebar = null;
		this._saveDoneCancelStrip = null;
		this._editButton = null;
		this._saveButton = null;
		this._doneButton = null;
		this._cancelButton = null;

		this._cshNode = null;
		this._dirtyMarker = null;
		this._artifactTitleElement = null;
		this._nameEditor = null;

		this._handleNavigateEvent = null;
		this._handleBodyClickEvent = null;
		this._showBaseProperties = false;
		this._resourceLocked = false;
	},

	postMixInProperties: function(){
		this._abstractMessages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.artifact", "AbstractResourceArtifactWidget");
		this._dashboardToolbarWidgetMessages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.project", "DashboardToolbarWidget");
		this._suspicionProfilePickerMessages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.suspicion", "SuspicionProfilePicker");
		this._commonMessages =
			dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
		this.inherited("postMixInProperties", arguments);
	},

	uninitialize: function() {
		this.inherited("uninitialize", arguments);
		if (this._listeners) {
			dojo.forEach(this._listeners, function(listener){
				com.ibm.rdm.web.notifications.ChangeNotifier.removeListener(listener);
			});
		}
		this._unregisterNavigateHandlers();
	},

	///////////////////////////////////////////////////////////////////////////////////
	// com.ibm.rdm.web.artifact.ArtifactWidgetInterface API
	// 		The following methods are implementing those defined as part of
	//		ArtifactWidgetInterface, which this is based on.
	///////////////////////////////////////////////////////////////////////////////////
	//Summary:
	//This MUST be implemented by widgets implementing the AbstractResourceArtifactWidget
	//This MUST return a deferred that is called back with the resource object when
	//startup has been completed
	startup: function(){
		this.addListeners();

		DashboardUtil.updateBannerProjectDashboardLink(this.projectURI);

		//Show timeline widget
		if (this.isInHistoryMode()){
			// load the revisions so that filtering of comments and links based on
			// the artifact version can occur when in history mode
			this._revisionsRequest = com.ibm.rdm.web.history.RevisionsCache.getRevisions(this.resourceURI);
			this._revisionsRequest.addCallback(this, function(revisions){
				this._revisions = revisions.doc._revisionInfosMap;
				this.contentWrapper = new com.ibm.rdm.web.history.HistoryViewer({
					resourceURI: this.resourceURI,
					projectURI: this.projectURI,
					revision: this.revision,
					baselineURI: this.baselineURI,
					originalContent: this._contentPane,
					updateRevision: dojo.hitch(this, this._updateRevisionInHistory),
					replaceDom: dojo.hitch(this, this._replaceMainContent),
					isModule: this.isModule,
					isModuleArtifact: this.isModuleArtifact,
					owningModule: this.owningModule,
					setModuleDimensions: dojo.hitch(this, this.setDimensions),
					getHeightOffset: function() {
						return (this.domNode) ? this.domNode.clientHeight : 0;
					}
				});
				this._toDestroy.push(this.contentWrapper);
				dojo.place(this.contentWrapper.domNode, this.containerNode, "first");
				this.contentWrapper.startup();
				this.setDimensions();
				if (this.updateLayoutTitle && dojo.isFunction(this.updateLayoutTitle)){
					this.updateLayoutTitle();
				}
				return revisions;
			});
		}
		//Show review header
		else if (this.isInReviewMode()){
			this.contentWrapper = new com.ibm.rdm.web.review.ArtifactInReviewViewer({
				resourceURI: this.resourceURI,
				revision: this.revision,
				reviewId: this.reviewId,
				getHeightOffset: function() {
					return (this.domNode) ? this.domNode.clientHeight : 0;
				}
			});
			this._toDestroy.push(this.contentWrapper);
			dojo.place(this.contentWrapper.domNode, this.containerNode, "first");
			this.contentWrapper.startup();
		}

		if (!this.isInHistoryMode() && !this.isInReviewMode()) {
			this._artifactSuspicionModel = new com.ibm.rdm.web.suspicion.model.ArtifactSuspicionModel({
				projectURI: this.projectURI,
				resourceURI: this.resourceURI
			});
			this._artifactSuspicionModel.load();
			this._toDestroy.push(this._artifactSuspicionModel);
		}

		if (this.editMode) {
			this._launchInEditModeIfAppropriate();
		}

		this.inherited("startup", arguments);

		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: APIEventTopics.ARTIFACT_OPENED,
			resource: this.resource,
			resourceWidget: this
		});

	},

	getTitleNode: function(){
		this._titleNode = dojo.create("div", {"class": "resource-title-cell"});
		dojo.create("span", {"class": "resource-id", innerHTML: this.getArtifactIdentifier() + ":"}, this._titleNode);
		this._artifactTitleElement = dojo.create("span", {"class": "resource-title"}, this._titleNode);
		this._dateStampNode = dojo.create("span", {"class": "revision-stamp", innerHTML: ""}, this._titleNode);
		if (this.isInHistoryMode() && this.revision) {
			this._revisionsRequest.addCallback(dojo.hitch(this, function() {
				var revisionInfo = this._revisions[this.revision];
				if (revisionInfo) {
					dojo.attr(this._dateStampNode, "innerHTML", "(" + revisionInfo.revisionDateLabel + ")");
				}
			}));
		}

		this._updateDisplayTitle();

		// Only allow the user to edit the title when allowed
		this.getModifyArtifactPermissions().addCallback(this, function(modifyArtifactPermissions){
			if (modifyArtifactPermissions.isModifyTitleAllowed()) {
				this.connect(this._artifactTitleElement, "onclick", dojo.hitch(this, this._resourceTitleEdit));
				this.connect(this._artifactTitleElement, "onfocus", dojo.hitch(this, this._resourceTitleEdit));
			}
			return modifyArtifactPermissions;
		});

		this._nameEditor = dojo.create("input", {}, this._titleNode);
		this.connect(this._nameEditor, "onblur", dojo.hitch(this, this._blurNameInput));
		// 48819. In addition to "onchange" we need other events to fire _onChangeNameInput for storyboards,
		//    because javascript events are not valid within the plugin area, and frame contest swithces will actually happen before the onchange event when a title is under edit..
		this.connect(this._nameEditor, "onchange", dojo.hitch(this, this._onChangeNameInput, "onchange"));
		this.connect(this._nameEditor, "onkeyup", dojo.hitch(this, this._onChangeNameInput, "onkeyup"));
		this.connect(this._nameEditor, "onkeypress", this._onKeyPress);
		this.connect(this._nameEditor, "onmouseleave", dojo.hitch(this, this._onChangeNameInput, "onmouseleave"));

		//bidi
		BidiUtils.applyTextDirSetting(this._artifactTitleElement, this._artifactTitleElement.innerHTML);
		if (BidiUtils.getTextDir() === BidiUtils.TEXT_DIR_CONTEXTUAL){
			this.connect(this._nameEditor, "onkeyup", dojo.hitch(this, this._onKeyUpNameInput));
			this.connect(this._nameEditor, "onpaste", dojo.hitch(this, this._onKeyUpNameInput));
		}
		this._dirtyMarker = dojo.create("span", {"class": "dirtyMarker", innerHTML: "*"}, this._titleNode);

		//Setup help node bits
		this._cshNode = dojo.create("span", {"class": "contextSensitiveHelp"}, this._titleNode);

		var pageHoverHelp = new jazz.app.ua.PageHoverHelp({uaKey: this.getHelpContext()});
		this._toDestroy.push(pageHoverHelp);
		pageHoverHelp.placeAt(this._cshNode);

		return this._titleNode;
	},

	handleRefresh: function(/*boolean?*/refreshLockInfo) {
		if (!this._refreshInProgress) {
			if (this.isEdit()) {
					this._refreshInProgress = true;
					var deferred = com.ibm.rdm.web.model.resources.ResourceManager.checkIsLatestVersion(this.resource);
					deferred.addCallback(dojo.hitch(this, function(result) {
						if (!result.isLatest && this.isDirty()) {
							var customMerger = this.getMergeCtor && this.getMergeCtor();
							if (!customMerger) {
								// no custom merge editor, so default to simple dialog
								this.displayMergeConflict(result.resource, false);
							} else {
								this._openMergeConfirmDialog(customMerger, result);
							}
							return;
						} else if (result.isLatest) {
							this._refreshInProgress = false;
							return;
						} else {
							this._refreshInProgress = false;
							this._refreshResource(refreshLockInfo);
						}
						return;
					}));
				}
			else {
				this._refreshResource(refreshLockInfo);
			}

			//Reload the artifact suspicion model
			if (this._artifactSuspicionModel) {
				this._artifactSuspicionModel.load();
			}
		}
	},

	_updateLockControlsCallback: function(lockInfo) {
		this.lockInfo = lockInfo;
		// cannot rely on the truthiness of lockInfo as it
		// might be undefined
		this._lockInfoDetermined = true;
		if (typeof this._manualLockPermission === "undefined") {
			ProcessOperationsCache.isManualLockAcquireAllowed(this.resource.getProcessAreaURI(), this.projectURI).addCallback(this, function(resp){
				// cache this here to avoid the whole chain of deferreds each time we
				// call setLockButtonDisplay
				this._manualLockPermission = resp;
				if (this._editButton) {
					// make sure we check this first, this will set a flag telling
					// us whether the user has permissions to edit.
					this._enableEditButtonIfAppropriate(this._editButton, lockInfo, this._deleteResourceButton).then(dojo.hitch(this, this._setLockButtonDisplay, lockInfo));
				} else {
					this._setLockButtonDisplay(lockInfo);
				}
			});
		} else {
			if (this._editButton) {
				this._enableEditButtonIfAppropriate(this._editButton, lockInfo, this._deleteResourceButton).then(dojo.hitch(this, this._setLockButtonDisplay, lockInfo));
			} else {
				this._setLockButtonDisplay(lockInfo);
			}
		}

	},

	_updateLockBoundControls: function(skipCache) {
		// summary:
		//		Gets the lock status for this resource from LockManager
		//		and updates controls bound to that status (at time of writing)
		//		the edit button and the lock button (can you move it ??).
		// skipCache:
		//		If true go to the server to get the lock info.




		return LockManager.getResourceLockStatus(this._getLockingURI(), this.getProjectURI(), skipCache).addBoth(this, function (lockInfo) {
			// check to see whether this user has break lock permission.
			if (typeof this.isReleaseLocksAllowed === "undefined") {
				var getModifyLocksPermissions = ProcessOperationsCache.isReleaseLocksAllowed(this.resource.getProcessAreaURI(), this.projectURI);

				getModifyLocksPermissions.addCallback(this, function(isReleaseLocksAllowed) {
					this.isReleaseLocksAllowed = isReleaseLocksAllowed;
					this._updateLockControlsCallback(lockInfo);
					return isReleaseLocksAllowed;
				});
			} else {
				 this._updateLockControlsCallback(lockInfo);
			}

		});
	},

	onCancel: function(/*Bool*/ force){
		this._closeMerger();
	},

	setDimensions: function(width, height) {
		// summary:
		//		Called from parent widget to set the size.
		if (width && height) {
			// keep the width and height - allows this to be called with no parameters to provoke
			// content to resize to fit.
			this._latestWidth = width;
			this._latestHeight = height;
		}
		this._sizeToLatestDimensions();
	},

	_sizeToLatestDimensions: function(){
		// summary:
		//		Called internally, to force the widget's size to the last known dimensions,
		//		as recorded in _latestWidth and _latestHeight;
		var width = this._latestWidth;
		var height = this._latestHeight;
		if (this.contentWrapper && dojo.isFunction(this.contentWrapper.setDimensions)){
			height = Math.max(height - this.contentWrapper.domNode.clientHeight, 0);
			this.contentWrapper.setDimensions(width, height);
		}

		if (this._contentPane && dojo.isFunction(this._contentPane.resize)){
			this._contentPane.resize({
				w: width,
				h: height
			});
		}
	},

	getLifecycleItems: function() {
		return this._getLifecycleItems(false);
	},
	
	_getLifecycleItems: function(noSave) {
		var buttonStrip = dojo.create("span");
		//There should be no edit/save/done/cancel even created if in history, formal review, or
		//The user does not have permissions
		if (!this.isInHistoryMode() && !this.isInReviewMode() && this.userCanEdit()){
			dojo.style(buttonStrip, "display", "inline-block");

			this._saveDoneCancelStrip = dojo.create("span",
					{style:
						{
							"display": "none"
						}
					}, buttonStrip);

			this._editButton = dojo.create("button", {
				innerHTML: this._abstractMessages.edit,
				"class": "editButton",
				"disabled": true
			});
			this.connect(this._editButton, "onclick", dojo.hitch(this, this.onEdit));
			// Enable the edit button only if conditions warrant.
			//this._enableEditButtonIfAppropriate(this._editButton);

			var saveButtonParent = this._saveDoneCancelStrip;
			if (noSave) {
				//If we don;t want the save button - create it, but don;t connect it.
				saveButtonParent = null;
			}
			this._saveButton = dojo.create("button", {
				"class": "saveButton",
				innerHTML:this._abstractMessages.save,
				"disabled": true
			}, saveButtonParent);
			this.connect(this._saveButton, "onclick", dojo.hitch(this, this.onSave));

			this._doneButton = dojo.create("button", {
				innerHTML:this._abstractMessages.done
			}, this._saveDoneCancelStrip);
			this.connect(this._doneButton, "onclick", dojo.hitch(this, this.onDone));

			this._cancelButton = dojo.create("button", {
				innerHTML: this._abstractMessages.cancel
			}, this._saveDoneCancelStrip);
			this.connect(this._cancelButton, "onclick", dojo.hitch(this, this.onCancelEdit));

			buttonStrip.appendChild(this._editButton);
			// WI: 73586.  Don't update the lock control if we are going straight into edit mode
			// as going into edit mode will acquire a lock (after checking status) anyway.
			if (!this.editMode) {
				this._updateLockBoundControls(true);
			}
		}
		return buttonStrip;
	},
	
	_createAndConnectOverviewSection: function(isForSelection) {
		// Summary:
		//		This creates and wires up an Overview section. This may be for the resource
		//		itself - or it may be for a selected artifact in a module.
		// isForSelection:
		//		true if this is for a selected artifact. False/null otherwise.
	
		var overviewSection = new com.ibm.rdm.web.attributes.OverviewSection({
			resourceURI: this.resourceURI,
			isModule: this.isModule,
			isModuleArtifact: this.isModuleArtifact,
			moduleURI: this.isModule && this.resourceURI,
			owningModule: this.owningModule,
			isForSelection: isForSelection,
			contentType: this._contentType,
			disableAttributeWidgets: !this.editMode,
			resource: this.resource,
			artifactSuspicionModel: this._artifactSuspicionModel,
			viewer: this
		});
		
		if (!isForSelection) {
			//Only wire up change methods for the module overview, not the artifact one
			this.connect(overviewSection, "onChange", function() {
				this.setDirty(true);
			});
			this.connect(overviewSection, "onSaveAttributes", dojo.hitch(this, function(){
				if (this.isDirty()) {
					this.onSave();
				}
			}));
			this.connect(overviewSection, "onDoneAttributes", dojo.hitch(this, function(){
				this.onDone();
			}));
			this.connect(overviewSection, "onCancelAttributes", dojo.hitch(this, function(){
				this.onCancelEdit();
			}));
			this.connect(overviewSection, "onDescriptionChanged", dojo.hitch(this, function(newDescription){
				// If we're in edit mode, do not actually do the rename on the server, just update the
				// model and viewer.  When the resource is saved, the changes will take place.
				this.resource.setDescription(newDescription);
				overviewSection.updateDescriptionField(newDescription);
				this.setDirty(true);
			}));
			this.connect(
				overviewSection, "onTeamOwnershipChanged",
				dojo.hitch(this, function(processAreaURI, projectOrTeamName){
					// If we're in edit mode, do not actually do the team ownership change on the
					// server, instead we just update the model and viewer.  When the resource is
					// saved, the changes will take place.
					this.resource.setProcessAreaURI(processAreaURI);
					overviewSection.updateTeamOwnershipField(processAreaURI, projectOrTeamName);
					this.setDirty(true);
				})
			);

			this.connect(
				overviewSection, "onAssetLocationChanged",
				dojo.hitch(this, function(folderURI){
					// If we're in edit mode, do not actually do the asset locations change on the
					// server, instead we just update the model and viewer.  When the resource is
					// saved, the changes will take place.
					this.resource.setAssetFolderURI(folderURI);
					overviewSection.updateAssetLocationField(folderURI);
					this.setDirty(true);
				})
			);
		}
			
		return overviewSection;
	},
	
	getSubViews: function() {
		//OverviewSection, commentingWidget, and linksListWidget are universal amongst non-review
		//artifacts. As such they are created here rather than in the individual widgets.
		var subViews = [];
		this._overviewSidebar = this._createAndConnectOverviewSection();

		var isModule = this.isModuleViewer();

		this._commentsSidebar = new com.ibm.rdm.web.commenting.CommentingWidget({
			viewer: this,
			resourceURI: this.resourceURI,
			baselineURI: this.baselineURI,
			resourceContentType: this._contentType,
			selectCommentURI: this.selectCommentURI,
			revisionDate: (this._successorRevision)?this._successorRevision.revisionDate:null,
			activateOnLoad: (this.selectCommentURI !== null),
			isModule: isModule
		});

		this._commentsSidebar.setResourceInfo({"projectURI": this.projectURI,
			"displayName": this.resource.getDisplayTitle(),
			"createdByUserUri": this.resource.getCreatedBy(),
			"lastModifiedByUserUri": this.resource.getLastModifiedBy()});

		this._linksSidebar = new com.ibm.rdm.web.links.LinksListWidget({
			viewer: this,
			projectURI: this.projectURI,
			baselineURI: this.baselineURI,
			resourceURI: this.resourceURI,
			reviewId: this.reviewId,
			isInModuleBaseline: this.isInModuleBaseline,
			boundArtifact: this.resource.getBoundArtifact(),
			selectLinkURI: this.selectLinkURI,
			revisionDate: (this._successorRevision)?this._successorRevision.revisionDate:null,
			activateOnLoad: (this.selectLinkURI !== null),
			artifactSuspicionModel: this._artifactSuspicionModel
		});

		subViews.push(this._overviewSidebar);
		subViews.push(this._commentsSidebar);
		subViews.push(this._linksSidebar);

		return subViews;
	},
	
	
	setSelection: function() {
		//Do nothing method for inheritance by sub classes.
	},
	
	refreshSelection: function() {
		//Do nothing method for inheritance by sub classes.
	},
	
	widgetActivated: function() {
		//Do nothing method for inheritance by sub classes.	
	},

	getCustomSidebarSections: function () {
		// should i have any custom sidebar sections ?
		return com.ibm.rdm.web.sidebar.SidebarExtensionsLoader.getArtifactSidebarExtensions(this.resource.artifactFormat);
	},

	getToolbarItems: function() {
		this._actionsToolbar = new jazz.ui.Toolbar();
		if(this.showMoreActions) {
			this.createMoreActionsMenu();
		}
		this._toDestroy.push(this._actionsToolbar);
	},
	
	createMoreActionsMenu: function() {
		var menu = this._moreActionsMenu = new jazz.ui.Menu({
			'class': 'more-actions-menu'
		});
		this._moreActionsButton = new jazz.ui.toolbar.MenuButton({
			injectCaret: false,
			imgClass: "more-actions-icon",
			title: this._commonMessages.moreActions,
			menuProvider: function() {
				return menu;
			}
		});
		this._toDestroy.push(this._moreActionsMenu, this._moreActionsButton);
	},

	getBreadcrumbs: function(isRefresh){
		var refreshBreadcrumbsWidget = dojo.hitch(this, function(){
			// Workaround for jazz Foundation defect 203149
			this._breadcrumbsWidget._ellipsis = null;

			this._breadcrumbsWidget.refresh();
			if (!this.isInReviewMode()){
				this._refreshPrettyLinkIcon();
			}
			if (dojo.isFunction(this.handleWindowResize)){
				this.handleWindowResize();
			}
		});

		if (this._breadcrumbsWidget && !isRefresh){
			refreshBreadcrumbsWidget();
			return this._breadcrumbsSpan;
		} else{
			var breadcrumbPath = [],
				breadcrumbInfo = [];
			if (!this._breadcrumbsWidget) {
				this._breadcrumbsWidget = new jazz.ui.Breadcrumbs({
						segments: []
					});
				this._toDestroy.push(this._breadcrumbsWidget);
			}

			if (!this._prettyLinkIcon) {
				var spanClass = (dojo.isIE ? "pretty-link-icon-IE" : "pretty-link-icon");
				this._prettyLinkIcon = dojo.create("span", { "class": spanClass });
			}
			if (!this._breadcrumbsSpan){
				this._breadcrumbsSpan = dojo.create("span");
				dojo.place(this._breadcrumbsWidget.domNode, this._breadcrumbsSpan, "only");
				dojo.place(this._prettyLinkIcon, this._breadcrumbsWidget.domNode, "after");
			}
			var createRootBreadcrumb = dojo.hitch(this, function(project){
				//append the project information
				var projectURI = null;
				if (this.baselineURI && !this.isInModuleBaseline){
					// Show the project in history
					projectURI = "#action=com.ibm.rdm.web.pages.showProjectHistory&projectURI=" + encodeURIComponent(this.projectURI) +
					"&baselineURI=" + encodeURIComponent(this.baselineURI);
				} else{
					//For live or module baselines, show the live project
					projectURI = "#action=com.ibm.rdm.web.pages.showProjectDashboard&projectURI=" + encodeURIComponent(this.projectURI);
				}

				breadcrumbPath.push({
					label: project.name,
					tooltip: project.name,
					href: projectURI
				});

				breadcrumbInfo.push({
					name: project.name,
					uri: this.projectURI
				});

			});
			var createFolderBreadcumb = dojo.hitch(this, function(project, resourceParentFolderURI, module){

				if (!this.isInModuleBaseline && resourceParentFolderURI) {
					//If not in a module baseline (ie live or in a project baseline)
					var folderPathDeferred = com.ibm.rdm.web.common.ProjectCache.getFolderPathToRoot(
						resourceParentFolderURI,
						this.projectURI,
						this.baselineURI,
						true
					);
					folderPathDeferred.addCallback(this, function(folderHierarchyMap){
						if (this.resource.isInModule()) {
							breadcrumbPath.push({
								label: module.getTitle(),
								tooltip: module.getTitle(),
								icon: dojo.moduleUrl("com.ibm.rdm.web", "common/images/resources/module-16.png").toString(),
								href: com.ibm.rdm.web.common.ResourceLinksHandler.getInternalResourcePresentationLink({uri:module.getResourceURI()})
							});

							breadcrumbInfo.push({
								name: module.getTitle(),
								uri: module.getResourceURI()
							});
						}
						var SELF = com.ibm.rdm.web.common.PublicTagsParser.SELF;
						var folderObj = folderHierarchyMap[resourceParentFolderURI][SELF];
						while (folderObj.title !== 'root') {
							breadcrumbPath.push({
								label: folderObj.title,
								tooltip: folderObj.title,
								href: this._createBreadcrumbLink(folderObj.resourceURI)
							});

							breadcrumbInfo.push({
								name: folderObj.title,
								uri: folderObj.resourceURI
							});

							folderObj = folderHierarchyMap[folderObj.parentURI][SELF];
						}
						createRootBreadcrumb(project);
						breadcrumbInfo = breadcrumbInfo.reverse();
						this.onBreadcrumbLoaded(breadcrumbInfo);

						breadcrumbPath = breadcrumbPath.reverse();
						this._breadcrumbsWidget.segments = breadcrumbPath;
						refreshBreadcrumbsWidget();
						return folderHierarchyMap;
					});
					return folderPathDeferred;
				} else {
					//The Breadcrumbs for a module baseline
					var deferred = new dojo.Deferred();

					var moduleURI = this.resource.getResourceURI();
					if (this.isModuleArtifact) {
						moduleURI = this.owningModule;
					}

					com.ibm.rdm.web.snapshots.ModuleSnapshotServer.getSnapshotByJtsURI(moduleURI, this.baselineURI).addCallback(dojo.hitch(this, function(snapshot) {
						if (snapshot) {
							if (snapshot.title) {
								this.baselineTitle = snapshot.title +" ("+snapshot.uniqueId+")";
							} else {
								this.baselineTitle = snapshot.uniqueId;
							}
						} else {
							this.baselineTitle = null;
						}

						//The baseline name etc
						if (this.baselineTitle) {
							breadcrumbPath.push({
										label: this.baselineTitle,
										icon: dojo.moduleUrl("com.ibm.rdm.web", "history/images/baseline_obj.gif").toString()
									});
						}

						//The live module itself
						if(module) {
							breadcrumbPath.push({
										label: module.getTitle(),
										icon: dojo.moduleUrl("com.ibm.rdm.web", "common/images/resources/module-16.png").toString(),
										href: com.ibm.rdm.web.common.ResourceLinksHandler.getInternalResourcePresentationLink({uri:module.getResourceURI()})
									});
						}

						createRootBreadcrumb(project);

						breadcrumbPath = breadcrumbPath.reverse();
						this._breadcrumbsWidget.segments = breadcrumbPath;
						refreshBreadcrumbsWidget();
						deferred.callback();


					}));

					return deferred;
				}
			});
			var projectDeferred = com.ibm.rdm.web.common.ProjectCache.getProject(this.projectURI).addCallback(this,
				function(project) {
					var resourceParentFolderURI, queryDeferred;
					if (this.isInModuleBaseline) {
						//get module title only for module baseline
						queryDeferred = com.ibm.rdm.web.query.ViewServiceClient.getViewContents({
							artifactUris: [this.resource.getResourceURI()],
							requestedAttributeUris: [com.ibm.rdm.web.model.types.RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Title, "http://com.ibm.rdm/navigation#parent"],
							projectURI: this.projectURI,
							baselineURI: this.baselineURI
						});
						queryDeferred.addCallback(this, function (response) {
							var result = com.ibm.rdm.web.query.ViewServiceClient.parseViewContentsResponse(response, this.projectURI, {}, false);
							var resources = result.resources;
							var module = null;
							dojo.forEach(resources, function(item) {
									module = item;
							}, this);
							createFolderBreadcumb(project, null, module);
							return response;
						});
					} else if (this.resource.isInModule()) {
						//get module title and parent folder of core resource
						queryDeferred = com.ibm.rdm.web.query.ViewServiceClient.getViewContents({
							artifactUris: [this.resource.getBoundArtifact(), this.resource.getModuleURI()],
							requestedAttributeUris: [com.ibm.rdm.web.model.types.RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Title, "http://com.ibm.rdm/navigation#parent"],
							projectURI: this.projectURI,
							baselineURI: this.baselineURI
						});
						queryDeferred.addCallback(this, function (response) {
							var result = com.ibm.rdm.web.query.ViewServiceClient.parseViewContentsResponse(response, this.projectURI, {}, false);
							var resources = result.resources;
							var module = null;
							dojo.forEach(resources, function(item) {
								if (item.getResourceURI() === this.resource.getBoundArtifact()) {
									resourceParentFolderURI = item.getParentFolder();
								}
								else {
									module = item;
								}
							}, this);
							createFolderBreadcumb(project, resourceParentFolderURI, module);
							return response;
						});
					}
					else {
						resourceParentFolderURI = dojo.isFunction(this.resource.getParentResourceURI)?this.resource.getParentResourceURI():null;
						createFolderBreadcumb(project, resourceParentFolderURI);
					}
					return project;
			});
		}
		return this._breadcrumbsSpan;
	},

	getTitle: function(){
		return this.getArtifactIdentifier() + ": " + this.getArtifactTitle();
	},

	//Override the default behavior in ArtifactWidgetInterface
	getHeaderImage: function(){
		var iconDiv = dojo.create("div");
		var iconImage = this.headerIconImgNode;
		dojo.place(iconImage, iconDiv);

		//Review mode has an overlay
		if (this.isInReviewMode()){
			dojo.addClass(iconDiv, "overlay-div");
			dojo.addClass(iconImage, "overlaid-resource-type-image");
			dojo.create("img", {
				src: this._blankGif,
				"class": "overlay-image in-review-overlay"
				},
				iconDiv
			);
		}
		//History also has an overlay
		else if (this.isInHistoryMode()){
			dojo.addClass(iconDiv, "overlay-div");
			dojo.addClass(iconImage, "overlaid-resource-type-image");
			if (this.baselineURI){
				dojo.create("img", {
					src: this._blankGif,
					"class": "overlay-image in-baseline-overlay"
					},
					iconDiv
				);
			} else{
				dojo.create("img", {
					src: this._blankGif,
					"class": "overlay-image in-history-overlay"
					},
					iconDiv
				);
			}
		}
		return iconDiv;
	},

	getOverviewSidebar: function() {
		return this._overviewSidebar;
	},

	getCommentsSidebar: function() {
		return this._commentsSidebar;
	},

	getShowBaseProperties: function() {
		return this._showBaseProperties;
	},

	//Updates _showBasePropertiesButton and the property _showBaseProperties
	setShowBaseProperties: function (strPressed) {
		//String will not update class of button correctly, must be a boolean
		var boolPressed = (strPressed === "true");
		if(this._basePropertiesButton && (this._showBaseProperties !== boolPressed)){
			this._basePropertiesButton.set("pressed", boolPressed);
			this._handleBasePropertiesClicked();
		}
	},

	viewHasBeenRestored: function(args){
		if (this.contentWrapper && dojo.isFunction(this.contentWrapper.viewHasBeenRestored)){
			this.contentWrapper.viewHasBeenRestored(args);
		}

		if (this.selectCommentURI && this._commentsSidebar && this._commentsSidebar.setSelectedCommentPane) {
			// highlight a comment if the navigation link indicated a comment.
			this._commentsSidebar.setSelectedCommentPane(this.selectCommentURI);
			this.selectCommentURI = null;
		}

		if (this._linksSidebar) {
			if (this._artifactSuspicionModel || this.selectLinkURI) {
				this._linksSidebar.selectLinkURI = this.selectLinkURI;
				this._linksSidebar.handleRefresh();
				this.selectLinkURI = null;
			}
		}

		if (this._overviewSidebar && this._artifactSuspicionModel) {
			this._overviewSidebar.reloadSuspicion();
		}

		com.ibm.rdm.web.viewer.RecentlyViewedSection.addNewResource(
				this.resourceURI, this.reviewId, this.revision, this.resource);
		com.ibm.rdm.web.viewer.CollectionsMenu.addNewResource(
				this.resourceURI, this.getContentType(), this.revision, this.resource);

		this._updateLockBoundControls(true);

		if (this.refreshOnRestore && dojo.isFunction(this.refreshOnRestore)){
			this.refreshOnRestore();
		}

		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: APIEventTopics.ARTIFACT_OPENED,
			resource: this.resource,
			resourceWidget: this
		});
	},

	setCommentToSelect: function(commentURI){
		this.selectCommentURI = commentURI;
	},

	setLinkToSelect: function(linkURI){
		this.selectLinkURI = linkURI;
	},

	setArtifactInModule: function(artifactInModuleURI, waitForGridToLoad){
		this.selectArtifactInModule = artifactInModuleURI;
	},

	///////////////////////////////////////////////////////////////////////////////////
	// Public com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget API
	//		The following methods should be implemented or extended by
	//		classes that are building on top of AbstractResourceArtifactWidget
	//		(eg WrappedArtifactWidget, TextArtifactWidget)
	///////////////////////////////////////////////////////////////////////////////////

	loadResource: function(revision/*Revision to load, if null 'head' is loaded*/){
		// summary:
		//		This MUST be overridden by widgets implementing the AbstractResourceArtifactWidget.
		//		This MUST return a deferred that is called back with the resource object.
		throw new Error('Unimplemented API: com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.loadResource');
	},

	onResourceLoaded: function(){
		// summary:
		//		This MUST be called when the deferred returns with the resource object.

		// If we're currently displaying a message, we should hide it.
		StatusDisplay.hideStatusMessage();

		com.ibm.rdm.web.viewer.RecentlyViewedSection.addNewResource(
				this.resourceURI, this.reviewId, this.revision, this.resource);
		com.ibm.rdm.web.viewer.CollectionsMenu.addNewResource(
				this.resourceURI, this.getContentType(), this.revision, this.resource);
		com.ibm.rdm.web.viewer.ModulesMenu.addNewResource(
				this.resourceURI, this.getContentType(), this.revision, this.resource);
	},

	viewResourceMode: function(onCancel, wasDirty){
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to do artifact-specific view render behavior.
		throw new Error('Unimplemented API: com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewResourceMode');
	},

	getElementDisplayName: function(elementId){
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to give IDs back to commenting widget.
		throw new Error('Unimplemented API: com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.getElementDisplayName');
	},

	getMergeCtor: function(){
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to give a widget name back for merge purposes.
		return null;
	},

	hasArtifactBeenLoaded: function(){
		return false;
	},

	userCanEdit: function(){
		return this._projectOperations.item(com.ibm.rdm.web.common.ProjectCache.MODIFY_RESOURCE);
	},

	editResourceMode: function() {
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to do artifact-specific edit behavior.
	},

	saveResource: function() {
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		this must return a deferred that is called back with the resource object.
	},

	getHelpContext: function() {
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to pass proper help context.
		return com.ibm.rdm.web.help.context.artifact;
	},

	getResourceObject: function(/*Boolean?*/ update) {
		// summary:
		//		This should be overridden by widgets implementing the AbstractResourceArtifactWidget
		//		to handle the appropriate update behavior.
		return this.resource;
	},

	getProcessAreaURI: function() {
		// summary:
		//		Helper method to return resource's processAreaURI for permissions checking.
		return this.getResourceObject().getProcessAreaURI();
	},

	getArtifactTypeURI: function() {
		// summary:
		//		Helper method to return resource's artifactTypeURI for permissions checking.
		return this.resource.getType();
	},

	addListeners: function(){
		// summary:
		//		This may be inherited by widgets implementing AbstractResourceArtifactWidget.
		//		This is used to build up listeners that will be used in the scope, and ensure that
		//		they become properly destroyed/removed.
		this._listeners.push(com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.RESOURCE_MOVED,
			callbackFunction: this._onArtifactMoved,
			callbackScope: this,
			projectURI: this.getProjectURI(),
			resourceUriScope: this.getResourceURI()
		}));

		this._listeners.push(com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.RESOURCE_RENAMED,
			callbackFunction: this._onRenamed,
			callbackScope: this,
			projectURI: this.getProjectURI(),
			resourceUriScope: this.getResourceURI()
		}));

		this._listeners.push(com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.RESOURCE_PROCESS_AREA_CHANGED,
			callbackFunction: this._onProcessAreaChanged,
			callbackScope: this,
			projectURI: this.getProjectURI(),
			resourceUriScope: this.getResourceURI()
		}));

		this._listeners.push(com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_CHANGED,
			callbackFunction: this._onObjectTypeChanged,
			callbackScope: this,
			projectURI: this.getProjectURI(),
			resourceUriScope: this.getResourceURI()
		}));

		this._listeners.push(com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
			eventTopics: [com.ibm.rdm.web.notifications.EventTopics.TAG_ARTIFACTS_UPDATED,
							com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CHANGED],
			callbackFunction: function(data){
					if(data && data.notifierParams && data.notifierParams.resourceURI &&
						data.notifierParams.resourceURI === this.resourceURI){
							this._handleArtifactContentChanged();
					}
				},
			callbackScope: this,
			projectURI: this.getProjectURI()
		}));
	},

	supportsElementCommenting: function() {
		// summary:
		//		Indicates whether or not the widget supports commenting on elements
		//		within the widget.
		return true;
	},

	///////////////////////////////////////////////////////////////////////////////////
	// Public
	//		The following methods may be used by AbstractResourceArtifactWidget
	//		and may be used by any external points, including those that implement
	//		this piece of code
	///////////////////////////////////////////////////////////////////////////////////
	getTags: function() {
		if (this.isInHistoryMode()){
			if(this.baselineURI){
				return this._doGetTags(this.resourceURI, this.baselineURI);
			}
			return this._doGetTags(this.resourceURI);
		}
		return this._doGetTags(this.resourceURI);
	},

	getTagsForBaseArtifact: function(){
		var result = null;
		if(this.getShowBaseProperties()){
			var boundArtifact = this.resource.getBoundArtifact();
			if(boundArtifact){
				result= this._doGetTags(boundArtifact);
			}
		}
		return result;
	},

	_doGetTags: function(getTagsForURI, baselineURI){

			var tagDeferred = com.ibm.rdm.web.common.ProjectCache.getResourceTags(getTagsForURI, baselineURI, true);
			tagDeferred.addCallback(this, function(resourceTags) {
				//create array containing only resource tags objects
				var tags = [];
				for (var tagResourceURI in resourceTags) {
					tags.push(resourceTags[tagResourceURI]);
				}
				if (tags.length === 0){
					return null;
				} else{
					var tagsSpan = dojo.create("span");

					tags.sort(com.ibm.rdm.web.tags.TagUtil.tagNameComparator);

					var publicTagsString = "";
					var privateTagsString = "";

					var tagRow = "";
					for (var i = 0; i < tags.length; i++) {
						tagRow = tagRow + tags[i].title;
						if (tags[i].scope === "public") {
							if (publicTagsString.length > 0) {
								publicTagsString += this._commonMessages.tagSeperator;
							}
							publicTagsString += BidiUtils.setTextDirUCC(tags[i].title, true); //bidi
						}
						else if (tags[i].scope === "private") {
							if (privateTagsString.length > 0) {
								privateTagsString += this._commonMessages.tagSeperator;
							}
							privateTagsString += BidiUtils.setTextDirUCC(tags[i].title, true); //bidi;
						}
					}
					var publicTagsStringWithDelim = publicTagsString;
					var tagsString;
					if (publicTagsString.length > 0 && privateTagsString.length === 0) {
						tagsString = publicTagsString;
					} else if (publicTagsString.length > 0 && privateTagsString.length > 0) {
						tagsString = publicTagsString + ", " + privateTagsString;
					} else if (publicTagsString.length === 0 && privateTagsString.length === 0) {
						tagsString = "";
					} else {
						tagsString = privateTagsString;
					}
					var publicTagClass = 'public-tags' + ((privateTagsString.length) ? ' shared' : ''),
						privateTagClass = 'private-tags' + ((publicTagsString.length) ? ' shared' : '');
					// If appropriate, manipulate the DOM to add public tag info.
					if (publicTagsString.length > 0 || privateTagsString.length > 0) {
						// add a delimiter between the public and private tags only if there is
						// atleast one public and private tag
						if (publicTagsString.length > 0 && privateTagsString.length > 0) {
							publicTagsStringWithDelim += this._commonMessages.tagSeperator;
						}

						var publicTagsSpan = DomUtils.createSpannedTextNode(publicTagClass, publicTagsStringWithDelim);
						tagsSpan.appendChild(publicTagsSpan);
					}
					// If appropriate, manipulate the DOM to add private tag info.
					if (privateTagsString.length > 0) {
						var privateTagsSpan = DomUtils.createSpannedTextNode(privateTagClass, privateTagsString);
						tagsSpan.appendChild(privateTagsSpan);
					}

					return tagsSpan;
				}
			});
			return tagDeferred;

	},

	getContentType: function(){
		return this.resource.getMimeType();
	},

	getArtifactIdentifier: function(){
		return this.resource.getID();
	},

	getArtifactTitle: function(){
		return this.resource.getDisplayTitle();
	},

	displayMergeConflict: function(resource, dontSave){

		var fakeDeferred = new dojo.Deferred();

		var modifiedByUser = null;
		var modifiedByUserURI = resource.getLastModifiedBy();
		com.ibm.rdm.web.server.client.utils.UserCache.getUser(modifiedByUserURI).addBoth(this, function(response) {
			if(response){
				modifiedByUser = response.name;
			} else {
				modifiedByUser = com.ibm.rdm.web.util.queryutils.getTrimmedUserName(modifiedByUserURI);
			}
			var invokeSaveResource =  dojo.hitch(this, function(){
				// merge conflict can happen on save or refresh, in refresh case, the editor
				// may not be dirty, set the editor to dirty so that the save takes place
				if (!dontSave){
					this.setDirty(false);
					this.saveResource();
				}

				fakeDeferred.callback(true);
			});
			var msgForm = new com.ibm.rdm.web.common.MessageForm({
				confirmMessage: dojo.string.substitute(this._abstractMessages.saveConflict, [modifiedByUser, resource.getRevisionDate()]),
				dialogTitle: this._abstractMessages.artifactModified,
				dialogStyle: "yesNo",
				onOk: dojo.hitch(invokeSaveResource),
				onCancel: function() { fakeDeferred.callback(false);}
			});
			this._toDestroy.push(msgForm);
			msgForm.show();
			return response;
		});

		return fakeDeferred;
	},




	onEdit: function(){
		// Per wi 76418, disable the Delete button when the artifact is in edit mode.
		if (this._deleteResourceButton) {
			this._deleteResourceButton.set("enabled", false);
		}

		var getLockDeferred = new dojo.Deferred();

		var callbackFn = dojo.hitch(this, function(lockStatus) {

			if (lockStatus.obtained) {
				this._resourceLocked = true;
				this._registerNavigateHandlers();
				var deferred = com.ibm.rdm.web.model.resources.ResourceManager.checkIsLatestVersion(this.resource);
				deferred.addCallback(dojo.hitch(this, function(result) {
					if (result.isLatest) {
						// it is the latest, no need to reload.
						this._processEdit();
						// no need to pass the skipCache flag here, we (hopefully)
						// just acquired the lock.
						this._updateLockBoundControls();
					} else {
						// reload
						var deferred = this._refreshResource();
						deferred.addCallback(this, this._processEdit);
					}
				}));
			} else {
				this._updateLockBoundControls();
				var processArea = this.resource.getProcessAreaURI();
				var projectURI = this.projectURI;
				var resourceURI = this._getLockingURI();
				//Lock was not obtained. Inform the user and possibly override
				LockManager.showLockedMessage(LockManager.MSG_LOCK, lockStatus, processArea, projectURI, ProcessOperationsCache, this._getLockingURI(), callbackFn);
			}

			getLockDeferred.callback(lockStatus);
		});

		//Refresh the lock to ensure we are uptodate
		LockManager.refreshLockStatus(this._getLockingURI()).addBoth(dojo.hitch(this, function() {
			//Obtain edit lock, and only action if lock is obtained
			var deferred = LockManager.lockResource(this._getLockingURI());
			deferred.addCallback(callbackFn);
		}));

		return getLockDeferred;
	},

	_processEdit: function() {
		this._underEdit = true;

		dojo.style(this._saveDoneCancelStrip, "display", "inline-block");
		dojo.style(this._editButton, "display", "none");

		// Only allow the user to edit the title or content area when permissions
		// checking states that these areas are editable.
		this.getModifyArtifactPermissions().addCallback(
			this,
			function(modifyArtifactPermissions) {
				if (modifyArtifactPermissions.isModifyTitleAllowed()) {
					dojo.addClass(this._titleNode, "underEdit");
					// User should be able to edit the title by tabbing into it
					this._artifactTitleElement.setAttribute("tabIndex", "0");
				}
				if (modifyArtifactPermissions.isModifyContentAllowed()) {
					this.editResourceMode();
				}
				return modifyArtifactPermissions;
			}
		);

		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_EDIT_MODE,
			resourceUriScope: this.resourceURI
		});

		//If the view is in edit-mode, disable the highlight-all links button
		this._linksSidebar.set("disabledHighlightlinks", true);
	},

	onView: function(isCancel, wasDirty){
		if (this._underEdit) {
			this._underEdit = false;
			dojo.removeClass(this._titleNode, "underEdit");

			this.setDirty(false);
			this._artifactTitleElement.setAttribute("tabIndex", "-1");

			dojo.style(this._saveDoneCancelStrip, "display", "none");
			dojo.style(this._editButton, "display", "inline-block");

			this.viewResourceMode(isCancel, wasDirty);

			com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
				eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_VIEW_MODE,
				resourceUriScope: this.resourceURI,
				resources: [this.resource]
			});

			//If cancelling on a dirty editor, we should refresh the page
			if (isCancel && wasDirty){
				this._triggerRefresh();
			}

			//If the view is no longer in edit-mode, enable the highlight-all links button
			this._linksSidebar.set("disabledHighlightlinks", false);
		} else {
			return;
		}
		this._sizeToLatestDimensions();
	},

	onSave: function(){
		// NOTE: This needs to be a function, used for hooking ctrl-s to save
		// we're in edit mode, so check whether the resource viewer widget is
		// showing the most recent version...

		// Work item 76437: after input non valid values in attribute with data type integer, user can save changes
		// We need to ensure that overview section values are valid and if not we should not allow save to occur.
		// This method could be invoked via shortcut key.
		if (!this._overviewSidebar.isValid()) {
			return;
		}
		com.ibm.rdm.web.common.MessageHandler.clearMessage();
		if (this.isMerge()) {
			// if we already have a merge editor open, no need
			// to check if we have the latest version.
			var saveDeferred = this._doSaveResource();
			saveDeferred.addCallback(this, function(saveResult) {
				this._closeMerger();
				this.onView(false, true);
				return saveResult;
			} );
			return saveDeferred;
		}
		// Handle the case of all other editors (i.e. other than a review editor) ...
		// user could be pressing done when the resource is not dirty, if this is the case, no
		// merge is necessary
		var fakeDeferred = new dojo.Deferred();
		if (this.isDirty()) {
			var deferred = com.ibm.rdm.web.model.resources.ResourceManager.checkIsLatestVersion(this.resource);
			deferred.addCallback(this, function(result) {

				if (result.isLatest) {
					// it is the latest, no need to take any action.
					var saveDeferred = this._doSaveResource();
					saveDeferred.addCallback(this, function(response){
						fakeDeferred.callback();
						return response;
					});
					saveDeferred.addErrback(this, function(response) {
						//response only has lockResponse if it is a locking clash
						if (response.status === 403 && response.lockResponse) {
							//Its locked by someone else - clear the error message and deal with it
							com.ibm.rdm.web.common.MessageHandler.clearMessage();
							//Get the uptodate status
							LockManager.refreshLockStatus(this._getLockingURI()).addCallback(this, function() {
								LockManager.getResourceLockStatus(this._getLockingURI(), this.projectURI).addCallback(this, function(lockStatus) {
									if (LockManager.isLockedByOther(this._getLockingURI())) {
										//We lost the lock.
										this._setLockButtonDisplay(lockStatus);
										var processAreaURI = this.resource.getProcessAreaURI();
										LockManager.showLockedMessage(LockManager.MSG_LOCK, lockStatus, processAreaURI, this.projectURI, ProcessOperationsCache, this._getLockingURI(),
											//overrideCallbackFn,
											dojo.hitch(this, function() {
												//We have overriden the lock - save again
												this.onSave().addCallback(this, function(response) {
													fakeDeferred.callback();
													return response;
												});
											}),
											//noOverrideCallbackFn
											function() {
												//Cannot do a lot here. just ErrorMessage
												com.ibm.rdm.web.common.MessageHandler.showWarning(7733);
												fakeDeferred.errback();
											}
										);
										return response;
									} else {
										//Hmmm changed, but no longer locked - try again
										this.onSave().addCallback(this, function(response) {
											fakeDeferred.callback();
											return response;
										});
										return response;
									}
								});
							});
						} else {
							//Another Err, return
							fakeDeferred.errback(response);

							throw response;
						}
					});
				} else {
					//Checkout the lock situation - we must have lost it somehow as the resource has changed
					LockManager.refreshLockStatus(this._getLockingURI()).addCallback(this, function() {
						LockManager.getResourceLockStatus(this._getLockingURI(), this.projectURI).addCallback(this, function(lockStatus) {
							if (LockManager.isLockedByOther(this._getLockingURI())) {
								//We lost the lock.
								var processAreaURI = this.resource.getProcessAreaURI();
								LockManager.showLockedMessage(LockManager.MSG_LOCK, lockStatus, processAreaURI, this.projectURI, ProcessOperationsCache, this._getLockingURI(),
									//overrideCallbackFn,
									dojo.hitch(this, function() {
										//We have overriden the lock - save again
										this.onSave().addCallback(this, function(response) {
											fakeDeferred.callback();
											return response;
										});
									}),
									//noOverrideCallbackFn
									function() {
										//Cannot do a lot here. just ErrorMessage
										com.ibm.rdm.web.common.MessageHandler.showWarning(7733);
										fakeDeferred.errback();
									}
								);
							} else {
								//Hmmm changed, but no longer locked

								// the version being edited is not the latest, check whether the
								// resource viewer widget knows about a custom merge editor for
								// the resource type it is editing
								var customMerger = this.getMergeCtor && this.getMergeCtor();
								if (!customMerger) {
									// no custom merge editor, so default to simple dialog
									this.displayMergeConflict(result.resource).addCallback(this, function(response) {

										fakeDeferred.callback();

										return response;
									});
								} else {
									this._openMergeConfirmDialog(customMerger, result, fakeDeferred);
								}
							}
						});
					});
					return result;
				}
			});
			deferred.addErrback(this, function(response) {
				fakeDeferred.errback(response);
				return response;
			});
		}else{
			fakeDeferred.callback();
		}

		return fakeDeferred;
	},

	onDone: function(){
		// Per wi 76418, enable the Delete button when the artifact is NOT in edit mode.
		if (this._deleteResourceButton) {
			this._deleteResourceButton.set("enabled", true);
		}

		// Work item 76437: after input non valid values in attribute with data type integer, user can save changes
		// We need to ensure that overview section values are valid and if not we should not allow save to occur.
		// This method could be invoked via shortcut key.
		if (!this._overviewSidebar.isValid()) {
			return;
		}
		com.ibm.rdm.web.common.MessageHandler.clearMessage();
		if (this.isDirty()) {
			this._doneInProgress = true;
			this.onSave().addCallback(this, function() {
				this._doneInProgress = false;
				this._releaseLockAndRefreshView();
			});
		} else{
			this._releaseLockAndRefreshView();
		}
	},

	_releaseLockAndRefreshView: function(/*boolean?*/explicit, /*boolean?*/isCancel, /*boolean?*/isDirty) {
		// summary:
		//		Release any held locks and refresh the view, switching back
		//		to "view" mode.
		// explicit:
		//		Optional param, if true we will always release the lock, if
		//		falsey then we wont release explicitly taken locks from
		//		this method.

		var deferred = LockManager.releaseLockedResource(this._getLockingURI(), explicit).addBoth(this, function() {
			this._resourceLocked = false;
			this._unregisterNavigateHandlers();
			this.onView(isCancel, isDirty);
			// LockManager may not have released the lock (it depends on the explicit param),
			// but if it has, we do not want to call _updateLockBoundControls as this will
			// call LockManager.getResourceLockStatus - which goes to the server if there is no
			// lock in the cache.  Since we just possibly released the lock, we don't want
			// to bypass lock managers cache since if it has no entry for this URI then it will
			// because we released the lock. The server may give us the wrong answer as
			// indexing is not waited on.  If we did not release the lock, then the lock in
			// lock managers cache is the right one anyway.
			// LockManager.getLockInfo consults the cache only.
			this._updateLockControlsCallback(LockManager.getLockInfo(this._getLockingURI()));
		});
		return deferred;
	},

	onClose: function() {

		if (!this.isInReviewMode()) {
			this.onView(false, this.isDirty());
		}
		//Release the lock now - without any refresh of view after
		if (this._resourceLocked) {
			this._unregisterNavigateHandlers();
			LockManager.releaseLockedResource(this._getLockingURI());
			this._resourceLocked = false;
		}

		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: APIEventTopics.ARTIFACT_CLOSED,
			resource: this.resource
		});
		
		this.toggleActiveEdit(false);
	},

	onCancelEdit: function(onConfirmNo){
		// summary:
		//		Cancel editing, but first prompt the user if changes exist.
		// onConfirmNo:
		//		An optional function to execute if the user does not confirm the cancel.

		// Per wi 76418, enable the Delete button when the artifact is NOT in edit mode.
		if (this._deleteResourceButton) {
			this._deleteResourceButton.set("enabled", true);
		}

		// If we are in the process of saving the artifact, ignore any cancel action.
		// Cancel button will be disabled, but Cancel keyboard shortcut could be invoked.
		if (this._saveInProgress) {
			return;
		}
		com.ibm.rdm.web.common.MessageHandler.clearMessage();
		var doCancel = dojo.hitch(this, function() {
			if (dojo.isFunction(this.resource.validateLinks)) {
				this.resource.validateLinks();
			}
			var releaseLockDeferred = this._releaseLockAndRefreshView(false, true, this.isDirty());


		});
		if (this.isDirty()) {
			var msgForm = new com.ibm.rdm.web.common.MessageForm({
				confirmMessage: this._abstractMessages.confirmCancelMessage,
				dialogTitle: this._abstractMessages.confirmCancel,
				dialogStyle: "yesNo",
				onOk: doCancel,
				onCancel: (onConfirmNo) ? onConfirmNo : null
			});
			msgForm.show();
		} else {
			doCancel();
		}
	},

	isDirty: function(){
		return this._isDirty;
	},

	isEdit: function(){
		return this._underEdit;
	},

	setDirty: function(dirty){
		// If we are in the process of saving the artifact, we want to ignore setDirty calls that will enable
		// the save button.  Work item 75902: A user can create a self-conflict in rich text editor, by saving changes too fast
		if (dirty && this._saveInProgress) {
			this._editorDirtiedWhileSaving = true;
			return;
		}
		this.setWindowTitleDirty(dirty);
		if (dirty){
			dojo.style(this._dirtyMarker, "display", "inline");
			//Navigate Handlers now tie to the lock, not dirtiness
			//this._registerNavigateHandlers();

			// Work item 76437: after input non valid values in attribute with data type integer, user can save changes
			// We need to ensure that overview section values are valid and if not we should disable save and done buttons.
			if (this._overviewSidebar.isValid()) {
				this._saveButton && dojo.attr(this._saveButton, "disabled", false);
				dojo.attr(this._doneButton, "disabled", false);
			} else {
				this._saveButton && dojo.attr(this._saveButton, "disabled", true);
				dojo.attr(this._doneButton, "disabled", true);
			}
		}
		else{
			dojo.style(this._dirtyMarker, "display", "none");
			//Navigate Handlers now tie to the lock, not dirtiness
			//this._unregisterNavigateHandlers();
			this._saveButton && dojo.attr(this._saveButton, "disabled", true);
		}
		this._isDirty = dirty;
	},

	isInReviewMode: function(){
		return (this.viewType === com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType.ShowArtifactInReviewContext);
	},

	isInHistoryMode: function(){
		return (this.viewType === com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType.ShowArtifactHistory);
	},

	isModulefactViewer: function(){
		return (this.getResourceObject().getBoundArtifact() != null);
	},

	isStoryboardViewer: function(){
		return false;
	},

	isModuleViewer: function(){
		return false;
	},

	isMerge: function(){
		// summary:
		//		return true or false, depending on whether we are currently merging.
		return !!this._mergeWidget;
	},

	getMerger: function() {
		// returns:
		//		The active merge widget if a merge is in progress.  null if we are
		//		not currently merging.
		return this._mergeWidget;
	},

	getEditor: function() {
		// summary:
		//		Returns this._editor if it exists.
		return this._editor;
	},

	getPermissibleCreateLinkTypes: function() {
		// summary:
		//		Returns a deferred which, when fired, will callback with a
		//		map of links by actionId and whether not creation of the link is allowed.
		var deferred = new dojo.Deferred();
		var projectURI = this.projectURI;
		var processAreaURI = this.resource.getProcessAreaURI();
		var getCreateLinkPermissions = ProcessOperationsCache.getPermissibleLinkTypesForCreation(projectURI, processAreaURI);
		getCreateLinkPermissions.addCallback(this, function(linkTypesToIsAllowedMap){
			deferred.callback(linkTypesToIsAllowedMap);
			return linkTypesToIsAllowedMap;
		});
		return deferred;
	},

	getModifyArtifactPermissions: function() {
		// summary:
		//		Returns a deferred which, when fired, will call you back with a
		//		single argument which will be an instance of
		//		ModifyArtifactPermissions.  This callback argument enables you
		//		to inquire about whether the artifact associated with this
		//		class is editable and, for all of its attributes, which of these
		//		attributes are editable.
		var deferred = new dojo.Deferred();
		var projectURI = this.projectURI;
		var processAreaURI = this.resource.getProcessAreaURI();
		var objectTypeDeferred = TypesManager.getObjectType({
			typeURI: this.artifactTypeURI,
			projectURI: projectURI,
			projectSnapshotURI: this.baselineURI
		});
		objectTypeDeferred.addCallback(this, function(objectType){
			var artifactTypeActionId = objectType.getActionId();
			var getModifyArtifactPermissions =
				ProcessOperationsCache.getModifyArtifactPermissions(
					artifactTypeActionId, processAreaURI, projectURI
				);
			getModifyArtifactPermissions.addCallback(
				this,
				function(modifyArtifactPermissions){
					deferred.callback(modifyArtifactPermissions);
					return modifyArtifactPermissions;
				}
			);
		});
		return deferred;
	},

	onBreadcrumbLoaded: function(breadcrumbInfo) {
		// summary:
		//		Invoked once the breadcrumb in the top right has
		//		been rendered.
		// breadcrumbInfo:
		//		Array of objects of the form {name: ..., uri: ... };
		this._breadcrumbInfo = breadcrumbInfo;
		// Pass the breadcrumb links to RecentlyViewedSection
		if (!this.isModuleArtifact){
			RecentlyViewedSection.setFolderBreadcrumb(this._breadcrumbInfo);
		} else {
			com.ibm.rdm.web.viewer.RecentlyViewedSection.resetFolderReferences();
		}
	},

	getBreadcrumbInfo: function() {
		return this._breadcrumbInfo;
	},

	///////////////////////////////////////////////////////////////////////////////////
	// PRIVATE API
	///////////////////////////////////////////////////////////////////////////////////

	_refreshResource: function(/*boolean?*/refreshLockInfo) {

		// refresh lock info defaults to true unless we get a false
		// boolean
		if (typeof refreshLockInfo === "boolean" && !refreshLockInfo) {
			refreshLockInfo = false;
		} else {
			refreshLockInfo = true;
		}
		var refreshDeferred = new dojo.Deferred();

		if (!this._refreshInProgress) {
			this._refreshInProgress = true;
			this._documentHasBeenLoaded = false;
			// Each sub-class must set _documentHasBeenLoaded when the artifact is
			// loaded
			var loadResourceAndLoadCommentsIfNeeded = dojo.hitch(this, function(revision) {
				var deferredLoadRequest = this.loadResource(revision, true);
				deferredLoadRequest.addCallback(this, function(result) {

					//Remove obvious errors
					if (result) {
						this.resource = result;
					} else {
						console.error("Null result for refreshing resource");
					}
					//Refresh breadcrumb area
					this.getBreadcrumbs(true);

					this.onResourceLoaded();

					//Handle refresh of overview sidebar. Temporary. Must clean up and implement
					//a proper handleRefresh in overview Section later.
					this._overviewSidebar.disableAttributeWidgets = !this._underEdit;
					this._overviewSidebar.load(result);
					this._updateDisplayTitle();
					if (refreshLockInfo) {
						this._updateLockBoundControls(true);
					}

					this._refreshInProgress = false;
					refreshDeferred.callback();
					return result;
				});
				deferredLoadRequest.addErrback(this, function(e){
					console.error("Error performing head request in ResourceViewer.handleRefresh\n" + e);
					this._refreshInProgress = false;
					refreshDeferred.errback();
					return e;
				});
			});
			var doHeadRequest = dojo.hitch(this, function(isFormalReview) {
				// Note: If we're viewing an artifact in a formal review context we
				// make sure here to NOT stop normal processing if the HEAD request
				// fails (and we now do not alert the user - see 72364).
				var deferredHeadRequest =
					com.ibm.rdm.web.server.client.RDMClient.doHead({
						uri: this.resourceURI,
						projectSnapshotURI: this.baselineURI,
						skipErrors: (isFormalReview || this.isInHistoryMode()) // See above Note ...
					});
				deferredHeadRequest.addCallback(this, function(response) {
					if (!isFormalReview && !this.isInHistoryMode()) {
						this.revision = XhrUtils.getResponseRevision(response);
					}
					//Clear the revision for module baselines as it is an unuseful JTS revision
					if (this.isInModuleBaseline) {
						this.revision = null;
					}
					loadResourceAndLoadCommentsIfNeeded(this.revision);
					return response;
				});
				deferredHeadRequest.addErrback(this, function(response){
					if ((isFormalReview || this.isInHistoryMode()) && response.ioArgs.xhr.status === 410) { // Note: 410 is "Gone"
						// See above Note ... we still want to continue loading (after
						// alerting the user to the fact that the artifact has been
						// deleted).
						loadResourceAndLoadCommentsIfNeeded(this.revision);
					}
					else {
						console.error("Error performing head request in ResourceViewer.handleRefresh\n" + response);
						this._refreshInProgress = false;
					}
					return response;
				});
			});

			if(this.isInReviewMode()) {
				if(!this._reviewModelDeferred) {
					this._reviewModelDeferred =
						com.ibm.rdm.web.review.ReviewCache.getReview(this.reviewId);
				}

				this._reviewModelDeferred.addCallback(this, function(review) {
					// We want to display head version of the resource
					// unless the formal review has been started.
					var reviewParser = review.getReviewParser();
					var isFormalReview = reviewParser.isFormal()
							&& reviewParser.getReviewState() !== ReviewTypes.REVIEW_STATE_TYPES.Draft;
					doHeadRequest(isFormalReview);
					return review;
				});
				this._reviewModelDeferred.addErrback(this, function(error) {
					console.error("Error retrieving the review for artifact under review refresh\n" + error);
				});
			} else {
				doHeadRequest(false);
			}

		} else { //Wait for refresh to finish
			//console.debug("refreshing");
			refreshDeferred.callback();
		}

		return refreshDeferred;
	},

	_openMergeConfirmDialog: function(customMerger, versionResult, deferred) {
		// Open a dialog giving the user 3 choices for the save conflict

		var modifiedByUser = null;
		var modifiedByUserURI = versionResult.resource.getLastModifiedBy();
		com.ibm.rdm.web.server.client.utils.UserCache.getUser(modifiedByUserURI).addBoth(this,
			function(response) {
				if(response){
					modifiedByUser = response.name;
				} else {
					modifiedByUser = com.ibm.rdm.web.util.queryutils.getTrimmedUserName(modifiedByUserURI);
				}
				var createRadioButton = dojo.hitch(this, function(btnName,btnValue,isChecked){
					var button = new dijit.form.RadioButton({
						value: btnValue,
						name: btnName,
						checked: isChecked || false
					});
					this._toDestroy.push(button);
					return button;
				});

				var createLabel = dojo.hitch(this, function(button, message){
					var lbl = dojo.create('label');
					if (button) {
						lbl.htmlFor = button.id;
					}
					lbl.innerHTML = message;
					return lbl;
				});

				var divElement = dojo.create("div");
				var div1 = dojo.create("div");
				var div2 = dojo.create("div");
				var div3 = dojo.create("div");

				var explMessage = dojo.string.substitute(this._abstractMessages.artifactModifiedState,
					[modifiedByUser]);
				var lblExpl = createLabel(null, explMessage);

				var discardBtn = createRadioButton("typeGroup","discard", true);
				var overrideBtn = createRadioButton("typeGroup","override");
				var mergeBtn = createRadioButton("typeGroup","merge");

				var lbl1 = createLabel(discardBtn, this._abstractMessages.discardChanges);
				var overwriteMessage = dojo.string.substitute(this._abstractMessages.overwriteChanges,
					[modifiedByUser]);
				var lbl2 = createLabel(overrideBtn, overwriteMessage);
				var lbl3 = createLabel(mergeBtn, this._abstractMessages.mergeChanges);

				div1.className = "merge-choice-top-div";
				div1.appendChild(discardBtn.domNode);
				div1.appendChild(lbl1);
				div2.className = "merge-choice-div";
				div2.appendChild(overrideBtn.domNode);
				div2.appendChild(lbl2);
				div3.className = "merge-choice-div";
				div3.appendChild(mergeBtn.domNode);
				div3.appendChild(lbl3);

				divElement.appendChild(lblExpl);
				divElement.appendChild(div1);
				divElement.appendChild(div2);
				divElement.appendChild(div3);

				var onOk = dojo.hitch(this, function() {
					if (discardBtn.checked) {
						this.setDirty(false);
						this.onView(true);
						this.handleRefresh();
						if (deferred) {deferred.callback();}
					} else if (overrideBtn.checked) {
						// merge conflict can happen on save or refresh, in refresh case, the editor
						// may not be dirty, set the editor to dirty so that the save takes place
						this.setDirty(true);
						this._doSaveResource().addCallback(this, function() {deferred.callback();});
					} else {
						// manual merge
						// merge conflict can happen on save or refresh, in refresh case, the editor
						// may not be dirty, set the editor to dirty so that the save takes place
						this.setDirty(true);
						var merger = new customMerger({
							leftResourceObj: versionResult.resource,
							resourceViewer: this,
							rightResourceObj: this.getResourceObject(true),
							resourceViewerLoader: this
						});
						this._toDestroy.push(merger);

						merger.startup();
						this._contentPane.setContent(merger.domNode);
						merger.render();
						this._mergeWidget = merger;
					}
				});

				var msgForm = new com.ibm.rdm.web.common.MessageForm(
					{
						confirmContent: divElement,
						dialogTitle: this._abstractMessages.artifactModified,
						dialogStyle: "okCancel",
						dialogWidth: 250,
						onOk: onOk
					});
				this._toDestroy.push(msgForm);
				msgForm.show();
				return response;
			}
		);
	},

	_updateDisplayTitle: function(){
		// summary:
		//		Updates the displayed title of the resource.
		//		this.resource must already have the title set
		//		on it.
		var displayTitle,
			title = this.resource.getTitle();
		if ((this.resource.hasServerGeneratedTitle && this.resource.hasServerGeneratedTitle()) || title === "") {
			dojo.addClass(this._titleNode, "generatedTitle");
			displayTitle = dojo.string.substitute(this._abstractMessages.generatedTitleIndicator, [title]);
		} else {
			dojo.removeClass(this._titleNode, "generatedTitle");
			displayTitle = title;
		}
		// Set the title before encoding the string
		this._artifactTitleElement.title = displayTitle;
		displayTitle = DomUtils.getHTMLEncodedText(displayTitle);
		this._artifactTitleElement.innerHTML = displayTitle;
		//bidi
		BidiUtils.applyTextDirSetting(this._artifactTitleElement, title);
		// Update the browser title to keep the tab name in sync with requirement name.
		var pageTitle = dojo.string.substitute(this._abstractMessages.artifactDisplayName, [this.resource.getID(), title]);
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(pageTitle);
	},

	_setDisplayTitle: function(newTitle){
		this._artifactTitleElement.innerHTML = newTitle;
		//bidi
		if (this._textDir === BidiUtils.TEXT_DIR_CONTEXTUAL){
			BidiUtils.applyTextDir(this._textDir, this._artifactTitleElement, newTitle);
		}
	},

	_updateDisplayDescription: function(newDescription){
		this._overviewSidebar.setDescription(newDescription);
	},

	_updateTeamOwnershipField: function(processAreaURI) {
		this._overviewSidebar.updateTeamOwnershipField(processAreaURI);
	},

	_resourceTitleEdit: function() {
		// summary:
		//		Function invoked when the user clicks on the title.

		var title;
		// do nothing in "view" mode.
		if (this.isEdit()) {
			// otherwise get the resource...

			if (this._isEditingFrame) {
				// Use the frame's name rather than the storyboard title.
				dojo.attr(this._nameEditor, "value", this._frameTitle);
			}	else {
				// Set the inputs value to be the title...  This could be a value previously
				// set by the user, or could be a value that has been generated by the server.
				// Since this is for edit, do not use this.getArtifactTitle(), since that can
				// return the ID if a title is not available.
				title = this.resource.getTitle();
				dojo.attr(this._nameEditor, "value", title);
			}

			//bidi
			BidiUtils.applyTextDirSetting(this._nameEditor, title);
			// add a class to the parent node, this causes matching
			// of rules that will hide the title span and reveal the
			// input called "_nameEditor"
			dojo.addClass(this._titleNode, "titleUnderEdit");

			// finally focus the input.
			this._nameEditor.focus();
		}
	},

	_blurNameInput: function () {
		// summary:
		//		Invoked when the input used to edit the resource title is blurred.
		dojo.removeClass(this._titleNode, "titleUnderEdit");
	},

	_onKeyPress: function (event) {
		// summary:
		//		Handle short cut keys for save/done/cancel
		if (event.keyChar === "S" && event.shiftKey && event.ctrlKey) {
			this._blurNameInput();
			this.onDone();
			dojo.stopEvent(event);
		} else if (event.keyChar === "s" && event.ctrlKey) {
			if (this.isDirty()) {
				this.onSave();
			}
			dojo.stopEvent(event);
		} else if (event.keyCode === dojo.keys.ESCAPE) {
			this._blurNameInput();
			var onConfirmNo = dojo.hitch(this, function() {
				dojo.addClass(this._titleNode, "titleUnderEdit");
				this._nameEditor.focus();
			});
			this.onCancelEdit(onConfirmNo);
			dojo.stopEvent(event);
		}
	},

	_onChangeNameInput: function (/*String*/ eventType) {
		// summary:
		//		Invoked when the input used to edit the resource title fires its
		//		onChange event, the mouse leaves the document body (for when we are in the editor)
		//		and when the onkeyup event in the title editor is fired.
		// 48819: There are some conditions where we do not want to execute this method.
		if (!this._underEdit
			|| (!this._isEditingFrame && eventType!=="onchange" && eventType!=="onkeyup")
			|| (this._isEditingFrame && eventType==="onchange")) {
			return;
		}
		var title;

		// remove the class that has revealed the unput and hidden the title
		if (!this._isEditingFrame && !(eventType==="onkeyup")) {
			dojo.removeClass(this._titleNode, "titleUnderEdit");
		}
		// get the value of the input (the edited title).
		title = dojo.attr(this._nameEditor, "value");
		// update the resource and mark the viewer as dirty.
		if (!this._isEditingFrame) {
			this.resource.setTitle(title);
			this._updateDisplayTitle();
		} else {
			this._frameTitle = title;
			this._artifactHandler.setFrameName(title);
			// We also need to update the title span, or it will revert back to the old title.
			this._artifactTitleElement.innerHTML = title;
		}
		this.setDirty(true);
		// note: not bothering to calculate whether this is warranted as asking for
		// the size of this._artifactTitleElement will force a reflow to happen anyway.
	},

	_onKeyUpNameInput: function () {
		// summary:
		//		Invoked when the input used to edit the resource title fires its
		//		onKeyUp event.
		//		for Bidi support for contextual text direction

		var value = dojo.attr(this._nameEditor, "value");
		var prevdir =  dojo.attr(this._nameEditor, "dir");
		BidiUtils.applyTextDirSetting(this._nameEditor, value);
		//case with contextual text direction. If the direction of the _nameEditor is changed, and then the focus is removed from the _nameEditor,
		//onchange is not fired, and text in  _artifactTitleElement is not updated
		//to fix this, copied relevant code from _onChangeNameInput
		var dir = dojo.attr(this._nameEditor, "dir");
		if (prevdir !== dir){
			// update the resource and mark the viewer as dirty.
			this.resource.setTitle(value);
			this._updateDisplayTitle();
			this.setDirty(true);
		}
	},

	_doSaveResource: function() {
		if (this.isDirty()) {
			// Use a flag to keep track of when the save operation is in progress for work item
			// 75902: A user can create a self-conflict in rich text editor, by saving changes too fast
			this._saveInProgress = true;
			var saveDeferred = this.saveResource();
			com.ibm.rdm.web.common.StatusDisplay.showStatusMessage(this._abstractMessages.saving);

			this._saveButton && dojo.attr(this._saveButton, "disabled", "disabled");
			dojo.attr(this._doneButton, "disabled", "disabled");
			dojo.attr(this._cancelButton, "disabled", "disabled");

			saveDeferred.addCallback(this, function(response) {
				var revision = response.getRevision();
				this.setRevision(revision);

				this._saveInProgress = false;
				this._saveButton && dojo.removeAttr(this._saveButton, "disabled");
				dojo.removeAttr(this._doneButton, "disabled");
				dojo.removeAttr(this._cancelButton, "disabled");
				if (this._editorDirtiedWhileSaving) {
					this._editorDirtiedWhileSaving = false;
					this.setDirty(true);
				} else {
					this.setDirty(false);
				}
				com.ibm.rdm.web.common.StatusDisplay.hideStatusMessage();
				this._overviewSidebar.loadModifiedInfo();
				//Only notify when resource actually saved.
				com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
					eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED,
					resourceURI: this.resourceURI,
					projectURI: this.projectURI,
					resources: [response]
				});

				// Update title after save in case of a generated title change
				this._updateDisplayTitle();
				return response;
			});
			saveDeferred.addErrback(this, function(response) {
				com.ibm.rdm.web.common.StatusDisplay.hideStatusMessage();
				this._saveInProgress = false;
				this._editorDirtiedWhileSaving = false;
				this._saveButton && dojo.removeAttr(this._saveButton, "disabled");
				dojo.removeAttr(this._doneButton, "disabled");
				dojo.removeAttr(this._cancelButton, "disabled");
				var validationFailed = XhrUtils.getValidationErrorDescription(response);
				if (validationFailed) {
					com.ibm.rdm.web.common.MessageHandler.showError(7346, null, validationFailed);
				} else {
					var responseText = response.ioArgs.xhr.responseText;
					if (responseText.indexOf("CRRRS8714E") !== -1) {
						// We don't want to do anything in this case.  The doPut for the
						// resource (resulting from our above 'saveResource' call) has
						// already made use of the MessageHandler to present an appropriate
						// error.
					} else {
						com.ibm.rdm.web.common.MessageHandler.showError(7342, null, response);
					}
				}
				return response;
			});
			return saveDeferred;
		} else {
			var fakeDeferred = new dojo.Deferred();
			fakeDeferred.callback();
			return fakeDeferred;
		}
	},

	_closeMerger: function() {
		// summary:
		//		Closes the merge tool, so that the resource is shown in view mode again.
		var merger  = this._mergeWidget;
		if (merger) {
			merger.destroyRecursive();
		}
		this._mergeWidget = null;
	},

	setRevision: function(revision) {
		this.revision = revision;
		this._successorRevision = null;
		if (this.baselineURI) {
			// in the case where a baselineURI is set, we want to use the actual revision date, not
			// the successor revision date
			if (this._revisions && this._revisions[this.revision]) {
				this._successorRevision = this._revisions[this.revision];
			}
		} else {
			if (this._revisions && this._revisions[this.revision]) {
				var successorRevisionId = this._revisions[this.revision]["http://jazz.net/xmlns/v0.6#successor"];
				if (this._revisions[successorRevisionId]) {
					this._successorRevision = this._revisions[successorRevisionId];
				}
				else {
					this._successorRevision = null;
				}
			}
		}
		if (this.contentWrapper && dojo.isFunction(this.contentWrapper.showRevision)){
			this.contentWrapper.showRevision(revision, this.baselineURI);
		}
		if(this._commentsSidebar) {
			this._commentsSidebar.setRevisionDate((this._successorRevision)?this._successorRevision.revisionDate:null);
		}
		if(this._linksSidebar) {
			this._linksSidebar.setRevisionDate((this._successorRevision)?this._successorRevision.revisionDate:null);
		}
	},


	setBaselineURI: function(baselineURI){
		this.baselineURI = baselineURI;
		this._commentsSidebar.setBaseline(baselineURI);
		this._linksSidebar.setBaseline(baselineURI);
		this._linksSidebar.setIsInModuleBaseline(this.isInModuleBaseline);
	},

	_registerNavigateHandlers: function() {
		var handleOnBeforeUnload = dojo.hitch(this, this._navigateAwayEvent);
		var handleBodyClick = dojo.hitch(this, this._clickNavigateAwayEvent);

		if (!this._handleNavigateEvent) {
			this._handleNavigateEvent =
				net.jazz.ajax.ui.PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(
					handleOnBeforeUnload, 10000
				);
		}
		if (!this._handleBodyClickEvent) {
			this._handleBodyClickEvent =
				net.jazz.ajax.ui.PlatformUI.getWorkbench().registerBodyClickHandler(
					handleBodyClick, 10000
				);
		}
	},

	_unregisterNavigateHandlers: function() {
		if (this._handleNavigateEvent){
			net.jazz.ajax.ui.PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this._handleNavigateEvent);
			this._handleNavigateEvent = null;
		}
		if (this._handleBodyClickEvent){
			net.jazz.ajax.ui.PlatformUI.getWorkbench().unregisterBodyClickHandler(this._handleBodyClickEvent);
			this._handleBodyClickEvent = null;
		}
	},

	_navigateAwayEvent: function() {
		return this.isDirty() ? dojo.string.substitute(this._abstractMessages.hasChanges, [this.getArtifactTitle()]) : false;
	},

	_clickNavigateAwayEvent: function(urlObject) {
		if (!this.isDirty()) {
			// do not veto the click event
			return false;
		}
		if (urlObject.uri.indexOf("#action") === -1) {
			// We want to ignore clicks for things like the Print Button, the Refresh Button,
			// CKEditor toolbar items that open a CKEditor dialog, so look for action parameter
			return false;
		}

		// Ideally we should give the user three choices:
		//		- save changes? (yes/no), cancel navigation
		// confirm only allows two options and buttons are ok/cancel, we need a window that will block the
		// UI and stop processing until an option is selected, at which point whether or not to veto the
		// operation can be returned to the jazz handler that calls clickNavigateAwayEvent
		// Note we put this in a timeout for 0ms so the browser can regain control if we are
		//   attempting to navigate from a graphical editor. Without this, the browser can freeze.
		window.setTimeout(function() {
			if (confirm(this._abstractMessages.unsavedNavigateConfirm)) {
				// do not veto the click event, discard changes
				this.setDirty(false);
				if (this.resource) {
					var resource = this.resource;
					if (typeof resource.validateLinks === "function") {
						resource.validateLinks();
					}
				}
				this.onView(true);
				return false;
			} else {
				// veto the click event and allow the user to save
				return true;
			}
		}, 0);

	},

	// Gets the pretty link icon image and puts it in the DOM
	// A modified version of this function is found in ReviewArtifactWidget.js
	_refreshPrettyLinkIcon: function() {
		if (this._breadcrumbsSpan && this._prettyLinkIcon){
			var button = new jazz.ui.toolbar.Button({
				imgClass: "permalink-icon",
				title: this._abstractMessages.permalink,
				href: this._getPrettyURI(),
				onClick: dojo.hitch(this, function(event){
					dojo.stopEvent(event);
					this._openPrettyLinkMessage();
				})
			});
			if (this._lastBreadcrumbLinkButton) {
				// Explicitly destroy the last pretty link button (and remove it from
				// the this._toDestroy array).
				var index = dojo.indexOf(this._toDestroy, this._lastBreadcrumbLinkButton);
				if (index !== -1) {
					this._toDestroy.splice(index, 1);
				}
				this._lastBreadcrumbLinkButton.destroyRecursive();
			}
			this._toDestroy.push(button);

			dojo.place(button.domNode, this._prettyLinkIcon, "only");
			this._lastBreadcrumbLinkButton = button;
		}
	},

	_getPrettyURI: function() {
		// summary:
		//		Compute and return the pretty URI of the artifact.
		var prettyURI = this.getResourceURI();
		if (this.isInHistoryMode()) {
			var revision = this.getRevision(),
				baseline = this.getBaselineURI();
			if (baseline && !this.isModule && !this.isModuleArtifact) {
				// Not a module or module artifact, but we have a baseline.
				prettyURI += "?revision=" + encodeURIComponent(revision) + "&baseline=" + encodeURIComponent(baseline);
			} else if (baseline && (this.isModule || this.isModuleArtifact)) {
				// Module or module artifact and we have a baseline
				prettyURI += "?moduleBaseline=" + encodeURIComponent(baseline);
			} else if (revision) {
				// Not a baseline, but we have a revision.
				prettyURI = revision;
			}
		}
		return prettyURI;
	},

	// Creates a pop-up message form that displays the pretty URI
	// A modified version of this function is found in ReviewArtifactWidget.js
	_openPrettyLinkMessage: function() {
		// Dialogs with baseline URIs should be a bit wider
		var dialogWidth = (this.isInHistoryMode() && this.getBaselineURI()) ? "525px" : "450px";
		var displayTitle = this.resource.getTitle();
		if (this.resource.hasServerGeneratedTitle && this.resource.hasServerGeneratedTitle()) {
			displayTitle = dojo.string.substitute(this._abstractMessages.generatedTitleIndicator, [displayTitle]);
		}
		displayTitle = dojo.string.substitute(this._abstractMessages.artifactDisplayName, [this.resource.getID(), displayTitle]);
		displayTitle = jazz.util.html.escape(displayTitle);
		var linkURI = this._getPrettyURI();

		var permalinkDialog = new com.ibm.rdm.web.common.PermalinkDialog({
			initLinkURI: linkURI,
			initDisplayText: displayTitle,
			initDialogWidth: dialogWidth
		});

		this._toDestroy.push(permalinkDialog);
		permalinkDialog.show();
	},

	/*
	 * Toolbar related methods
	 */
	_addNextGenEditorButton: function(){
		this._nextGenEditorButton = new jazz.ui.toolbar.TwoStateButton({
			title: "Next Generation Editor",
			pressed: this._isNextGenEditorPressed(),
			showLabel: false,
			onClick: dojo.hitch(this, this._handleNextGenEditorClicked),
			imgSrc: dojo.moduleUrl("com.ibm.rdm.web", "common/images/icons/etool16/nextgen_vis.gif").toString()
		});
		this._toDestroy.push(this._nextGenEditorButton);
		this._actionsToolbar.addChild(this._nextGenEditorButton);
		this._actionsToolbar.addChild(new jazz.ui.toolbar.Separator());
	},

	_isNextGenEditorPressed: function() {
		// Subclasses should override
		return false;
	},

	_addBasePropertiesButton: function(toolbar){
		if ((!this.isModuleViewer() && !this.isModulefactViewer()) || this.isInReviewMode()) {
			return;
		}
		
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'base-properties-toggle-menu',
			args = {
			title: this._abstractMessages.baseProperties,
			onClick: dojo.hitch(this, '_handleBasePropertiesClicked'),
			imgClass: icon,
			iconClass: icon,
			pressed: this._showBaseProperties
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._basePropertiesButton = new jazz.ui.toolbar.TwoStateButton(args);
			this._actionsToolbar.addChild(this._basePropertiesButton);
			this._toDestroy.push(this._basePropertiesButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			this._basePropertiesMenuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(this._basePropertiesMenuItem);
			this._toDestroy.push(this._basePropertiesMenuItem);
		}
	},

	_addCreateExportButton: function(args){
		// No args were provided. Set default args as just the 'main' toolbar
		if(!args) {  args = { toolbar: 'main' }; }
		var toolbar = args.toolbar;
		if(this._shouldAddToMain(toolbar)) {
			var exportMain = this._addCreateExportButtonMain(args);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addCreateExportButtonMore(args);
		}
		
		return exportMain;
	},
	
	_addCreateExportButtonMain: function(args) {
		var hideSmallClass = (args.toolbar === 'both' ? HIDE_ON_SMALL_CLASS : '');
		var exportMenu = new jazz.ui.Menu();
		this._toDestroy.push(exportMenu);
		if(args.includeCsv) {
			var exportCsv = new jazz.ui.menu.MenuItem(this._getExportCsvArgs());
			this._toDestroy.push(exportCsv);
			exportMenu.addChild(exportCsv);
		}
		if(args.generateReportFn) {
			var generateReport = new jazz.ui.menu.MenuItem(this._getGenerateReportArgs(args));
			this._toDestroy.push(generateReport);
			exportMenu.addChild(generateReport);
		}
		var exportPdf = new jazz.ui.menu.MenuItem(this._getPrintPdfArgs());
		var exportWord = new jazz.ui.menu.MenuItem(this._getPrintWordArgs());
		this._exportButton = new jazz.ui.toolbar.MenuButton({
			title: this._abstractMessages.createPrint,
			'class': hideSmallClass,
			dropDown: exportMenu,
			imgClass: "createPdfWordIcon",
			menuProvider: function() {
				return exportMenu;
			}
		});
		// Check permissions and enable if needed
		this._enableQuickPrintButtonsIfAppropriate([exportPdf, exportWord]);
		exportMenu.addChild(exportPdf);
		exportMenu.addChild(exportWord);
		this._toDestroy.push(exportMenu, exportPdf, exportWord, this._exportButton);
		
		this._actionsToolbar.addChild(this._exportButton);
	},
	
	_addCreateExportButtonMore: function(args) {
		var hideLargeClass = (args.toolbar === 'both' ? HIDE_ON_LARGE_CLASS : '');
		// If we have children already add a separator
		if(this._moreActionsMenu.getChildren().length) {
			this._moreActionsMenu.addChild(new dijit.MenuSeparator({'class': hideLargeClass}));
		}
		var titleItem = new jazz.ui.menu.NodeMenuItem({label: this._abstractMessages.createPrint, isTitle: true, 'class': hideLargeClass});
		this._moreActionsMenu.addChild(titleItem);
		
		if(args.includeCsv) {
			var csvArgs = this._getExportCsvArgs();
			csvArgs['class'] = hideLargeClass;
			var exportCsv = new jazz.ui.menu.MenuItem(csvArgs);
			this._moreActionsMenu.addChild(exportCsv);
			this._toDestroy.push(exportCsv);
		}
		if(args.generateReportFn) {
			var reportArgs = this._getGenerateReportArgs(args);
			reportArgs['class'] = hideLargeClass;
			var reportItem = new jazz.ui.menu.MenuItem(reportArgs);
			this._moreActionsMenu.addChild(reportItem);
			this._toDestroy.push(reportItem);
		}
		
		var pdfArgs = this._getPrintPdfArgs();
		pdfArgs['class'] = hideLargeClass;
		var pdfItem = new jazz.ui.menu.MenuItem(pdfArgs);
		this._moreActionsMenu.addChild(pdfItem);
		
		var wordArgs = this._getPrintWordArgs();
		wordArgs['class'] = hideLargeClass;
		var wordItem = new jazz.ui.menu.MenuItem(wordArgs);
		this._moreActionsMenu.addChild(wordItem);
		
		this._enableQuickPrintButtonsIfAppropriate([pdfItem, wordItem]);
		this._toDestroy.push(titleItem, pdfItem, wordItem);
		
		this._moreActionsMenu.addChild(new dijit.MenuSeparator({'class': hideLargeClass}));
	},
	
	_getGenerateReportArgs: function(args) {
		return {
			label: args.generateReportLabel || this._abstractMessages["generateReport"],
			onClick: args.generateReportFn,
			iconClass: "createReportCommand"
		};
	},
	
	_getExportCsvArgs: function() {
		return {
			label: this._abstractMessages.exportToCsv,
			onClick: dojo.hitch(this, '_handleExportArtifactsClicked'),
			iconClass: "exportCommand"
		};
	},
	
	_getPrintPdfArgs: function() {
		return {
			label: this._abstractMessages["printToPdf"],
			iconClass: "newPdfIcon",
			disabled: true,
			onClick: dojo.hitch(this, '_handleExportClicked', {format: com.ibm.rdm.web.model.types.RRMTypes.EXPORT_FORMATS.PDF})
		};
	},
	
	_getPrintWordArgs: function() {
		return {
			label: this._abstractMessages["printToWord"],
			iconClass: "newDocIcon",
			disabled: true,
			onClick: dojo.hitch(this, '_handleExportClicked', {format: com.ibm.rdm.web.model.types.RRMTypes.EXPORT_FORMATS.WORD})
		};
	},
	
	_addHighlightRecentlyCommentedButton: function(onHighlightRecentlyCommented) {
		var button = new jazz.ui.toolbar.TwoStateButton({
			title: this._dashboardToolbarWidgetMessages["highlightRecentlyCommented"],
			onClick: onHighlightRecentlyCommented,
			imgClass: "recent-comments-toggle-menu"
		});
		this._toDestroy.push(button);
		this._actionsToolbar.addChild(button);
	},

	_addHighlightRecentlyModifiedButton: function(onHighlightRecentlyModified) {
		var button = new jazz.ui.toolbar.TwoStateButton({
			title: this._dashboardToolbarWidgetMessages["highlightRecentlyModified"],
			onClick: onHighlightRecentlyModified,
			imgClass: "recent-artifacts-toggle-menu"
		});
		this._toDestroy.push(button);
		this._actionsToolbar.addChild(button);
	},

	_addCreateReviewAction: function(toolbar){
		if (!this._projectOperations.item(com.ibm.rdm.web.common.ProjectCache.MODIFY_REVIEW) 
				|| this.isInReviewMode() || this.isModulefactViewer()) {
			return;
		}
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'review-icon',
			args = {
			title: this._abstractMessages.createReview,
			onClick: dojo.hitch(this, '_handleCreateReviewClicked'),
			imgClass: icon,
			iconClass: icon
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._createReviewButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._createReviewButton);
			this._toDestroy.push(this._createReviewButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			args.label = args.title;
			this._addHidingClass(toolbar, args, 'more');
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addLockAction: function(){
		// Not permitted in review
		if(this.isInReviewMode()) { return; }
		
		var button = new jazz.ui.toolbar.TwoStateButton({
			title: this._abstractMessages.permLock,
			"class": "lockButton",
			"enabled": false,
			onClick: dojo.hitch(this, '_handleLockClicked'),
			imgSrc: this._blankGif
		});

		this._actionsToolbar.addChild(button);
		this.__lockButton = button;

		if (this._lockInfoDetermined) {
			this._setLockButtonDisplay(this.lockInfo);
		}
		this._toDestroy.push(button);
		return button;
	},

	_addSuspicionProfileButton: function(toolbar) {
		if (this.isInReviewMode()) { return; }
		if(!toolbar) { toolbar = 'main'; }
		var user = com.ibm.rdm.web.AUTHENTICATED_USER,
			icon = "suspicion-menu",
			args = {
				// If the user has only the JazzGuests repository permission
				// we set the title to "Suspicion Profiles".
				// Otherwise, the user has "normal" permissions and we set the
				// title to "Loading suspicion profiles".
				title: user.isOnlyJazzGuest ? 
						this._suspicionProfilePickerMessages.selectProfiles : this._abstractMessages.loadingSuspicionProfiles,
				imgClass: icon,
				iconClass: icon
			};
		var tempSuspicionProfileButton = new jazz.ui.toolbar.Button(args);
		this._actionsToolbar.addChild(tempSuspicionProfileButton);
		this._toDestroy.push(tempSuspicionProfileButton);

		if (user.isOnlyJazzGuest) {
			tempSuspicionProfileButton.set("enabled", false);
		} else {
			this._artifactSuspicionModel.getModelObject().then(
				dojo.hitch(this, function(modelObject) {
					var suspicionProfilePicker = new com.ibm.rdm.web.suspicion.SuspicionProfilePicker({
						projectURI: this.getProjectURI(),
						projectName: this.getProjectName(),
						source: com.ibm.rdm.web.suspicion.SuspectLinksUtil.EVENT_SOURCE.artifactToolbar,
						suspicionModel: this._artifactSuspicionModel
					});
					var className = "artifactToolbarPicker" + ((toolbar === 'both') ? " hide-on-small" : ''); 
					dojo.addClass(suspicionProfilePicker.domNode, className);
					dojo.place(suspicionProfilePicker.domNode, tempSuspicionProfileButton.domNode, "replace");
					this._toDestroy.push(suspicionProfilePicker);
					
					if(this._shouldAddToMore(toolbar)) {
						this._addHidingClass(toolbar, args, 'more');
						args.title = this._suspicionProfilePickerMessages.manage;
						args.label = this._suspicionProfilePickerMessages.manage;
						args.onClick = dojo.hitch(suspicionProfilePicker, 'onClickHandler');
						var menuItem = new jazz.ui.menu.MenuItem(args);
						this._moreActionsMenu.addChild(menuItem);
					}
				})
			);
		}
		return tempSuspicionProfileButton;
	},

	_createLockedByOtherUserTooltipMessage: function(lockInfo, includeUnlockAction) {
		// summary:
		//		Returns a deferred that when fired will contain the string
		//		used as a tooltip for the lock button and the edit button
		//		if another user has locked this artifact.
		return com.ibm.rdm.web.server.client.utils.UserCache.getUser(lockInfo.userURI).addBoth(this, function(response) {
			if (response){
				var userName = jazz.util.html.escape(response.name),
					title = dojo.string.substitute(this._commonMessages["lockedByOtherUserSince"], [userName, DateTimeHelper.getDateTimeDisplayStringFromString(lockInfo.utcDate)]);

				 if (this.isReleaseLocksAllowed && includeUnlockAction) {
					title = title + " " + this._abstractMessages["overrideLock"];
				  }

				 return title;
			}
		});
	},

	_setLockButtonDisplay: function(lockInfo) {
		var isEdit;

		if (this.__lockButton) {
			isEdit = !!this._underEdit;
			if (lockInfo) {
				if (lockInfo.byMe) {
					this.__lockButton.set({
						"imgClass": "lockedByMe",
						"pressed": true,
						"title": this._abstractMessages["releasePermLock"],
						"enabled": true
					});
				} else {
					this.__lockButton.set({
						"imgClass": "lockedByOther",
						 "title": "",
						 "enabled": this.isReleaseLocksAllowed,
						 "pressed": false
					});

					this._createLockedByOtherUserTooltipMessage(lockInfo, true).then(dojo.hitch(this, function(title) {
						this.__lockButton.set("title", title);
					}));
				}
			} else {
				this.__lockButton.set({
					"imgClass": "noLock",
					"enabled": true,
					"pressed": false,
					"title": this._abstractMessages["permLock"]
				});
			}

			if (isEdit) {
				this.__lockButton.set("title", this._abstractMessages["editLocked"]);
			}

			if (isEdit || !this._manualLockPermission || !this._isEditAllowed) {
				this.__lockButton.set({
					"enabled": false,
					"pressed": false
				});
			}
		}
	},

	_addAddToCollectionAction: function(toolbar){
		if (!this._projectOperations.item(com.ibm.rdm.web.common.ProjectCache.MODIFY_RESOURCE) ||
				this.isInReviewMode() || this.isModulefactViewer()) {
			return;
		}
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'add-to-collection-icon',
			args = {
			title: this._abstractMessages.addToCollection,
			onClick: dojo.hitch(this, '_handleAddToCollectionClicked'),
			imgClass: icon,
			iconClass: icon
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addToCollectionButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._addToCollectionButton);
			this._toDestroy.push(this._addToCollectionButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addCreateTemplateAction: function(toolbar){
		if (!this._projectOperations.item(com.ibm.rdm.web.common.ProjectCache.CREATE_TEMPLATE) ||
				this.isInReviewMode() || this.isModulefactViewer()) {
			return;
		}
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'create-artifact-template-icon',
			args = {
			title: this._abstractMessages.createArtifactTemplate,
			onClick: dojo.hitch(this, '_handleCreateArtifactTemplateClicked'),
			imgClass: icon,
			iconClass: icon
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._createArtifactTemplateButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._createArtifactTemplateButton);
			this._toDestroy.push(this._createArtifactTemplateButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addShowHistoryAction: function(toolbar){
		if (this.isInReviewMode()) { return; }
		
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'open-history-icon',
			args = {
			title: this._abstractMessages.openHistory,
			onClick: dojo.hitch(this, '_handleOpenHistoryClicked'),
			imgClass: icon,
			iconClass: icon
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._openHistoryButton =  new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._openHistoryButton);
			this._toDestroy.push(this._openHistoryButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addMoveFolderAction: function(toolbar){
		if (this.isModulefactViewer()) { return; }
		
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'moveCommand',
			args = {
			title: this._abstractMessages.moveToFolder,
			onClick: dojo.hitch(this, '_handleMoveToFolderClick'),
			imgClass: icon,
			iconClass: icon,
			enabled: this.userCanEdit()
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._moveToFolderButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._moveToFolderButton);
			this._toDestroy.push(this._moveToFolderButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addCopyArtifactAction: function(toolbar, altTitle){
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'copyCommand',
			args = {
			title: altTitle || this._abstractMessages.duplicateArtifact,
			onClick: dojo.hitch(this, '_handleCopyArtifact'),
			imgClass: icon,
			iconClass: icon,
			enabled: this.userCanEdit()
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._copyArtifactButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._copyArtifactButton);
			this._toDestroy.push(this._copyArtifactButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},
	
	_addCollectionCompareButton: function(toolbar) {
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'collection-compare-icon',
			args = {
			title: this._abstractMessages.collectionCompare,
			onClick: dojo.hitch(this, '_handleCollectionCompareClicked'),
			imgClass: icon,
			iconClass: icon
		};
		if(this._shouldAddToMain(toolbar)) {
			this._addHidingClass(toolbar, args, 'main');
			this._collectionCompareButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._collectionCompareButton);
			this._toDestroy.push(this._collectionCompareButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			this._addHidingClass(toolbar, args, 'more');
			args.label = args.title;
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			this._toDestroy.push(menuItem);
		}
	},

	_addDeleteArtifactAction: function(toolbar){
		if(!toolbar) { toolbar = 'main'; }
		var icon = 'delete-icon',
			buttons = [],
			args = {
			title: this._abstractMessages.deleteResource,
			onClick: dojo.hitch(this, '_handleDeleteResourceLinkClick'),
			imgClass: icon,
			iconClass: icon,
			enabled: this.userCanEdit()
		};
		
		if(this._shouldAddToMain(toolbar)) {
			this._deleteResourceButton = new jazz.ui.toolbar.Button(args);
			this._actionsToolbar.addChild(this._deleteResourceButton);
			buttons.push(this._deleteResourceButton);
			this._toDestroy.push(this._deleteResourceButton);
		}
		if(this._shouldAddToMore(toolbar)) {
			args.label = args.title;
			this._moreActionsMenu.addChild(new dijit.MenuSeparator());
			var menuItem = new jazz.ui.menu.MenuItem(args);
			this._moreActionsMenu.addChild(menuItem);
			buttons.push(menuItem);
			this._toDestroy.push(menuItem);
		}
	
		this._enableDeleteArtifactButtonsIfAppropriate(buttons);
	},

	_addExternalIntegrationActionIfAppropriate: function() {
		// Removed by WI#: 86595
		return new dojo.Deferred();
	},

	_getArtifactTypeURI: function() {
		var artifactTypes = this.resource.getTypes();
		var artifactTypeURI;
		// Note: we only ever have one URI found in the object returned by getTypes() ...
		for (var artifactType in artifactTypes) {
			return artifactType;
		}
		return null;
	},

	_enableEditButtonIfAppropriate: function(editButton, lockInfo, deleteButton) {
		// summary:
		//		Enable the Edit button if the server tells us that the user
		//		should be able to at least one of the artifact's attributes.

		var determineLockStatus = dojo.hitch(this, function (lockInfo) {
			// enable the edit button, if either :
			// a)the artifact is not locked by anyone
			// b)the current user can release locks.
			// c)the current user holds the lock on this artifact.
			//
			// Note that this function is only invoked if the user is able
			// to edit the artifact, so if they can't none of these lock
			// considerations matter.
			if (!lockInfo || this.isReleaseLocksAllowed || lockInfo.byMe) {
				dojo.attr(editButton, {
					"disabled": false,
					"title": ""
				});
			} else {
				dojo.attr(editButton, "disabled", true);

				// Per wi 76418, disable the Delete button when the artifact is in edit mode.
				if (deleteButton) {
					deleteButton.set("enabled", false);
				}

				this._createLockedByOtherUserTooltipMessage(lockInfo).then(function(title){
					dojo.attr(editButton, "title", title);
				});
			}
		});

		var getModifyArtifactPermissionsDeferred = this.getModifyArtifactPermissions();
		getModifyArtifactPermissionsDeferred.addCallback(
			this,
			function(modifyArtifactPermissions){
				if (modifyArtifactPermissions.isModifyArtifactAllowed()) {
					this._isEditAllowed = true;
					determineLockStatus(lockInfo);
				} else {
					this._isEditAllowed = false;
					if (this.__lockButton) {
						this.__lockButton.set("enabled", "false");
					}
				}
				return modifyArtifactPermissions;
			}
		);

		return getModifyArtifactPermissionsDeferred;
	},

	_launchInEditModeIfAppropriate: function() {
		// summary:
		//		Start in edit mode if the server tells us that the user
		//		should be able to edit at least one of the artifact's attributes.
		var getModifyArtifactPermissionsDeferred = this.getModifyArtifactPermissions();
		getModifyArtifactPermissionsDeferred.addCallback(
			this,
			function(modifyArtifactPermissions){
				if (modifyArtifactPermissions.isModifyArtifactAllowed()) {
					this.onEdit();
				}
				return modifyArtifactPermissions;
			}
		);
	},

	_enableDeleteArtifactButtonsIfAppropriate: function(/*array*/buttons) {
		// summary:
		//		Enable the Delete toolbar button if the server tells us that
		//		the user should be able to perform a Delete (based on the
		//		process area assigned to this artifact as well as the
		//		artifact's type).
		var artifactTypeURI = this._getArtifactTypeURI();
		var isDeletedAllowedDeferred =
			ProcessOperationsCache.isDeleteInstanceOfArtifactTypeAllowed(
				this.resourceURI,
				this.projectURI,
				artifactTypeURI,
				this.resource.getProcessAreaURI() || this.projectURI
			);
		isDeletedAllowedDeferred.addCallback(this, function(isDeleteInstanceOfArtifactTypeAllowed){
			dojo.forEach(buttons, function(button){
				button.set('disabled', !isDeleteInstanceOfArtifactTypeAllowed);
			});
			return isDeleteInstanceOfArtifactTypeAllowed;
		});
	},

	_enableQuickPrintButtonsIfAppropriate: function(/*array*/ buttons) {
		// summary:
		//		Enable the quick print toolbar items if the server tells us that
		//		the user should be able to perform a quick print (based on the
		//		process area assigned to this artifact).
		var artifactTypeURI = this._getArtifactTypeURI();
		var isQuickPrintAllowedDeferred =
			ProcessOperationsCache.isQuickPrintAllowed(
				this.getProcessAreaURI(),
				this.projectURI
			);
		isQuickPrintAllowedDeferred.addCallback(this, function(isQuickPrintAllowed){
			if (isQuickPrintAllowed) {
				dojo.forEach(buttons, function(button){
					button.set('disabled', false);
				});
			}
			return isQuickPrintAllowed;
		});
	},

	_addOpenCurrentVersionAction: function(){
		var button = new jazz.ui.toolbar.Button({
			title: this._abstractMessages.openCurrentVersion,
			onClick: dojo.hitch(this, '_handleOpenCurrentVersionClicked'),
			imgClass: "open-current-version-icon"
		});
		this._actionsToolbar.addChild(button);
		this._toDestroy.push(button);
		return button;
	},

	_addRestorePreviousAction: function(isAllowed){
		//Disable by default
		this._restoreVersionButton = new jazz.ui.toolbar.Button({
			title: dojo.string.substitute(this._abstractMessages.restoreVersion, [""]),
			onClick: dojo.hitch(this, '_doRestoreVersion'),
			imgClass: "open-previous-version-icon",
			enabled: false
		});
		this._restoreVersionButton.set("isAllowed", isAllowed);

		this._actionsToolbar.addChild(this._restoreVersionButton);
		this._toDestroy.push(this._restoreVersionButton);
		return this._restoreVersionButton;

	},

	_updateRevisionInHistory: function(revisionDateLabel, revisionID, isLast, latestETag, baselineURI){
		this._historyViewerLatestETag = latestETag;
		if (revisionDateLabel && revisionID) {
			if (this._actionsToolbar && this._restoreVersionButton && this._restoreVersionButton.get("isAllowed")) {
				this._restoreVersionButton.set("title", dojo.string.substitute(this._abstractMessages.restoreVersion, [revisionDateLabel]));

				if (isLast && !baselineURI) {
					this._restoreVersionButton.set("enabled", false);
				}
				else {
					this._restoreVersionButton.set("enabled", true);
				}
				// WI: 73661. Export should only be enabled for current revision.
				if(this._exportButton) {
					this._exportButton.set("enabled", (isLast ? true : false));
				}
			}
			this.revision = revisionID;
			this._revisionDateLabel = revisionDateLabel;
		} else {
			if (this._restoreVersionButton) {
				this._restoreVersionButton.set("enabled", false);
			}
		}
	},

	_doRestoreVersion: function(){
		var restoreFunction = function(){
			if (!this._restoreVersionAction) {
				this._restoreVersionAction = new com.ibm.rdm.web.history.RestoreVersionAction({
					resourceURI: this.resourceURI
				});
			}

			this._restoreVersionAction.restore({
				revision: this.revision,
				revisionDate: this._revisionDateLabel,
				latestETag: this._historyViewerLatestETag,
				baselineURI: this.baselineURI,
				isModuleArtifact: this.isModuleArtifact
				});
		};

		var msgForm = new com.ibm.rdm.web.common.MessageForm({
			confirmMessage: this._abstractMessages["confirmRestoreMessage"],
			dialogTitle: this._abstractMessages["confirmRestore"],
			dialogStyle: "yesNo",
			onOk: dojo.hitch(this, restoreFunction)
		});
		this._toDestroy.push(msgForm);
		msgForm.show();
	},

	_getLockingURI: function() {
		// summary:
		//		Returns the uri to use for locking this; in most cases, the resource URI.
		//		But when editing a module artifact, need to look up the bound artifact.

		if (this.isModuleArtifact) {
			return this.resource.getBoundArtifact();
		}
		return this.resourceURI;
	},

	_getSidebarWidgets: function() {
		// summary:
		//		Return an array of the sidebar widgets that are active for this widget.
		//		Subclasses should override as necessary.

		var widgets = [];
		widgets.push(this._overviewSidebar);
		widgets.push(this._commentsSidebar);
		widgets.push(this._linksSidebar);

		return widgets;

	},

	_handleArtifactContentChanged: function() {
		// summary:
		//		The content for this widget's artifact has changed.  Handle refresh of this widget and
		//		see if the sidebar widgets associated to this widget need to respond to the change.

		this.handleRefresh();
		var sidebarWidgets = this._getSidebarWidgets();
		// TODO: Should use an interface here for Sidebar Widgets that would
		// define methods sidebar widgets are supposed to implement, one being
		// _handleArtifactContentChanged
		for (var i=0; i<sidebarWidgets.length; i++) {
			var sidebarWidget = sidebarWidgets[i];
			if (sidebarWidget.handleArtifactContentChanged) {
				sidebarWidget.handleArtifactContentChanged();
			}
		}
	},

	_handleNextGenEditorClicked: function() {
		UserPreferencesClient
			.savePreference(UserPreferenceNames.NEXT_GENERATION_EDITOR_ENABLED, !this._isNextGenEditorPressed(), this.projectURI).then(
				dojo.hitch(this, function(response) {
					window.location.reload();
					return response;
				}),
				dojo.hitch(this, function(error) {
					return error;
				})
		);
	},

	_handleBasePropertiesClicked: function() {
		this._showBaseProperties = !this._showBaseProperties;
		this._basePropertiesButton.set('pressed', this._showBaseProperties);
		
		if(this._basePropertiesMenuItem) {
			this._basePropertiesMenuItem.set('selected', this._showBaseProperties);
		}

		// Temporarily disable the base properties button while processing for the action is occurring.
		// Fixes Clicking on Include links, tags and comments from base artifacts option twice displays the comments for base artifacts (74678).
		// Module editor will enable the button via event notification after the module contents is loaded.  For Modulefact editor, we use a timeout
		// since we can't easily tell when all the deferreds for comments, links and tags loading have completed.
		this._basePropertiesButton.set('enabled', false);
		if (this.isModulefactViewer()) {
			window.setTimeout(dojo.hitch(this, function() {
				this._basePropertiesButton.set('enabled', true);
			}), 1000);
		}

		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SHOW_BASE_PROPERTIES,
			resourceUriScope: this.getResourceURI(),
			show: this._showBaseProperties
		});
	},

	_handleExportClicked: function(args) {
		var form = new com.ibm.rdm.web.viewer.ExportForm({
			resourceURI : this.resourceURI,
			resourceTitle : this.getArtifactTitle(),
			contentType : this.resource.getMimeType(),
			format: args.format ? args.format : "pdf",
			projectURI: this.projectURI,
			baselineURI: this.baselineURI
		});
		this._toDestroy.push(form);
		form.show();
	},

	_handleExportArtifactsClicked: function() {
		// stub function called when csv export button clicked
	},

	_createReview: function() {
		com.ibm.rdm.web.review.reviewutils.createNewReview(
			this.projectURI,
			[ this.resourceURI ]
		);
	},

	_handleLockClicked: function() {
		var lockInfo = this.lockInfo;

		var deferred;

		if ( (lockInfo && (lockInfo.byMe || this.isReleaseLocksAllowed)) ) {
			this._releaseLockAndRefreshView(true);
		} else {
			StatusDisplay.showStatusMessage(this._abstractMessages["acquiringLock"]);
			deferred = LockManager.lockResource(this._getLockingURI(), true);
			// TODO - this would probably be better expressed with callback and errback,
			// however LockManager does an addBoth and does not return or throw errors
			deferred.addBoth(this, function (lockStatus) {
				StatusDisplay.hideStatusMessage();
				this._updateLockBoundControls();
				if (!lockStatus || !lockStatus.obtained) {
					if (this.isReleaseLocksAllowed) {
						// the user action was to acquire the lock, so if they have permission to do so,
						// go ahead and warn them once...
						LockManager.showReleaseWarningMessage([lockStatus],
							dojo.hitch(this, function() {
									// when the user presses OK,  override the lock
									LockManager.overrideLock(this._getLockingURI()).addCallback(this, function() {
										// get our lock icon up to date.
										this._updateLockBoundControls();
									});
							})
						);
					} else {
						// otherwise, this will show them a page level message informing them someone else
						// has the lock, and there isn't anything this user can do.
						LockManager.showLockedMessage(LockManager.MSG_LOCK, lockStatus, this.getProcessAreaURI(), this.projectURI, ProcessOperationsCache);
					}
				}


			});
		}
	},

	_handleCreateReviewClicked: function() {
		var saveAndThenCreateReview = dojo.hitch(this, function() {
			this.saveResource(false).addCallback(this, function(response){
				this._createReview();
				return response;
			});
		});

		if (this.isDirty()){
			var messageForm = new com.ibm.rdm.web.common.MessageForm({
				confirmMessage: this._abstractMessages["mustBeSavedBeforeCreatingReview"],
				dialogTitle: this._abstractMessages.artifactModified,
				dialogStyle: "okCancel",
				onOk: saveAndThenCreateReview
			});
			this._toDestroy.push(messageForm);
			messageForm.show();
		}
		else{
			this._createReview();
		}
	},

	_handleAddToCollectionClicked: function() {
		// summary:
		//		Invoked when the "Add to Collection" menu item
		//		is selected.
		var resourceURIToAdd = this.resourceURI;

		var excludeCurrentMembershipsDeferred =
			com.ibm.rdm.web.server.client.utils.ResourceUtil
				.getArtifactCollectionMembership(resourceURIToAdd);

		excludeCurrentMembershipsDeferred.addCallback(this, function(currentCollectionURIs){

			var collectionPicker;
			var addToCollections = dojo.hitch(this, function(selectedCollections) {

				collectionPicker.displayInfoMessage(this._abstractMessages.addingToCollection);
				var collectionsToBeSaved = selectedCollections.length;
				var collectionTitles = null;

				var onCollectionRetrieved = dojo.hitch(this, function(collection) {

					var currentURIs = collection.getArtifactURIs();

					// Gotta make sure we're not already a member...
					if (dojo.indexOf(currentURIs, resourceURIToAdd) === -1) {
						currentURIs.push(resourceURIToAdd);
						collection.setArtifactURIs(currentURIs);
						var saveDeferred = collection.save({refreshAfterSave: false});
						saveDeferred.addCallback(this, function(saveResponse){
							collectionsToBeSaved --;
							// notify the collection section in the sidebar until the artifact
							// has been added to all the collections selected
							if(collectionsToBeSaved === 0 ){
								setTimeout(dojo.hitch(this, function(){
									com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
										eventTopic: com.ibm.rdm.web.notifications.EventTopics.LINK_IN_COLLECTION_CREATED,
										resourceUriScope: resourceURIToAdd
									});
								}), 250);
							}
							collectionPicker.displayOkMessage(this._abstractMessages.addedToCollection, [collectionTitles]);
						});
						saveDeferred.addErrback(this, function(error) {
							collectionPicker.displayMessage(7338);
						});
					}
					return collection; // in case we're chained
				});

				var addToCollection = dojo.hitch(this, function(collectionInfo) {
					var collectionDeferred =
						com.ibm.rdm.web.model.resources.ResourceManager.get({
						resourceURI: collectionInfo.resourceURI
					});
					collectionTitles = collectionTitles
						? collectionTitles + ", " + collectionInfo.getTitle()
						: collectionInfo.getTitle();
					collectionDeferred.addCallback(this, onCollectionRetrieved);
				});

				dojo.forEach(selectedCollections, addToCollection, this);
			});
			var newArtifactFormat = com.ibm.rdm.web.model.types.RRMTypes
				.getArtifactFormats(this.projectURI)["Collection"];
			var params = {
				projectURI: this.projectURI,
				baselineURI: this.baselineURI,
				resourceURI: this.resourceURI,
				selectionOptions: {
					selectArtifactFormat: ["Collection"],
					displayArtifactCreation: true,
					newArtifactFormat: newArtifactFormat			},
				style: com.ibm.rdm.web.picker.ArtifactPickerForm.formStyle.ADD_CLOSE,
				filterArtifacts: currentCollectionURIs,
				description: this._abstractMessages.addToCollectionDialogDesc,
				summary: this._abstractMessages.addToCollectionDialogDesc,
				title: this._abstractMessages.addToCollectionDialogTitle,
				onAddArtifacts: addToCollections,
				onAddCallbackScope: this,
				surrenderClose: false,
				pauseOnAddAndClose: true,
				disablePickerModuleReuseMode: true
			};

			collectionPicker = new com.ibm.rdm.web.picker.ArtifactPickerForm(params);
			collectionPicker.show();

			this._toDestroy.push(collectionPicker);

			return currentCollectionURIs;
		});
	},

	_handleCreateArtifactTemplateClicked: function() {
		var artifactTypeURI = null;
		if (this.resource) {
			var types = this.resource.getTypes();
			for (var type in types) {
				artifactTypeURI = types[type];
				break;
			}
		}
		var createArtifactTemplate = dojo.hitch(this, function(/*String?*/revision) {
			var form = new com.ibm.rdm.web.viewer.NewArtifactTemplateForm({
				projectURI: this.projectURI,
				resourceURI: this.resourceURI,
				artifactName: this.getArtifactTitle(),
				artifactTypeURI: artifactTypeURI,
				artifactFormatURI: this.resource.getMimeType(),
				viewType: com.ibm.rdm.web.viewer.NewArtifactTemplateForm.VIEW_TYPE.CreateArtifactTemplateUsingPresetArtifact
			});
			this._toDestroy.push(form);
			form.show();
		});
		var saveAndThenCreateArtifactTemplate = dojo.hitch(this, function() {
			// Note: RictTextArtifactEditor uses an ARTIFACT_SAVED ChangeNotifier event
			// to make a ckEditor.focus() call ... which means we can't make use of
			// onSave's returned deferred (as this deferred is callback'd BEFORE the
			// ChangeNotifier is told to issue a new ARTIFACT_SAVED event.
			var saveListener;
			var onArtifactSaved = function(event) {
				var savedResourceURI = event.notifierParams.resourceURI;
				if (savedResourceURI === this.resourceURI) {
					com.ibm.rdm.web.notifications.ChangeNotifier.removeListener(saveListener);
					// Note: RichTextArtifactEditor's _updateAfterSave function
					// is competing with us ... it issues a ckEditor.focus();
					// call just before this onArtifactSaved is invoked and
					// this call results in grabbing focus from the dialog
					// that createArtifactTemplate does a 'show' on.  As a
					// workaround we wrap the call to createArtifactTemplate
					// in a setTimeout ...
					window.setTimeout(dojo.hitch(this, function(){
						createArtifactTemplate(
							this.resource.getRevision());
					}), 200);
				}
			};
			saveListener = com.ibm.rdm.web.notifications.ChangeNotifier.addListener({
				eventTopics: [com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED],
				callbackFunction: onArtifactSaved,
				callbackScope: this,
				projectURI: this.projectURI
			});
			this._listeners.push(saveListener);
			this.onSave();
		});
		if (this.isDirty()) {
			// Note: We require the user to Save before creating a new artifact template.
			// The reason for this is that we need the content links to be in alignment
			// with the current artifact content.  For example, if the user just used
			// the "Insert Image" action, the Link instance would be created but the
			// associated IMG element would not yet be found in the HEAD revision.
			// Therefore if the user elects to "Cancel" saving, we DO NOT go down the
			// path of artifact template creation (i.e. because the Link instance(s)
			// may be out of sync with the artifact's HEAD content).
			var messageForm = new com.ibm.rdm.web.common.MessageForm({
				confirmMessage: this._abstractMessages["mustBeSavedBeforeCreatingTemplate"],
				dialogTitle: this._abstractMessages.artifactModified,
				dialogStyle: "okCancel",
				dialogWidth: 250,
				onOk: saveAndThenCreateArtifactTemplate
			});
			this._toDestroy.push(messageForm);
			messageForm.show();
		} else {
			createArtifactTemplate();
		}
	},

	_handleOpenHistoryClicked: function() {
		var args = {"isRemoveFromCache":true,
					"isOpenInHistory":true},
			uri = this.resourceURI;

		com.ibm.rdm.web.common.ResourceLinksHandler.showInternalResource(uri, args);
	},

	_handleOpenCurrentVersionClicked: function() {
		com.ibm.rdm.web.common.ResourceLinksHandler.showInternalResource(this.resourceURI, {"isRemoveFromCache":true});
	},

	_handleMoveToFolderClick: function() {
		// summary:
		//		Called when the "Move to Folder" option of an artifact is selected.
		var onGetMoveResult = dojo.hitch(this, function(folderURI){
			return com.ibm.rdm.web.server.client.utils.ResourceUtil.moveToFolder(
					this.projectURI,
					this.resourceURI,
					folderURI);
		});

		var picker = new com.ibm.rdm.web.picker.MoveFolderPicker({
			projectURI: this.projectURI,
			currentName: this.getArtifactTitle(),
			onGetMoveResult: onGetMoveResult,
			currentFolderURI: this.resource.getParentResourceURI(),
			isMultiMove: false,
			artifactTypeURI: this._getArtifactTypeURI()
		});
		this._toDestroy.push(picker);
		picker.show();
	},

	_handleCopyArtifact: function (/*boolean?*/showDuplicationPickerInCopyDialog) {
		// summary:
		//		Called when the "Copy to Folder" option of an artifact is selected.
		var copyArtifact = dojo.hitch(this, function(/*folderURI*/folderURI,
									/*String*/copyName,
									/*Boolean*/doDuplicateLinks, /*Object?*/moduleCopyPolicy)
		{
			var objectType = null;
			for (var type in this.resource.getTypes()) {
				objectType = type;
				break;
			}

			var wrappedResourceURI = null;
			if (this.resource.getWrappedResourceURI) {
				wrappedResourceURI = this.resource.getWrappedResourceURI();
			}

			var afterCopyDeferred =
				com.ibm.rdm.web.server.client.utils.ResourceUtil.copyToFolder({
					resourceURI: this.resourceURI,
					projectSnapshotURI: this.baselineURI,
					projectURI: this.projectURI,
					copiedName: copyName,
					folderURI: folderURI,
					revision: this.resource.getRevision(),
					reviewURI: this.reviewId,
					contentType: this.resource.artifactFormat,
					wrappedResourceURI: wrappedResourceURI,
					objectType: objectType,
					doDuplicateLinks: doDuplicateLinks,
					moduleCopyPolicy: moduleCopyPolicy,
					fromArtifactName: this.getArtifactTitle(),
					fromArtifactIdentifier: this.getArtifactIdentifier()
				});
			afterCopyDeferred.addCallback(this, function(resourceURI){
				com.ibm.rdm.web.viewer.viewerutils.openResourceUsingAppropriateViewer(resourceURI);
			});
			return afterCopyDeferred;
		});

		var picker = new com.ibm.rdm.web.picker.CopyFolderPicker({
			projectURI: this.projectURI,
			currentName: this.getArtifactTitle(),
			onGetCopyResult: copyArtifact,
			currentFolderURI: this.resource.getParentResourceURI(),
			artifactTypeURI: this.artifactTypeURI,
			entityType: this.contentType,
			copiedResourceProcessAreaURI: this.resource.getProcessAreaURI()
		});
		this._toDestroy.push(picker);
		picker.show();
	},

	_handleDeleteResourceLinkClick: function() {
		var wrappedResourceURI = null;
		if (this.resource.getWrappedResourceURI) {
			wrappedResourceURI = this.resource.getWrappedResourceURI();
		}
		com.ibm.rdm.web.server.client.utils.ResourceUtil.deleteResource(
			this.resourceURI, this.projectURI,
			this.getArtifactTitle(), wrappedResourceURI, false,
			this.resource.getEntityType() === com.ibm.rdm.web.model.types.RRMTypes.getArtifactFormats(this.projectURI)["Module"]
		);
	},

	_loadProjectPermissions: function() {
		var projectOperationsDeferred =
			com.ibm.rdm.web.common.ProjectCache.getProjectPermissions(this.projectURI);
		projectOperationsDeferred.addCallback(this, function(projectOperations){
			this._projectOperations = projectOperations;
			return projectOperations;
		});
		return projectOperationsDeferred;
	},

	/*
	 * End of toolbar related methods
	 */
	 _createBreadcrumbLink: function(resourceURI){
		var uri = "#";
		var SELF = com.ibm.rdm.web.common.PublicTagsParser.SELF;

		if (resourceURI.indexOf(com.ibm.rdm.web.FRONTING_SERVICE_FOLDERS) !== -1){
			if (this.baselineURI){
				uri = "#action=com.ibm.rdm.web.pages.showProjectHistory&projectURI="
					+ encodeURIComponent(this.projectURI)+"&baselineURI="+encodeURIComponent(this.baselineURI)
					+ "&folderId=" + com.ibm.rdm.web.util.queryutils.getLastPathSegment(resourceURI);
			}
			else{
				uri = "#action=com.ibm.rdm.web.pages.showProjectDashboard&projectURI="
					+ encodeURIComponent(this.projectURI) + "&folderId=" + com.ibm.rdm.web.util.queryutils.getLastPathSegment(resourceURI);
			}
		}

		return uri;
	},

	_replaceMainContent: function(widget){
		// summary:
		//		Method to replace the main content node.
		dojo.place(widget.domNode, this._contentPane.domNode, "replace");
		this._contentPane = widget;
	},

	_onArtifactMoved: function(/*notifierParams*/eventParams){
		// summary:
		//		This is a callback that is called when a move operation has
		//		occurred on an artifact.
		var newFolderURL = eventParams.notifierParams.folderURI;
		var questionMarkIndex = newFolderURL.indexOf("?");
		var resourceShortName = (
					questionMarkIndex === -1 ?
					newFolderURL :
					newFolderURL.substring(0, questionMarkIndex));

		this.resource.parentResourceURI = resourceShortName;
		this.getBreadcrumbs(true);
	},

	_onRenamed: function(/*notifierParams*/eventParams){
		this.resource.setDescription(eventParams.notifierParams.notifyResource.getDescription());
		this._updateDisplayDescription(eventParams.notifierParams.notifyResource.getDescription());

		this.resource.setTitle(eventParams.notifierParams.notifyResource.getTitle());
		this._updateDisplayTitle();
		this.revision = eventParams.notifierParams.notifyResource.getRevision();
		this._overviewSidebar.loadModifiedInfo();
	},

	_onProcessAreaChanged: function(/*notifierParams*/eventParams){
		var processAreaURI = eventParams.notifierParams.processAreaURI;
		this.resource.setProcessAreaURI(processAreaURI);
		this._updateTeamOwnershipField(processAreaURI);
	},

	_onObjectTypeChanged: function(/*notifierParams*/eventParams){
		var artifactTypeUri = this.resource.getType();
		var format = this.resource.getMimeType();
		this.headerIconImgNode = com.ibm.rdm.web.common.ArtifactIcons.getLargeImage(this.projectURI, artifactTypeUri, format);
		if (this.updateLayoutTitle && dojo.isFunction(this.updateLayoutTitle)){
			this.updateLayoutTitle();
		}
	}
});


com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType = {
	ShowArtifact: 0,
	ShowArtifactHistory: 1,
	ShowArtifactInReviewContext: 2
};

})();
