/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardColumnsAndLimitsViewConfiguration");

dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.TreeViewConfiguration");
dojo.require("dojo.string");

(function() {
var TreeViewConfiguration= com.ibm.team.apt.shared.ui.internal.viewmodes.TreeViewConfiguration;
var string= dojo.string;

var BoardColumnsAndLimitsViewConfiguration= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardColumnsAndLimitsViewConfiguration", TreeViewConfiguration, {

	//fConfig: null,

	//fUpdatedConfig: null,

	//fNewBoard: null,

	//fUpdated: null,

	constructor: function(config, factory) {
		this.inherited(arguments, [config]);
		this.fUpdated= false;
		this.fConfig= config;
		this.fUpdatedConfig= factory.newElement(this.fConfig);
		this.fNewBoard= BoardColumnsAndLimitsViewConfiguration.computeNewBoard();
	},

	getConfiguration: function() {
		return this.fConfig;
	},

	getUpdatedConfiguration: function() {
		if (this.fUpdated) {
			return this.fUpdatedConfig;
		}
		return null;
	},

	isNewBoard: function() {
		return this.fNewBoard;
	},

	getContainerColor: function(container) {
		return this.getValue(container.getItem().getLabel() + BoardColumnsAndLimitsViewConfiguration.COLOR_CONFIG_KEY);
	},

	setContainerColor: function(container, color) {
		this.updateConfiguration(container.getItem().getLabel() + BoardColumnsAndLimitsViewConfiguration.COLOR_CONFIG_KEY, color);
	},

	removeContainerColor: function(container) {
		this.updateConfiguration(container.getItem().getLabel() + BoardColumnsAndLimitsViewConfiguration.COLOR_CONFIG_KEY, null);
	},

	isContainerExists: function(container) {
		return this.getBooleanValue(container.getItem().getLabel(), true);
	},

	addContainer: function(container) {
		this.updateConfiguration(container.getItem().getLabel(), "true");
	},

	removeContainer: function(container) {
		this.updateConfiguration(container.getItem().getLabel(), "false");
	},

	getBooleanValue: function(key, defaultValue) {
		var value= this.getValue(key);
		return value == null ? defaultValue : value === "true";
	},

	getValue: function(key) {
		return this.fUpdatedConfig.getParameter(key);
	},

	updateConfiguration: function(key, value) {
		this.fUpdatedConfig.setParameter(key, value);
		this.fUpdated= true;
	},

	/**
	 * Returns true if the stateGroup has been filtered out.
	 * 
	 * Default value is false (not filtered out).
	 * 
	 * @param stateGroup
	 *            The state group to test to.
	 */
	isStateGroupFiltered: function(stateGroup) {
		if (stateGroup == null) {
			return true;
		}
		return this.getBooleanValue(stateGroup.getId(), false);
	},

	/**
	 * Returns true if the state group should hide states
	 * 
	 * @param stateGroup
	 *            The state group to check
	 */
	isStateGroupHidingStates: function(stateGroup) {
		if (stateGroup == null) {
			return false;
		}
		return this.getBooleanValue(BoardColumnsAndLimitsViewConfiguration.createStateGroupHideKey(stateGroup), false);
	},

	/**
	 * Returns true if the state from the stateGroup has been filtered out.
	 * 
	 * Default value is false (not filtered out).
	 * 
	 * @param stateGroup
	 *            The state group that the state belong to.
	 * @param stateLabel
	 *            The state to test to.
	 */
	isStateFiltered: function(stateGroup, stateLabel) {
		if (stateGroup == null || stateLabel == null) {
			return true;
		}
		return this.getBooleanValue(BoardColumnsAndLimitsViewConfiguration.createStateKey(stateGroup, stateLabel), false);
	},

	/**
	 * Filter the stateGroup according to isFiltered value.
	 * 
	 * @param stateGroup
	 *            The state group to be filtered.
	 * @param isFiltered
	 *            The filter value.
	 */
	filterStateGroup: function(stateGroup, isFiltered) {
		this.updateConfiguration(stateGroup.getId(), isFiltered ? "true" : "false");
	},

	/**
	 * Determines if the states under a state group should be hidden
	 * 
	 * @param stateGroup
	 *            The state group to be filtered.
	 * @param hideStates
	 *            True means that states should be hidden, false otherwise
	 */
	hideStateGroupStates: function(stateGroup, hideStates) {
		if (stateGroup == null) {
			console.error("Cannot hide states from a null state group");
		} else {
			this.updateConfiguration(BoardColumnsAndLimitsViewConfiguration.createStateGroupHideKey(stateGroup), hideStates ? "true" : "false");
		}
	},

	/**
	 * Filter the state according to isFiltered value.
	 * 
	 * @param stateGroup
	 *            The state group to be filtered.
	 * @param stateLabel
	 *            The state to filter to.
	 * @param isFiltered
	 *            The filter value.
	 */
	filterState: function(stateGroup, stateLabel, isFiltered) {
		this.updateConfiguration(BoardColumnsAndLimitsViewConfiguration.createStateKey(stateGroup, stateLabel), isFiltered ? "true" : "false");
	}
});

BoardColumnsAndLimitsViewConfiguration.STATE_GROUP_HIDE_KEY= "State Group <${0}> No States";
BoardColumnsAndLimitsViewConfiguration.STATE_KEY= "${0}-${1}";
BoardColumnsAndLimitsViewConfiguration.computeNewBoard= function() {
	if (!dojo.isBrowser) {
		return false;
	}
	var value= null;
	var queryString= window.location.search;
	if (queryString != null && queryString.length > 0) {
		queryString= queryString.charAt(0) === "?" ? queryString.substring(1) : queryString;
		var queryParams= dojo.queryToObject(queryString);
		value= queryParams["newboard"];
	}
	return value == null || dojo.isArray(value) ? true : value === "true";
};
BoardColumnsAndLimitsViewConfiguration.COLOR_CONFIG_KEY= ":CONFIG";
BoardColumnsAndLimitsViewConfiguration.isNewBoardConfiguration= function(config) {
	return BoardColumnsAndLimitsViewConfiguration.computeNewBoard();
};
BoardColumnsAndLimitsViewConfiguration.isNewBoardConfiguration2= function() {
	return BoardColumnsAndLimitsViewConfiguration.computeNewBoard();
};
BoardColumnsAndLimitsViewConfiguration.createStateGroupHideKey= function(stateGroup) {
	return string.substitute(BoardColumnsAndLimitsViewConfiguration.STATE_GROUP_HIDE_KEY, [stateGroup.getId() ]);
};
BoardColumnsAndLimitsViewConfiguration.createStateKey= function(stateGroup, stateLabel) {
	return string.substitute(BoardColumnsAndLimitsViewConfiguration.STATE_KEY, [stateGroup.getId() , stateLabel]);
};

})();
