/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode");

dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.IResolvedPlan");
dojo.require("com.ibm.team.apt.shared.client.internal.RankingMode");
dojo.require("com.ibm.team.apt.shared.client.internal.model.attributes.NewRankingAttribute");
dojo.require("com.ibm.team.apt.shared.client.internal.model.attributes.RankingAttribute");
dojo.require("com.ibm.team.apt.shared.ui.internal.columns.BoardColumnProvider");
dojo.require("com.ibm.team.apt.shared.ui.internal.utils.MoveResponse");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardCardMoveHandler");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.BoardColumnsAndLimitsViewConfiguration");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.ScrumBoardViewMode");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag");
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IColumn");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.apt.shared.ui.internal.viewmodes", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.shared.ui.internal.viewmodes", "Messages");

var team= com.ibm.team;
var apt= team.apt;
var client= apt.api.client;
var IPlanItem= client.IPlanItem;
var IResolvedPlan= client.IResolvedPlan;
var shared= apt.shared;
var internal= shared.client.internal;
var RankingMode= internal.RankingMode;
var attributes= internal.model.attributes;
var Value2= attributes.NewRankingAttribute.Value;
var Value= attributes.RankingAttribute.Value;
var internal2= shared.ui.internal;
var BoardColumnProvider= internal2.columns.BoardColumnProvider;
var MoveResponse= internal2.utils.MoveResponse;
var viewmodes= internal2.viewmodes;
var BoardCardMoveHandler= viewmodes.BoardCardMoveHandler;
var BoardColumnsAndLimitsViewConfiguration= viewmodes.BoardColumnsAndLimitsViewConfiguration;
var ScrumBoardViewMode= viewmodes.ScrumBoardViewMode;
var ScrumBoardNode= ScrumBoardViewMode.ScrumBoardNode;
var ScrumboardElementSorter= ScrumBoardViewMode.ScrumboardElementSorter;
var ScrumboardNodeCreator= ScrumBoardViewMode.ScrumboardNodeCreator;
var model= team.rtc.foundation.api.ui.model;
var ColumnTag= model.ColumnTag;
var Unit= model.IColumn.Unit;

var TaskboardViewMode= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode", ScrumBoardViewMode, {

	//fTaskboardColumnProvider: null,

	constructor: function(planningClient, configuration, groupProvider, columnProvider, factory) {
		this.inherited(arguments, [planningClient, configuration, groupProvider, columnProvider, factory]);
		this.fTaskboardColumnProvider= columnProvider;
		this.setElementInfoCreator(new TaskboardNodeCreator(this));
	},

	createBoardConfiguration: function(configuration, factory) {
		return new TaskboardViewConfiguration(configuration, factory);
	},

	createComparator: function() {
		return new TaskboardElementSorter();
	},

	getConfiguration: function() {
		return this.fConfig;
	},

	doRefreshContent: function(updateAccessor, elementInfos) {
		if (this.fConfig.isNewBoard()) {
			this.addStateEntries(updateAccessor, elementInfos);
		}
		this.inherited("doRefreshContent", arguments, [updateAccessor, elementInfos]);
	},

	addStateEntries: function(updateAccessor, elementInfos) {
		var $subject= elementInfos;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var elementInfo= $subject[$count];
			if (this.includeInView(elementInfo)) {
				var groupId= this.fGroupProvider.getGroupId(elementInfo);
				var path= null;
				if (groupId != null) {
					path= this.getGroupPath(groupId);
				} else {
					path= [];
				}
				path.push(this.getTopLevelContainer(elementInfo));
				this.addStateEntry(updateAccessor, path);
			}
		}
	},

	/**
	 * Determines whether the given element should be added to the ViewModel.
	 * 
	 * For the general case, defaults to the super implementation. For the case
	 * where the element's top-level container (story) has an undefined state group,
	 * hide the element.
	 */
	includeInView: function(elementInfo) {
		var isTopLevel= elementInfo.isIsTopLevel();
		if (this.getStateGroup(elementInfo.getPlanElement()) == null) {
			return false;
		}
		if (!isTopLevel) {
			var topLevelElement= this.getTopLevelContainer(elementInfo).getTopLevelElement();
			if (topLevelElement != null && this.getStateGroup(topLevelElement) == null) {
				return false;
			}
			if (this.isStateOrStateGroupExcluded(elementInfo.getPlanElement())) {
				return false;
			}
			if (this.isCrossProjectItem(elementInfo.getPlanElement()) && this.isCrossProjectItemFiltered(elementInfo.getPlanElement())) {
				return false;
			}
		}
		var inclusion= elementInfo.getAttributeValue(IPlanItem.INCLUSION);
		return inclusion.isIncluded() || this.isChildInView(elementInfo);
	},

	isChildInView: function(elementInfo) {
		var references= elementInfo.getAttributeValue(this.fReferenceAttribute);
		var $subject2= references.getReferences();
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var reference= $subject2[$count2];
			var childHandle= reference.getLink().getItemHandle(reference.getEndpoint());
			var planModel= elementInfo.getPlanElement().getPlanModel();
			var childElement= planModel.getPlanElement(childHandle.getItemId());
			if (childElement != null && childElement.getAttributeValue(IPlanItem.INCLUSION).isIncluded()) {
				return true;
			}
		}
		return false;
	},

	modifyElement: function(updater, elementInfo, remove) {
		var stateGroup= this.getStateGroupColumn(elementInfo);
		if (stateGroup == null) {
			this.inherited("modifyElement", arguments, [updater, elementInfo, remove]);
			return ;
		}
		var planElement= elementInfo.getPlanElement();
		var container= this.getTopLevelContainer(elementInfo);
		var isTopLevel= elementInfo.isIsTopLevel();
		var groupElementPaths= this.getGroupElementPaths([planElement]);
		var $subject3= groupElementPaths;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var groupElementPath= $subject3[$count3];
			if (!isTopLevel || this.fTaskboardColumnProvider.fTopLevelItemColumn == null) {
				var path= [];
				Array.prototype.push.apply(path, groupElementPath);
				path.push(container);
				path.push(stateGroup);
				if (!this.fConfig.isStateGroupHidingStates(stateGroup.getColumnDescriptor().getStateGroup())) {
					Array.prototype.push.apply(path, this.getSubColumnsPath(elementInfo));
				}
				var groupId= null;
				if (groupElementPath.length > 0) 
					groupId= groupElementPath[groupElementPath.length - 1].getGroupElementIdentifier();
				this.doModifyElement(path, planElement, elementInfo.getChildrenResolveCallback(), groupId, remove, updater);
			}
			if (this.fTaskboardColumnProvider.fTopLevelItemColumn != null && container.getTopLevelElement() != null) {
				var path= [];
				Array.prototype.push.apply(path, groupElementPath);
				path.push(container);
				path.push(this.fTaskboardColumnProvider.fTopLevelItemColumn);
				var groupId= null;
				if (groupElementPath.length > 0) 
					groupId= groupElementPath[groupElementPath.length - 1].getGroupElementIdentifier();
				this.doModifyElement(path, container.getTopLevelElement(), null, groupId, remove, updater);
			}
		}
	},

	getTopLevelContainer: function(elementInfo) {
		var topLevelPath= elementInfo.computePaths()[0];
		var topLevelItem= topLevelPath.length > 1 ? topLevelPath[0] : null;
		var container= new TopLevelItemContainer(topLevelItem);
		return container;
	},

	createMoveHandler: function() {
		return new TaskBoardMoveHandler(this);
	}
});
var TaskboardNodeCreator= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskboardNodeCreator", ScrumboardNodeCreator, {

	constructor: function(viewMode) {
		this.inherited(arguments, [viewMode]);
	},

	newInstance: function(planElement, attributeValues) {
		return new TaskboardNode(this, planElement, attributeValues);
	}
});
var TaskboardNode= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskboardNode", ScrumBoardNode, {

	constructor: function(creator, planElement, attributeValues) {
		this.inherited(arguments, [creator, planElement, attributeValues]);
	},

	computePaths: function() {
		var path= [this.getPlanElement()];
		var topLevelParent= this.getTopLevelParent();
		if (topLevelParent != null) 
			path.unshift(topLevelParent.getPlanElement());
		return [path];
	},

	getTopLevelParent: function() {
		if (this.isIsTopLevel()) 
			return this;
		if (this.fParents.length > 0) {
			var elementInfo= this.fCreator.fromCache(this.fParents[0].getPlanElement());
			if (elementInfo != null) 
				return elementInfo.getTopLevelParent();
		}
		return null;
	},

	isIsTopLevel: function() {
		var type= this.getAttributeValue(IPlanItem.ITEM_TYPE);
		return (type == null) ? false : type.isTopLevel();
	}
});
var TaskBoardMoveHandler= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskBoardMoveHandler", BoardCardMoveHandler, {

	constructor: function(viewMode) {
		this.inherited(arguments, [viewMode]);
	},

	canMoveIntoEntry: function(candidateTarget) {
		if (candidateTarget.getElement() === this.getTopLevelItemColumn()) 
			return MoveResponse.DENY;
		return this.inherited("canMoveIntoEntry", arguments, [candidateTarget]);
	},

	canMoveEntry: function(source) {
		if (source.getElement() === this.getTopLevelItemColumn()) 
			return MoveResponse.DENY;
		return this.inherited("canMoveEntry", arguments, [source]);
	},

	getTopLevelParent: function(entry, readAccessor) {
		var containerEntry= readAccessor.getEntryNavigator(false).parentEntryOfType(entry, TopLevelItemContainer);
		if (containerEntry == null) 
			return null;
		return containerEntry.getElement().getTopLevelElement();
	},

	getTopLevelItemColumn: function() {
		return this.fViewMode.fTaskboardColumnProvider.getTopLevelItemColumn();
	}
});
var TaskboardElementSorter= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskboardElementSorter", ScrumboardElementSorter, {

	constructor: function() {
		this.inherited(arguments, []);
	},

	compare: function(e1, e2, readAccessor, forceResort) {
		var result= this.inherited("compare", arguments, [e1, e2, readAccessor, forceResort]);
		if (result === undefined) {
			var o1= e1.getElement();
			var o2= e2.getElement();
			var t1= o1 instanceof TopLevelItemContainer;
			var t2= o2 instanceof TopLevelItemContainer;
			if (t1 !== t2) {
				result= (t1 ? 0 : 1) - (t2 ? 0 : 1);
			} else if (t1 && t2) {
				var p1= o1.getTopLevelElement();
				var p2= o2.getTopLevelElement();
				if (p1 == null || p2 == null) {
					result= (p1 == null ? 1 : 0) - (p2 == null ? 1 : 0);
				} else {
					result= this.compareRank(p1, p2);
					if (result === 0) {
						var i1= p1.getAttributeValue(IPlanItem.ID);
						var i2= p2.getAttributeValue(IPlanItem.ID);
						result= i1 - i2;
					}
				}
			}
		}
		return result;
	},

	compareRank: function(p1, p2) {
		var value;
		var planModel= p1.getPlanModel();
		if (this.isExplicitRanking(planModel)) {
			value= this.getExplicitRank(p1).compareTo(this.getExplicitRank(p2));
		} else {
			value= this.getAttributeRank(p1).compareTo(this.getAttributeRank(p2));
		}
		return value;
	},

	isExplicitRanking: function(planModel) {
		var rankingMode= planModel.getAdapter(IResolvedPlan).getPlanRecord().getRankingMode();
		var explicitRanking= RankingMode.isExplicitRanking(rankingMode);
		return explicitRanking;
	},

	getAttributeRank: function(planElement) {
		var rank= planElement.getAttributeValue(IPlanItem.RANKING);
		if (rank == null) {
			rank= Value.UNRANKED;
		}
		return rank;
	},

	getExplicitRank: function(planElement) {
		var rank= planElement.getAttributeValue(IPlanItem.NEW_RANKING);
		if (rank == null) {
			rank= Value2.UNRANKED;
		}
		return rank;
	}
});
var TaskboardColumnProvider= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskboardColumnProvider", BoardColumnProvider, {

	//fTopLevelItemColumn: null,

	constructor: function(columns, columnContext) {
		this.inherited(arguments, [columns, columnContext]);
	},

	refreshScrumBoardHeader: function(boardConfiguration, descriptorFactory, groupProvider, updateAccessor) {
		this.inherited("refreshScrumBoardHeader", arguments, [boardConfiguration, descriptorFactory, groupProvider, updateAccessor]);
		var columns= this.getColumns();
		var stateGroupColumnList= columns.getStateGroupColumnList();
		if (boardConfiguration.getParentLabel() != null) {
			this.fTopLevelItemColumn= stateGroupColumnList.addColumnAtFront(TaskboardColumnProvider.PARENT_COLUMN_ID, boardConfiguration.getParentLabel(), null, false, null, updateAccessor);
			this.fTopLevelItemColumn.setSize({size: TaskboardViewMode.PARENT_COLUMN_WIDTH, unit: Unit.em}, null, 1, updateAccessor);
		}
	},

	provideColumnInfo: function(viewEntry, readAccessor) {
		if (viewEntry.getElement() instanceof TopLevelItemContainer) {
			return new ColumnTag(null, null);
		}
		return this.inherited("provideColumnInfo", arguments, [viewEntry, readAccessor]);
	},

	getTopLevelItemColumn: function() {
		return this.fTopLevelItemColumn;
	}
});
var TopLevelItemContainer= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TopLevelItemContainer", null, {
	"-chains-": { constructor: "manual" },

	//fId: null,

	//fTopLevelElement: null,

	constructor: function(topLevelElement) {
		this.fTopLevelElement= topLevelElement;
		this.fId= "topLevelContainer_" + (topLevelElement != null ? topLevelElement.getIdentifier() : "null");
	},

	getIdentifier: function() {
		return this.fId;
	},

	getTopLevelElement: function() {
		return this.fTopLevelElement;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true,
		'com.ibm.team.apt.api.ui.structure.ITaskboardItemContainer': true
	}
});
var TaskboardViewConfiguration= dojo.declare("com.ibm.team.apt.shared.ui.internal.viewmodes.TaskboardViewMode.TaskboardViewConfiguration", BoardColumnsAndLimitsViewConfiguration, {

	//fParentLabel: null,

	constructor: function(config, factory) {
		this.inherited(arguments, [config, factory]);
		if (config.getParameter("showParent") == null || config.getParameter("showParent") === "true") {
			var parentColumnLabel= config.getParameter("parentColumnLabel");
			this.fParentLabel= parentColumnLabel != null ? parentColumnLabel : Messages.TaskboardViewMode_PARENT_COLUMN_LABEL;
		} else {
			this.fParentLabel= null;
		}
	},

	getParentLabel: function() {
		return this.fParentLabel;
	}
});

TaskboardViewMode.PARENT_COLUMN_WIDTH= 11.7;
TaskboardColumnProvider.PARENT_COLUMN_ID= "__parent_column";

})();
