/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.tests.internal.common.viewer.plan.board.BoardMoveHelperTest");

dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.common.UIItemHandle");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElement");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanModel");
dojo.require("com.ibm.team.apt.shared.client.internal.model.attributes.WorkflowInfoAttribute");
dojo.require("com.ibm.team.apt.web.client.internal.items.workitem.WorkflowAction");
dojo.require("com.ibm.team.apt.web.client.internal.items.workitem.WorkflowInfo");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.AbstractBoardCellGadget");
dojo.require("com.ibm.team.apt.web.ui.internal.common.viewer.plan.board.BoardMoveHelper");
dojo.require("com.ibm.team.apt.web.ui.tests.PlanningUnitTestCase");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockWorkflowState");
dojo.require("com.ibm.team.dev.jdojo.jsmock.JSMock");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.NativeDragHelper");

(function() {
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var IPlanItem= api.client.IPlanItem;
var UIItemHandle= api.common.UIItemHandle;
var model3= apt.shared.client.internal.model;
var PlanElement= model3.PlanElement;
var PlanModel= model3.PlanModel;
var WorkflowInfoAttribute= model3.attributes.WorkflowInfoAttribute;
var web= apt.web;
var workitem= web.client.internal.items.workitem;
var WorkflowAction= workitem.WorkflowAction;
var WorkflowInfo= workitem.WorkflowInfo;
var ui= web.ui;
var board= ui.internal.common.viewer.plan.board;
var AbstractBoardCellGadget= board.AbstractBoardCellGadget;
var BoardMoveHelper= board.BoardMoveHelper;
var tests= ui.tests;
var PlanningUnitTestCase= tests.PlanningUnitTestCase;
var MockWorkflowState= tests.mocks.MockWorkflowState;
var Builder= MockWorkflowState.Builder;
var jdojo= team.dev.jdojo;
var JSMock= jdojo.jsmock.JSMock;
var JSAssert= jdojo.junit.script.JSAssert;
var DragObject= team.rtc.foundation.web.ui.gadgets.table.NativeDragHelper.DragObject;

var BoardMoveHelperTest= dojo.declare("com.ibm.team.apt.web.ui.tests.internal.common.viewer.plan.board.BoardMoveHelperTest", PlanningUnitTestCase, {

	testGetWorkflowActionReturnsNullIfNoStates: function() {
		var contentStates= [];
		var legalStates= [];
		var stateActionMap= null;
		var draggedFromState= null;
		var gadget= this.aCellGadget(contentStates);
		var dragData= this.aDragData(this.aPlanElement.apply(this, legalStates), stateActionMap, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().getWorkFlowActionTest(gadget, dragObject);
		JSAssert.assertEquals(0, actual.length);
	},

	testGetWorkflowActionReturnsNullIfNoMatch: function() {
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s2= this.stateBuilder().label("s2").id("54").itemId("workflow1/54").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var stateActionMap= this.jsArray(this.aStateActionPair(s2, this.aWorkflowAction("a2")));
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s2), stateActionMap, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().getWorkFlowActionTest(gadget, dragObject);
		JSAssert.assertEquals(0, actual.length);
	},

	testGetWorkflowActionReturnsNullIfDroppedOnCurrentState: function() {
		var s1= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var draggedFromState= s1;
		var stateActionMap= this.jsArray();
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s1), stateActionMap, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().getWorkFlowActionTest(gadget, dragObject);
		JSAssert.assertEquals(1, actual.length);
		JSAssert.assertEquals(null, actual[0]);
	},

	testGetWorkflowActionMatchesDragObjectLegalActionToGadgetStates: function() {
		var expected= this.aWorkflowAction("a1");
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var stateActionMap= this.jsArray(this.aStateActionPair(s1, expected));
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s1), stateActionMap, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().getWorkFlowActionTest(gadget, dragObject);
		JSAssert.assertEquals(1, actual.length);
		JSAssert.assertEquals(expected, actual[0]);
	},

	testGetWorkflowActionMatchesDragObjectLegalActionToGadgetStatesWithDuplicateStateIds: function() {
		var expected= this.aWorkflowAction("a2");
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s2= this.stateBuilder().label("s2").id("53").itemId("workflow2/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var stateActionMap= this.jsArray(this.aStateActionPair(s2, expected));
		var gadget= this.aCellGadget(this.jsArray(s1, s2));
		var dragData= this.aDragData(this.aPlanElement(s2), stateActionMap, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().getWorkFlowActionTest(gadget, dragObject);
		JSAssert.assertEquals(1, actual.length);
		JSAssert.assertEquals(expected, actual[0]);
	},

	testDoesWorkflowContainStateReturnsFalseIfNoStates: function() {
		var gadgetStates= [];
		var elementStates= [];
		var draggedFromState= null;
		var gadget= this.aCellGadget(gadgetStates);
		var dragData= this.aDragData(this.aPlanElement.apply(this, elementStates), null, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().doesWorkflowContainStateTest(gadget, dragObject);
		JSAssert.assertFalse(actual);
	},

	testDoesWorkflowContainStateReturnsFalseIfNoMatch: function() {
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s2= this.stateBuilder().label("s2").id("54").itemId("workflow1/54").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s2), null, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().doesWorkflowContainStateTest(gadget, dragObject);
		JSAssert.assertFalse(actual);
	},

	testDoesWorkflowContainStateMatchesDragObjectWorkflowStatesToGadgetStates: function() {
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s1), null, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().doesWorkflowContainStateTest(gadget, dragObject);
		JSAssert.assertTrue(actual);
	},

	testDoesWorkflowContainStateReturnsFalseForDifferentStatesWithDuplicateIds: function() {
		var draggedFromState= this.stateBuilder().label("s0").id("52").itemId("workflow1/52").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s1= this.stateBuilder().label("s1").id("53").itemId("workflow1/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var s2= this.stateBuilder().label("s2").id("53").itemId("workflow2/53").stateGroup(BoardMoveHelperTest.OPEN_ID).build();
		var gadget= this.aCellGadget(this.jsArray(s1));
		var dragData= this.aDragData(this.aPlanElement(s2), null, draggedFromState);
		var dragObject= this.aDragObject(null, null, dragData);
		var actual= new BoardMoveHelperTestClass().doesWorkflowContainStateTest(gadget, dragObject);
		JSAssert.assertFalse(actual);
	},

	aCellGadget: function(states) {
		var gadget= JSMock.mock(AbstractBoardCellGadget);
		var $subject= states;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var state= $subject[$count];
			JSMock.doReturn(state).when(gadget).getState(state.getItemId());
		}
		JSMock.doReturn(states).when(gadget).getStates();
		return gadget;
	},

	aDragData: function(element, stateActionMap, currentState) {
		var map= {};
		map[BoardMoveHelper.DRAG_WORK_ITEM]= element;
		map[BoardMoveHelper.DRAG_WORK_ITEM_ACTIONS]= stateActionMap;
		map[BoardMoveHelper.DRAG_WORK_ITEM_STATE]= currentState;
		return map;
	},

	aDragObject: function(draggable, droppable, dragData) {
		var dragObject= JSMock.mock(DragObject);
		JSMock.doReturn(draggable).when(dragObject).getDragObject();
		JSMock.doReturn(droppable).when(dragObject).getDropObject();
		JSMock.doAnswer(function(invocationOnMock) {
			var id= invocationOnMock()[0];
			return dragData[id];
		}).when(dragObject).getData(com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
		return dragObject;
	},

	aPlanElement: function( /*, states... */ ) {
		var states= Array.prototype.slice.call(arguments, 0);
		var attr= this.aWorkflowInfoAttribute(states);
		var model= this.aPlanModel(attr);
		var element= JSMock.mock(PlanElement);
		JSMock.doReturn(model).when(element).getPlanModel();
		JSMock.doReturn(attr.getValue(element)).when(element).getAttributeValue(IPlanItem.WORKFLOW_INFO);
		return element;
	},

	aPlanModel: function(workflowInfoAttribute) {
		var model= JSMock.mock(PlanModel);
		JSMock.doReturn(workflowInfoAttribute).when(model).findAttribute(IPlanItem.WORKFLOW_INFO);
		return model;
	},

	aWorkflowAction: function(id) {
		var action= JSMock.mock(WorkflowAction);
		JSMock.doReturn(id).when(action).getId();
		return action;
	},

	aStateActionPair: function(state, action) {
		var map= {};
		map[BoardMoveHelper.DRAG_WORKFLOW_FINAL_STATE]= state;
		map[BoardMoveHelper.DRAG_WORKFLOW_ACTION]= action;
		return map;
	},

	aWorkflowInfoAttribute: function(states) {
		var stateHandles= this.getStateHandles(states);
		var workflowInfo= this.aWorkflowInfo(stateHandles);
		var attr= JSMock.mock(WorkflowInfoAttribute);
		JSMock.doReturn(workflowInfo).when(attr).getValue(com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
		JSMock.doAnswer(dojo.hitch(this, function(invocationOnMock) {
			var o= invocationOnMock()[0];
			var handle= o;
			return this.getFromHandle(handle, stateHandles, states);
		})).when(attr).getResolvedState(com.ibm.team.dev.jdojo.jsmock.JSMockMatchers.any());
		return attr;
	},

	aWorkflowInfo: function(stateHandles) {
		var info= JSMock.mock(WorkflowInfo);
		JSMock.doReturn(stateHandles).when(info).getStates();
		return info;
	},

	stateBuilder: function() {
		return Builder.create();
	},

	getStateHandles: function(states) {
		return dojo.map(states, function(element, index, array) {
			return UIItemHandle.stateHandleFor(element);
		});
	},

	getFromHandle: function(handle, handles, elements) {
		var idx= dojo.indexOf(handles, handle);
		return elements[idx];
	},

	jsArray: function( /*, elements... */ ) {
		var elements= Array.prototype.slice.call(arguments, 0);
		return elements;
	}
});
var BoardMoveHelperTestClass= dojo.declare("com.ibm.team.apt.web.ui.tests.internal.common.viewer.plan.board.BoardMoveHelperTest.BoardMoveHelperTestClass", BoardMoveHelper, {

	constructor: function() {
		this.inherited(arguments, []);
	},

	getWorkFlowActionTest: function(gadget, data) {
		return BoardMoveHelper.getWorkFlowAction(gadget, data);
	},

	doesWorkflowContainStateTest: function(gadget, data) {
		return BoardMoveHelper.doesWorkflowContainState(gadget, data);
	}
});

BoardMoveHelperTest.OPEN_ID= MockWorkflowState.OPEN_STATES;

})();
