/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.tests.model.attributes.DefaultAttributeValueComparatorTest");

dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.common.planning.PlanningAttributeType");
dojo.require("com.ibm.team.apt.shared.client.internal.duration.Instant");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElement");
dojo.require("com.ibm.team.apt.shared.client.internal.model.attributes.DefaultAttributeValueComparator");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockAttribute");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockAttributeDescription");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockContributor");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockEnumerationElement");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockIteration");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockPlanModel");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockTimeline");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockWorkflowState");
dojo.require("com.ibm.team.apt.web.ui.tests.mocks.MockWorkitemType");
dojo.require("com.ibm.team.dev.jdojo.jsmock.JSMock");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSAssert");
dojo.require("com.ibm.team.dev.jdojo.junit.script.JSTestCase");

(function() {
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var IPlanItem= api.client.IPlanItem;
var PlanningAttributeType= api.common.planning.PlanningAttributeType;
var internal= apt.shared.client.internal;
var Instant= internal.duration.Instant;
var model3= internal.model;
var PlanElement= model3.PlanElement;
var DefaultAttributeValueComparator= model3.attributes.DefaultAttributeValueComparator;
var mocks= apt.web.ui.tests.mocks;
var MockAttribute= mocks.MockAttribute;
var MockAttributeDescription= mocks.MockAttributeDescription;
var MockContributor= mocks.MockContributor;
var MockEnumerationElement= mocks.MockEnumerationElement;
var MockIteration= mocks.MockIteration;
var MockPlanModel= mocks.MockPlanModel;
var Builder= MockPlanModel.Builder;
var MockTimeline= mocks.MockTimeline;
var MockWorkflowState= mocks.MockWorkflowState;
var MockWorkitemType= mocks.MockWorkitemType;
var jdojo= team.dev.jdojo;
var JSMock= jdojo.jsmock.JSMock;
var script= jdojo.junit.script;
var JSAssert= script.JSAssert;
var JSTestCase= script.JSTestCase;

dojo.declare("com.ibm.team.apt.web.ui.tests.model.attributes.DefaultAttributeValueComparatorTest", JSTestCase, {

	//fModel: null,

	//fState1: null,

	//fState2: null,

	//fType1: null,

	//fType2: null,

	//fIteration1: null,

	//fIteration2: null,

	//fEnum1: null,

	//fEnum2: null,

	//fContributor1: null,

	//fContributor2: null,

	setUp: function() {
		this.inherited("setUp", arguments, []);
		this.fModel= new MockPlanModel([new MockAttribute(IPlanItem.COMPLEXITY.getId()), new MockAttribute(IPlanItem.WORKFLOW_STATE.getId()), new MockAttribute(IPlanItem.ITEM_TYPE.getId()), new MockAttribute(IPlanItem.TARGET.getId()), new MockAttribute(IPlanItem.OWNER.getId())]);
		this.fState1= this.aState("New", 0);
		this.fState2= this.aState("New", 1);
		this.fType1= this.aType("Story");
		this.fType2= this.aType("Story");
		this.fIteration1= this.anIteration("Release 1.0");
		this.fIteration2= this.anIteration("Release 1.0");
		this.fEnum1= this.anEnum("priority.literal.l4", "High", 3);
		this.fEnum2= this.anEnum("priority.literal.l3", "Medium", 2);
		this.fContributor1= this.aContributor("Auser", "Auser");
		this.fContributor2= this.aContributor("Buser", "Buser");
	},

	testTwoContributorsWithDifferentNameIsBasedOnNameAndReturnMinusOneIfFirstElementIsLexicographicallySmaller: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var contributorAttribute= this.fModel.findAttribute(IPlanItem.OWNER);
		contributorAttribute.setDescription(new MockAttributeDescription(IPlanItem.OWNER.getId(), mockAttributeParams, PlanningAttributeType.ITEM));
		JSMock.doReturn(this.fContributor1).when(contributorAttribute).getValue(element1);
		JSMock.doReturn(this.fContributor2).when(contributorAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(contributorAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithSameStateIsBasedOnIdAndNotLabelAndReturnsZero: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var workflowStateAttribute= this.fModel.findAttribute(IPlanItem.WORKFLOW_STATE);
		workflowStateAttribute.setDescription(new MockAttributeDescription(IPlanItem.WORKFLOW_STATE.getId(), mockAttributeParams, PlanningAttributeType.WORKFLOW_STATE));
		JSMock.doReturn(this.fState1).when(workflowStateAttribute).getValue(element1);
		JSMock.doReturn(this.fState1).when(workflowStateAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(workflowStateAttribute);
		JSAssert.assertEquals(0, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentStateIsBasedOnIdAndNotLabelAndReturnsMinusOneIfSecondElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var model= Builder.create().referenceTime(Instant.currentTime()).build();
		var mockAttributeParams= {};
		var workflowStateAttribute= model.findAttribute(IPlanItem.WORKFLOW_STATE);
		JSMock.doReturn(this.fState1).when(workflowStateAttribute).getValue(element1);
		JSMock.doReturn(this.fState2).when(workflowStateAttribute).getValue(element2);
		workflowStateAttribute.setDescription(new MockAttributeDescription(IPlanItem.WORKFLOW_STATE.getId(), mockAttributeParams, PlanningAttributeType.WORKFLOW_STATE));
		var comparator= DefaultAttributeValueComparator.createComparator(workflowStateAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentStateIsBasedOnIdAndNotLabelAndReturnsOneIfFirstElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var model= Builder.create().referenceTime(Instant.currentTime()).build();
		var mockAttributeParams= {};
		var workflowStateAttribute= model.findAttribute(IPlanItem.WORKFLOW_STATE);
		JSMock.doReturn(this.fState2).when(workflowStateAttribute).getValue(element1);
		JSMock.doReturn(this.fState1).when(workflowStateAttribute).getValue(element2);
		workflowStateAttribute.setDescription(new MockAttributeDescription(IPlanItem.WORKFLOW_STATE.getId(), mockAttributeParams, PlanningAttributeType.WORKFLOW_STATE));
		var comparator= DefaultAttributeValueComparator.createComparator(workflowStateAttribute);
		JSAssert.assertEquals(1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithSameTypeIsBasedOnIdAndNotLabelAndReturnsZero: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var workitemTypeAttribute= this.fModel.findAttribute(IPlanItem.ITEM_TYPE);
		workitemTypeAttribute.setDescription(new MockAttributeDescription(IPlanItem.ITEM_TYPE.getId(), mockAttributeParams, PlanningAttributeType.WORKITEM_TYPE));
		JSMock.doReturn(this.fType1).when(workitemTypeAttribute).getValue(element1);
		JSMock.doReturn(this.fType1).when(workitemTypeAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(workitemTypeAttribute);
		JSAssert.assertEquals(0, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentTypeIsBasedOnIdAndNotLabelAndReturnsMinusOneIfSecondElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var workitemTypeAttribute= this.fModel.findAttribute(IPlanItem.ITEM_TYPE);
		workitemTypeAttribute.setDescription(new MockAttributeDescription(IPlanItem.ITEM_TYPE.getId(), mockAttributeParams, PlanningAttributeType.WORKITEM_TYPE));
		JSMock.doReturn(this.fType1).when(workitemTypeAttribute).getValue(element1);
		JSMock.doReturn(this.fType2).when(workitemTypeAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(workitemTypeAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentTypeIsBasedOnIdAndNotLabelAndReturnsOneIfFirstElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var workitemTypeAttribute= this.fModel.findAttribute(IPlanItem.ITEM_TYPE);
		workitemTypeAttribute.setDescription(new MockAttributeDescription(IPlanItem.ITEM_TYPE.getId(), mockAttributeParams, PlanningAttributeType.WORKITEM_TYPE));
		JSMock.doReturn(this.fType2).when(workitemTypeAttribute).getValue(element1);
		JSMock.doReturn(this.fType1).when(workitemTypeAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(workitemTypeAttribute);
		JSAssert.assertEquals(1, comparator.compareTo(element1, element2));
	},

	testTwoItemsPlannedForSameIterationIsBasedOnIdAndNotLabelAndReturnsZero: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var iterationAttribute= this.fModel.findAttribute(IPlanItem.TARGET);
		iterationAttribute.setDescription(new MockAttributeDescription(IPlanItem.TARGET.getId(), mockAttributeParams, PlanningAttributeType.ITEM));
		JSMock.doReturn(this.fIteration1).when(iterationAttribute).getValue(element1);
		JSMock.doReturn(this.fIteration1).when(iterationAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(iterationAttribute);
		JSAssert.assertEquals(0, comparator.compareTo(element1, element2));
	},

	testTwoItemsPlannedForDifferentIterationsIsBasedOnIdAndNotLabelAndReturnsMinusOneIfSecondElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var iterationAttribute= this.fModel.findAttribute(IPlanItem.TARGET);
		iterationAttribute.setDescription(new MockAttributeDescription(IPlanItem.TARGET.getId(), mockAttributeParams, PlanningAttributeType.ITEM));
		JSMock.doReturn(this.fIteration1).when(iterationAttribute).getValue(element1);
		JSMock.doReturn(this.fIteration2).when(iterationAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(iterationAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	testTwoItemsPlannedForDifferentIterationsIsBasedOnIdAndNotLabelAndReturnsOneIfFirstElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var iterationAttribute= this.fModel.findAttribute(IPlanItem.TARGET);
		iterationAttribute.setDescription(new MockAttributeDescription(IPlanItem.TARGET.getId(), mockAttributeParams, PlanningAttributeType.ITEM));
		JSMock.doReturn(this.fIteration2).when(iterationAttribute).getValue(element1);
		JSMock.doReturn(this.fIteration1).when(iterationAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(iterationAttribute);
		JSAssert.assertEquals(1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentEnumerationsReturnsOneIfFirstElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var complexityAttribute= this.fModel.findAttribute(IPlanItem.COMPLEXITY);
		complexityAttribute.setDescription(new MockAttributeDescription(IPlanItem.COMPLEXITY.getId(), mockAttributeParams, PlanningAttributeType.ENUMERATION));
		JSMock.doReturn(this.fEnum1).when(complexityAttribute).getValue(element1);
		JSMock.doReturn(this.fEnum2).when(complexityAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(complexityAttribute);
		JSAssert.assertEquals(1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentEnumerationsReturnsMinusOneIfSecondElementIsHigher: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var complexityAttribute= this.fModel.findAttribute(IPlanItem.COMPLEXITY);
		complexityAttribute.setDescription(new MockAttributeDescription(IPlanItem.COMPLEXITY.getId(), mockAttributeParams, PlanningAttributeType.ENUMERATION));
		JSMock.doReturn(this.fEnum2).when(complexityAttribute).getValue(element1);
		JSMock.doReturn(this.fEnum1).when(complexityAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(complexityAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentEnumerationsReturnsOneIfSecondElementIsNullValue: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var complexityAttribute= this.fModel.findAttribute(IPlanItem.COMPLEXITY);
		complexityAttribute.setDescription(new MockAttributeDescription(IPlanItem.COMPLEXITY.getId(), mockAttributeParams, PlanningAttributeType.ENUMERATION));
		JSMock.doReturn(this.fEnum1).when(complexityAttribute).getValue(element1);
		JSMock.doReturn(null).when(complexityAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(complexityAttribute);
		JSAssert.assertEquals(1, comparator.compareTo(element1, element2));
	},

	testTwoItemsWithDifferentEnumerationsReturnsMinusOneIfFirstElementIsNullValue: function() {
		var element1= this.aPlanElement();
		var element2= this.aPlanElement();
		var mockAttributeParams= {};
		var complexityAttribute= this.fModel.findAttribute(IPlanItem.COMPLEXITY);
		complexityAttribute.setDescription(new MockAttributeDescription(IPlanItem.COMPLEXITY.getId(), mockAttributeParams, PlanningAttributeType.ENUMERATION));
		JSMock.doReturn(null).when(complexityAttribute).getValue(element1);
		JSMock.doReturn(this.fEnum2).when(complexityAttribute).getValue(element2);
		var comparator= DefaultAttributeValueComparator.createComparator(complexityAttribute);
		JSAssert.assertEquals(-1, comparator.compareTo(element1, element2));
	},

	aPlanElement: function() {
		return JSMock.mock(PlanElement);
	},

	aState: function(label, id) {
		return new MockWorkflowState(label, id);
	},

	aType: function(type) {
		return new MockWorkitemType(type);
	},

	anIteration: function(label) {
		return new MockIteration(new MockTimeline("main"), null, label);
	},

	anEnum: function(literalId, label, sequenceValue) {
		return new MockEnumerationElement(literalId, label, sequenceValue);
	},

	aContributor: function(label, name) {
		var mContributor= new MockContributor(label);
		mContributor.setName(name);
		return mContributor;
	}
});

})();
