/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gadgets.table.AbstractGadgetHolderTableElement"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.ErrorGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.factories.EmptyGadgetFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.AbstractTableElement"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var lang= com.ibm.jdojo.lang;
var Exception= lang.Exception;
var JavaScriptException= lang.JavaScriptException;
var jdojo= lang.Runtime;
var gadgets= com.ibm.team.rtc.foundation.web.ui.gadgets;
var ErrorGadget= gadgets.ErrorGadget;
var EmptyGadgetFactory= gadgets.factories.EmptyGadgetFactory;
var AbstractTableElement= gadgets.table.AbstractTableElement;
var _Widget= dijit._Widget;

/**
 * A TableElement class used for generically managing IHTMLGadgets
 */
var AbstractGadgetHolderTableElement= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gadgets.table.AbstractGadgetHolderTableElement", AbstractTableElement, { //$NON-NLS-1$

	/**
	 * The factory to be used for creating the content
	 */
	//fHTMLGadgetFactory: null,

	/**
	 * The content which should be displayed in the element
	 */
	//fHTMLGadget: null,

	/**
	 * A container which all of the element's functionality is contained inside
	 * of
	 */
	//fElementContentContainer: null,

	/**
	 * A container which wraps the IHTMLGadget's content
	 */
	//fGadgetContentContainer: null,

	/**
	 * A basic constructor for a table element which can contain an IHTMLGadget
	 * 
	 * @param identifier
	 *            The locally unique identifier for the the table element
	 * @param table
	 *            The table for which the current element belongs to
	 */
	constructor: function(identifier, table) {
		this.inherited(arguments, [identifier, table]);
	},

	/**
	 * Creates the container which contains all of the current element's
	 * contents
	 * 
	 * @return The container which contains all of the current element's
	 *         contents
	 */
	getContainerElement: function() {
		this.fElementContentContainer= dojo.create("span", {className: AbstractGadgetHolderTableElement.CONTAINER_CLASS_NAME}); //$NON-NLS-1$
		this.fGadgetContentContainer= dojo.create("span", {className: AbstractGadgetHolderTableElement.CONTENT_CONTAINER_CLASS_NAME}, this.fElementContentContainer); //$NON-NLS-1$
		try {
			this.fGadgetContentContainer.appendChild(this.getGadget().getHTMLElement());
		} catch (t) {
			if ((t= t instanceof Exception ? t : new JavaScriptException(t)) instanceof Exception) {
				this.fGadgetContentContainer.appendChild(new ErrorGadget().getHTMLElement());
				console.error(t);
			} else {
				throw t;
			}
		}
		return this.fElementContentContainer;
	},

	/**
	 * Gets the container which contains all of the current element's contents
	 * 
	 * @return The container which contains all of the current element's
	 *         contents
	 */
	getCellContainer: function() {
		return this.fElementContentContainer;
	},

	/**
	 * Gets the container which contains all of the gadget's contents
	 * 
	 * @return The container which contains all of the gadget's contents
	 */
	getContentContainer: function() {
		return this.fGadgetContentContainer;
	},

	/**
	 * Gets the current gadget factory attached to the element
	 * 
	 * @return The current factory attached to the element
	 */
	getGadgetFactory: function() {
		return this.fHTMLGadgetFactory;
	},

	/**
	 * Sets the gadget factory and refreshes the element
	 * 
	 * @param contentFactory
	 *            The new factory to use for creating the gadget content
	 */
	setGadgetFactory: function(contentFactory) {
		this.destroyGadgetAndFactory();
		this.fHTMLGadgetFactory= contentFactory;
		this.refreshGadget();
	},

	/**
	 * Gets the current gadget. If none exists, creates a new one.
	 * 
	 * <b>Note:<b> This forces the creation of the gadget.
	 * 
	 * @return The current gadget
	 */
	getGadget: function() {
		if (this.fHTMLGadgetFactory == null) {
			this.fHTMLGadgetFactory= new EmptyGadgetFactory();
		}
		if (this.fHTMLGadget == null) {
			this.fHTMLGadget= this.fHTMLGadgetFactory.createGadget();
			this.fHTMLGadget.setParent(this);
		}
		return this.fHTMLGadget;
	},

	setGadget: function(gadget) {
		this.fHTMLGadget= gadget;
	},

	/**
	 * Destroys both the gadget and the gadget factory, but keeps the dom
	 * elements
	 */
	destroyGadgetAndFactory: function() {
		if (this.fHTMLGadgetFactory != null && jdojo.implementsInterface(this.fHTMLGadgetFactory, "com.ibm.team.rtc.foundation.web.IDestroyable")) {
			this.fHTMLGadgetFactory.destroy();
		}
		if (this.fHTMLGadget != null && this.fHTMLGadget instanceof _Widget) {
			this.fHTMLGadget.destroyRecursive(true);
		} else if (this.fHTMLGadget != null && jdojo.implementsInterface(this.fHTMLGadget, "com.ibm.team.rtc.foundation.web.IDestroyable")) {
			this.fHTMLGadget.destroy();
		}
		this.fHTMLGadgetFactory= null;
		this.fHTMLGadget= null;
	},

	destroy: function() {
		this.destroyGadgetAndFactory();
	}
});

AbstractGadgetHolderTableElement.CONTAINER_CLASS_NAME= "element-content-container"; //$NON-NLS-1$
AbstractGadgetHolderTableElement.CONTENT_CONTAINER_CLASS_NAME= "gadget-content-container"; //$NON-NLS-1$

})();
