/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gadgets.table.Table"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.factories.EmptyGadgetFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.AbstractTableElement"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.OrderedMap"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableGroupHeader"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableHeaderRow"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TablePaintingHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.TableRow"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var gadgets= com.ibm.team.rtc.foundation.web.ui.gadgets;
var EmptyGadgetFactory= gadgets.factories.EmptyGadgetFactory;
var table3= gadgets.table;
var AbstractTableElement= table3.AbstractTableElement;
var OrderedMap= table3.OrderedMap;
var TableCell= table3.TableCell;
var TableColumn= table3.TableColumn;
var TableGroupHeader= table3.TableGroupHeader;
var TableHeaderRow= table3.TableHeaderRow;
var TableHelper= table3.TableHelper;
var TablePaintingHelper= table3.TablePaintingHelper;
var TableRow= table3.TableRow;
var string= dojo.string;

/**
 * The Table class is the class which is used for creating a table which is
 * filled with IHTMLGadgets.
 * 
 * The suggested way to create a table is to:
 * 1) Add the column structure you need. Table.addColumn
 * 2) Add the row structure you need. Table.addRow
 * 3) Get each cell you would like to edit them accordingly. Table.getCell
 */
var Table= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gadgets.table.Table", AbstractTableElement, { //$NON-NLS-1$

	/**
	 * Contains a map of all columns by their identifier.
	 */
	//fAllColumnsByIdentifier: null,

	/**
	 * Contains an ordered map of all header rows by their identifier.
	 */
	//fAllHeaderRowsByIndex: null,

	/**
	 * Contains an ordered map of all rows by their identifier.
	 */
	//fAllRowsByIndex: null,

	/**
	 * Contains the table group header.
	 */
	//fTableGroupHeader: null,

	/**
	 * Contains a class which links tables together.
	 */
	//fLinkedTables: null,

	/**
	 * A boolean which determines if updates are currently allowed on the table.
	 */
	//fAreUpdatesAllowed: null,

	/**
	 * The default factory to use for all newly created TableCell.
	 */
	//fDefaultCellGadgetFactory: null,

	/**
	 * Contains a class which helps with element painting and refreshing.
	 */
	//fTablePaintingHelper: null,

	/**
	 * Contains a list of tables which are grouped below this one
	 */
	//fDependentTables: null,

	/**
	 * The dependency depth of this table. Value is 0 if the table
	 * is not grouped below other tables.
	 */
	//fDepth: null,

	/**
	 * A basic constructor.
	 * 
	 * @param identifier
	 *            The identifier to use for the table.
	 */
	constructor: function(identifier) {
		this.inherited(arguments, [identifier, null]);
		this.fDepth= 0;
		this.fAllColumnsByIdentifier= {};
		this.fAllHeaderRowsByIndex= new OrderedMap();
		this.fAllRowsByIndex= new OrderedMap();
		this.fTablePaintingHelper= new TablePaintingHelper();
		this.fAreUpdatesAllowed= true;
		this.fDefaultCellGadgetFactory= new EmptyGadgetFactory();
		this.fDependentTables= [];
		this.addClass(Table.TABLE_CLASS_NAME);
	},

	/**
	 * Tracks the given table as a group nested below this table
	 * @param child
	 * 			The table grouped below this one
	 */
	addDependentTable: function(child) {
		child.setDepth(this.fDepth + 1);
		this.fDependentTables.push(child);
	},

	/**
	 * Determines if the table should be updating its dom.
	 * 
	 * @param areUpdatesAllowed
	 *            True allows the table to update its dom, false does not.
	 */
	allowUpdates: function(areUpdatesAllowed) {
		this.fAreUpdatesAllowed= areUpdatesAllowed;
		if (this.fAreUpdatesAllowed) {
			this.fTablePaintingHelper.performUpdate(this.getTable());
		}
	},

	createRootElement: function() {
		return dojo.create("table", {className: this.getClasses()}); //$NON-NLS-1$
	},

	performRefresh: function() {
		this.emptyRootElement();
		if (this.fTableGroupHeader != null) {
			this.paintHeader();
		}
		var $subject= this.fAllHeaderRowsByIndex.getValueArray();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var headerRow= $subject[$count];
			this.fRootElement.appendChild(headerRow.getHTMLElement());
		}
		var $subject2= this.fAllRowsByIndex.getValueArray();
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var row= $subject2[$count2];
			this.fRootElement.appendChild(row.getHTMLElement());
		}
	},

	addToRefreshQueue: function() {
		this.getTable().fTablePaintingHelper.addTableRefresh(this);
	},

	/**
	 * A function which is used for creating a new Table.
	 * 
	 * <b>Note:</b> Meant to help with extending this class.
	 * 
	 * @param identifier
	 *            The identifier of the new Table.
	 * @return The new Table.
	 */
	createTable: function(identifier) {
		return new Table(identifier);
	},

	/**
	 * A function which is used for creating a new TableHeaderRow.
	 * 
	 * <b>Note:</b> Meant to help with extending this class.
	 * 
	 * @param identifier
	 *            The identifier of the new TableHeaderRow.
	 * @param table
	 *            The Table to attach the TableHeaderRow to.
	 * @return The new TableHeaderRow.
	 */
	createHeaderRow: function(identifier, table) {
		return new TableHeaderRow(identifier, table);
	},

	/**
	 * A function which is used for creating a new TableColumn.
	 * 
	 * <b>Note:</b> Meant to help with extending this class.
	 * 
	 * @param identifier
	 *            The identifier of the new TableColumn.
	 * @param headerRow
	 *            The TableHeaderRow which the column belongs to.
	 * @param parentColumn
	 *            The parent column, null means column is a root column.
	 * @param columnHeaderContentFactory
	 *            The factory to use for the content of this column header or
	 *            <code>null</code> to create no content in the header element.
	 * @param position
	 *            The position of this column relative to its parent's children
	 *            (If root column, then relative to the other root columns).
	 *            Null means to insert the column at the end.
	 * @return The new TableColumn.
	 */
	createColumn: function(identifier, headerRow, parentColumn, columnHeaderContentFactory, position) {
		return new TableColumn(identifier, headerRow, parentColumn, columnHeaderContentFactory);
	},

	/**
	 * A function which is used for creating a new TableRow.
	 * 
	 * <b>Note:</b> Meant to help with extending this class.
	 * 
	 * @param identifier
	 *            The identifier of the new TableRow.
	 * @param table
	 *            The Table to attach the TableRow to.
	 * @param position
	 *            Where in the order this row belongs. Null means to insert the
	 *            row at the end.
	 * @return The new TableRow.
	 */
	createRow: function(identifier, table, position) {
		return new TableRow(identifier, table);
	},

	/**
	 * A function which is used for creating a new TableCell.
	 * 
	 * <b>Note:</b> Meant to help with extending this class.
	 * 
	 * @param identifier
	 *            The identifier of the new TableCell.
	 * @param row
	 *            The farthest up TableRow the TableCell belongs to.
	 * @param column
	 *            The farthest "left" (Right in RTL) TableColumn the TableCell
	 *            belongs to.
	 * @param contentFactory
	 *            The factory to use for the contents of this cell. Null uses
	 *            the default factory.
	 * @return A new TableCell.
	 */
	createCell: function(identifier, row, column, contentFactory) {
		return new TableCell(identifier, row, column, contentFactory == null ? this.fDefaultCellGadgetFactory : contentFactory);
	},

	/**
	 * Sets the default factory to use for all TableCell.
	 * 
	 * @param contentFactory
	 *            The default factory to use for all TableCell.
	 */
	setDefaultCellFactory: function(contentFactory) {
		this.fDefaultCellGadgetFactory= contentFactory;
	},

	/**
	 * Creates a new TableHeaderRow and inserts it into the table.
	 * 
	 * @param identifier
	 *            The identifier of the new TableHeaderRow.
	 * @return The new TableHeaderRow, null on error.
	 */
	_addHeaderRow: function(identifier) {
		if (identifier == null) {
			identifier= TableHelper.generateHeaderRowIdentifer(this);
		}
		if (this.fAllHeaderRowsByIndex.getElementByIdentifier(identifier) != null) {
			console.error(string.substitute(Table.Table_ERROR_HEADER_ROW_IDENTIFIER_CONFLICT, [identifier ]));
		} else {
			var headerRow= this.createHeaderRow(identifier, this);
			TableHelper.addHeaderRow(headerRow);
			return headerRow;
		}
		return null;
	},

	/**
	 * Creates a new TableColumn and inserts it into the table.
	 * 
	 * @param identifier
	 *            The identifier of the new TableColumn.
	 * @param parentColumn
	 *            The parent column, null means column is a root column.
	 * @param columnHeaderContentFactory
	 *            The factory to use for the content of this column header or
	 *            <code>null</code> to create no content in the header element.
	 * @param position
	 *            The position of this column relative to its parent's children
	 *            (If root column, then relative to the other root columns).
	 *            Null means to insert the column at the end.
	 * @return A new TableColumn, null on error.
	 */
	_addColumn: function(identifier, parentColumn, columnHeaderContentFactory, position) {
		if (parentColumn != null && parentColumn.getTable() !== this) {
			console.error(string.substitute(Table.Table_ERROR_TABLE_DOES_NOT_MATCH, [parentColumn.getTable().getIdentifier() , this.getIdentifier()]));
		} else if (parentColumn != null && this.fAllColumnsByIdentifier[parentColumn.getIdentifier()] !== parentColumn) {
			console.error(string.substitute(Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_PARENT_COLUMN, [parentColumn.getIdentifier() , this.getIdentifier()]));
		} else {
			if (identifier == null) {
				identifier= TableHelper.generateColumnIdentifier(this);
			}
			if (this.fAllColumnsByIdentifier[identifier] != null) {
				console.error(string.substitute(Table.Table_ERROR_COLUMN_IDENTIFIER_CONFLICT, [identifier ]));
			} else {
				var headerRow= TableHelper.getHeaderRowOrGenerate(this, parentColumn == null ? 0 : parentColumn.getColumnDepth() + 1);
				var column= this.createColumn(identifier, headerRow, parentColumn, columnHeaderContentFactory, position);
				TableHelper.addColumn(column, position);
				if (this.fTableGroupHeader != null) {
					this.fTableGroupHeader.setColumnSpan(this.getColumnCount(null));
				}
				return column;
			}
		}
		return null;
	},

	/**
	 * Creates a new TableColumn and inserts it into the table.
	 * 
	 * @param identifier
	 *            The identifier of the new TableColumn.
	 * @param parentColumn
	 *            The parent column, null means column is a root column.
	 * @param columnHeaderContentFactory
	 *            The factory to use for the content of this column header or
	 *            <code>null</code> to create no content in the header element.
	 * @param position
	 *            The position of this column relative to its parent's children
	 *            (If root column, then relative to the other root columns) or
	 *            <code>null</code> to insert the column at the end.
	 * @return A new TableColumn, null on error.
	 */
	addColumn: function(identifier, parentColumn, columnHeaderContentFactory, position) {
		return this._addColumn(identifier, parentColumn, columnHeaderContentFactory, position);
	},

	/**
	 * Creates a new TableRow and inserts it into the table.
	 * 
	 * @param identifier
	 *            The identifier of the new TableRow.
	 * @param position
	 *            Where in the order this row belongs. Null means to insert the
	 *            row at the end.
	 * @return The new TableRow, null on error.
	 */
	_addRow: function(identifier, position) {
		if (identifier == null) {
			identifier= TableHelper.generateRowIdentifier(this);
		}
		if (this.fAllRowsByIndex.getElementByIdentifier(identifier) != null) {
			console.error(string.substitute(Table.Table_ERROR_ROW_IDENTIFIER_CONFLICT, [identifier ]));
		} else {
			var row= this.createRow(identifier, this, position);
			TableHelper.addRow(row, position);
			return row;
		}
		return null;
	},

	/**
	 * Creates a new TableRow and inserts it into the table.
	 * 
	 * @param identifier
	 *            The identifier of the new TableRow.
	 * @param position
	 *            Where in the order this row belongs. Null means to insert the
	 *            row at the end.
	 * @return The new TableRow, null on error.
	 */
	addRow: function(identifier, position) {
		return this._addRow(identifier, position);
	},

	/**
	 * Gets a specific cell in the Table
	 * 
	 * @param row
	 *            The row the cell belongs to
	 * @param column
	 *            The column the cell belongs to
	 * @return Gets the TableCell, null on error
	 */
	_getCell: function(row, column) {
		if (this.getRow(row.getIdentifier()) !== row) {
			console.error(string.substitute(Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_ROW, [row.getIdentifier() , this.getIdentifier()]));
		} else if (this.getColumn(column.getIdentifier()) !== column) {
			console.error(string.substitute(Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_COLUMN, [column.getIdentifier() , this.getIdentifier()]));
		} else {
			column= TableHelper.getChildlessDescendant(column);
			var cell= row.getCellByColumn(column);
			if (cell == null) {
				cell= this.createCell(null, row, column, null);
				TableHelper.addCell(cell);
			}
			return cell;
		}
		return null;
	},

	/**
	 * Gets a specific cell in the Table
	 * 
	 * @param row
	 *            The row the cell belongs to
	 * @param column
	 *            The column the cell belongs to
	 * @return Gets the TableCell, null on error
	 */
	getCell: function(row, column) {
		return this._getCell(row, column);
	},

	/**
	 * @return the tables grouped below this one
	 */
	getDependentTables: function() {
		return this.fDependentTables;
	},

	/**
	 * @return the nested group depth of this table
	 */
	getDepth: function() {
		return this.fDepth;
	},

	/**
	 * Gets a header row based upon its index
	 * 
	 * @param index
	 *            The index of the header row to find
	 * @return The header row at that index, Undefined.VALUE() if none exists
	 */
	getHeaderRow: function(index) {
		return this.fAllHeaderRowsByIndex.getElementByIndex(index);
	},

	/**
	 * Gets a row by its identifier
	 * 
	 * @param identifier
	 *            The identifier of the row to retrieve
	 * @return Undefined.VALUE() if no row is found, otherwise the TableRow that
	 *         matches the identifier
	 */
	getRow: function(identifier) {
		return this.fAllRowsByIndex.getElementByIdentifier(identifier);
	},

	/**
	 * Gets the total number of rows in the table
	 * 
	 * @return The total number of rows in the table
	 */
	getRowCount: function() {
		return this.fAllRowsByIndex.getSize();
	},

	/**
	 * Gets an array of all table rows in order
	 * 
	 * @return An array of all table rows in order
	 */
	getRows: function() {
		return this.fAllRowsByIndex.getValueArray();
	},

	/**
	 * Gets a column by its identifier
	 * 
	 * @param identifier
	 *            The identifier of the column to retrieve
	 * @return Undefined.VALUE() if no found column, otherwise the TableColumn
	 *         that matches the identifier
	 */
	getColumn: function(identifier) {
		return this.fAllColumnsByIdentifier[identifier];
	},

	/**
	 * Gets the total number of columns in a header row
	 * 
	 * @param headerRowIndex
	 *            Which column row to retrieve from, null retrieves from last
	 *            row
	 * @return The total number of columns in a header row, -1 on error
	 */
	getColumnCount: function(headerRowIndex) {
		if (this.fAllHeaderRowsByIndex.getSize() < 1) {
			return 0;
		} else if (headerRowIndex == null) {
			return this.fAllHeaderRowsByIndex.getElementByIndex(this.fAllHeaderRowsByIndex.getSize() - 1).getColumns().length;
		} else if (0 <= headerRowIndex && headerRowIndex < this.fAllHeaderRowsByIndex.getSize()) {
			return this.fAllHeaderRowsByIndex.getElementByIndex(headerRowIndex).getColumns().length;
		} else {
			console.error(string.substitute(Table.Table_ERROR_INDEX_OUT_OF_RANGE, [headerRowIndex , this.fAllHeaderRowsByIndex.getSize()]));
			return -1;
		}
	},

	/**
	 * Gets a list of the final columns
	 * 
	 * @return Null if no columns exist, otherwise an array of all the columns
	 *         on the last row in order
	 */
	getLastColumns: function() {
		return this.getColumns(null);
	},

	/**
	 * Gets an entire row of columns
	 * 
	 * @param headerRowIndex
	 *            Which column row to retrieve from, null retrieves from last
	 *            row
	 * @return null if row does not exist, otherwise column array of all columns
	 *         in the row in order
	 */
	getColumns: function(headerRowIndex) {
		if (this.fAllHeaderRowsByIndex.getSize() < 1) {
			return null;
		} else if (headerRowIndex == null) {
			return this.fAllHeaderRowsByIndex.getElementByIndex(this.fAllHeaderRowsByIndex.getSize() - 1).getColumns();
		} else if (headerRowIndex < this.fAllHeaderRowsByIndex.getSize()) {
			return this.fAllHeaderRowsByIndex.getElementByIndex(headerRowIndex).getColumns();
		} else {
			console.error(string.substitute(Table.Table_ERROR_INDEX_OUT_OF_RANGE, [headerRowIndex , this.fAllHeaderRowsByIndex.getSize()]));
			return null;
		}
	},

	/**
	 * Gets the number of header rows which are added
	 * 
	 * @return The header row count
	 */
	getHeaderRowCount: function() {
		return this.fAllHeaderRowsByIndex.getSize();
	},

	/**
	 * Paints the fTableGroupHeader to fRootElement at its first child position
	 */
	paintHeader: function() {
		if (this.fRootElement != null) {
			if (this.fRootElement.childNodes.length === 0) {
				this.fRootElement.appendChild(this.fTableGroupHeader.getHTMLElement());
			} else {
				this.fRootElement.insertBefore(this.fTableGroupHeader.getHTMLElement(), this.fRootElement.firstChild);
			}
		}
	},

	/**
	 * Gets the current header to the table
	 * 
	 * <b>Note:<b> This forces the creation of the gadget.
	 * 
	 * @return The current header gadget
	 */
	getGroupHeader: function() {
		if (this.fTableGroupHeader == null) {
			return null;
		}
		return this.fTableGroupHeader.getGadget();
	},

	/**
	 * Sets the content of the label
	 * 
	 * @param headerFactory
	 *            The factory used to create the content of the label
	 * @return 
	 */
	setGroupHeaderFactory: function(headerFactory) {
		if (this.fTableGroupHeader == null) {
			this.fTableGroupHeader= new TableGroupHeader(this.getIdentifier(), this, headerFactory);
			this.paintHeader();
		} else {
			this.fTableGroupHeader.setGadgetFactory(headerFactory);
		}
		return this.fTableGroupHeader;
	},

	getLinker: function() {
		return this.fLinkedTables;
	},

	getTable: function() {
		return this;
	},

	/**
	 * Sets the nested group depth of this table
	 * @param depth
	 */
	setDepth: function(depth) {
		this.fDepth= depth;
	},

	/**
	 * Gets a list of all tables which are linked to the current one
	 * 
	 * @return A list of all tables which are linked to the current one
	 */
	getLinkedTables: function() {
		if (this.fLinkedTables != null) {
			return this.fLinkedTables.getTables();
		} else {
			return null;
		}
	},

	/**
	 * Sets whether to completely hide this table or not.
	 * Hides both the board table and the group header.
	 * @param isHidden
	 * 			Whether to hide or become visible
	 */
	setIsHidden: function(isHidden) {
		this.toggleClass(Table.HIDDEN_CLASS, isHidden);
		var $subject3= this.fDependentTables;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var child= $subject3[$count3];
			child.setIsHidden(isHidden);
		}
	},

	/**
	 * Stops tracking the given table as a group nested below this table
	 * @param child
	 * 			The table to stop tracking
	 */
	removeDependentTable: function(child) {
		var idx= dojo.indexOf(this.fDependentTables, child);
		this.fDependentTables.splice(idx, 1);
	},

	destroy: function() {
		if (this.fTableGroupHeader != null) {
			this.fTableGroupHeader.destroy();
		}
		var $subject4= this.fAllHeaderRowsByIndex.getValueArray();
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var headerRow= $subject4[$count4];
			headerRow.destroy();
		}
		var $subject5= this.fAllRowsByIndex.getValueArray();
		var $length5= $subject5.length;
		for (var $count5= 0; $count5 < $length5; $count5++){
			var row= $subject5[$count5];
			row.destroy();
		}
	}
});

Table.Table_ERROR_HEADER_ROW_IDENTIFIER_CONFLICT= "Header Row Identifier <${0}> is already in use."; //$NON-NLS-1$
Table.Table_ERROR_COLUMN_IDENTIFIER_CONFLICT= "Column Identifier <${0}> is already in use."; //$NON-NLS-1$
Table.Table_ERROR_ROW_IDENTIFIER_CONFLICT= "Row Identifier <${0}> is already in use."; //$NON-NLS-1$
Table.Table_ERROR_TABLE_DOES_NOT_MATCH= "Table <${0}> does not match current Table <${1}>"; //$NON-NLS-1$
Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_PARENT_COLUMN= "Parent Column <${0}> is not contained in Table <${1}>"; //$NON-NLS-1$
Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_ROW= "Row <${0}> is not located in the Table <${1}>."; //$NON-NLS-1$
Table.Table_ERROR_TABLE_DOES_NOT_CONTAIN_COLUMN= "Column <${0} is not located in the Table <${1}>."; //$NON-NLS-1$
Table.Table_ERROR_INDEX_OUT_OF_RANGE= "Header Row Index <${0}> is out of range <${1}>."; //$NON-NLS-1$
Table.TABLE_CLASS_NAME= "com-ibm-team-rtc-foundation-web-ui-gadgets-table-Table"; //$NON-NLS-1$
Table.HIDDEN_CLASS= "hidden"; //$NON-NLS-1$

})();
